//****************************************************************************
//
// Process the "ADC" instruction 
//
// V=Sm & Dm & (~Rm) | (~Sm) & (~Dm) & (Rm)
//
//****************************************************************************
void ProcessADC_C_69(  void )
{
        word  address;
        byte  zpage;

        _d1=_A;
        if ((_F&_C)!=0) _d1++;

        _d1+=GETABYTE(); 
        Cycles=2; 

        // do flags
        _F&=(_I+_D);                                                            // clear carry as well
        if ((_d1&0x100)!=0) _F|=_C;
        _A=_d1&255;
        if ((_A & 128)==128) {_F|=_N;}
        if (_A==0) {_F|=_Z;}
}
//------------------------------------------------------------------
void ProcessADC_C_65(  void )
{
        word  address;
        byte  zpage;

        _d1=_A;
        if ((_F&_C)!=0) _d1++;
        
        zpage=GETABYTE(); 
        _d1+=Peek(zpage);        
        Cycles=3; 

        // do flags
        _F&=(_I+_D);                                                            // clear carry as well
        if ((_d1&0x100)!=0) _F|=_C;
        _A=_d1&255;
        if ((_A & 128)==128) {_F|=_N;}
        if (_A==0) {_F|=_Z;}
}

//------------------------------------------------------------------
void ProcessADC_C_75(  void )
{
        word  address;
        byte  zpage;

        _d1=_A;
        if ((_F&_C)!=0) _d1++;


        zpage=GETABYTE(); 
        _d1+=Peek((zpage+_X)&255);     
        Cycles=4; 


        // do flags
        _F&=(_I+_D);                                                            // clear carry as well
        if ((_d1&0x100)!=0) _F|=_C;
        _A=_d1&255;
        if ((_A & 128)==128) {_F|=_N;}
        if (_A==0) {_F|=_Z;}
}

//------------------------------------------------------------------
void ProcessADC_C_6D(  void )
{
        word  address;
        byte  zpage;

        _d1=_A;
        if ((_F&_C)!=0) _d1++;

        address=GETAWORD(); 
        _d1+=Peek(address);    
        Cycles=4; 

        // do flags
        _F&=(_I+_D);                                                            // clear carry as well
        if ((_d1&0x100)!=0) _F|=_C;
        _A=_d1&255;
        if ((_A & 128)==128) {_F|=_N;}
        if (_A==0) {_F|=_Z;}
}

//------------------------------------------------------------------
void ProcessADC_C_7D(  void )
{
        word  address;
        byte  zpage;

        _d1=_A;
        if ((_F&_C)!=0) _d1++;

        address=GETAWORD(); 
        _d1+=Peek(address+_X); 
        Cycles=4; 

        // do flags
        _F&=(_I+_D);                                                            // clear carry as well
        if ((_d1&0x100)!=0) _F|=_C;
        _A=_d1&255;
        if ((_A & 128)==128) {_F|=_N;}
        if (_A==0) {_F|=_Z;}
}

//------------------------------------------------------------------
void ProcessADC_C_79(  void )
{
        word  address;
        byte  zpage;

        _d1=_A;
        if ((_F&_C)!=0) _d1++;

        address=GETAWORD(); 
        _d1+=Peek(address+_Y); 
        Cycles=4; 

        // do flags
        _F&=(_I+_D);                                                            // clear carry as well
        if ((_d1&0x100)!=0) _F|=_C;
        _A=_d1&255;
        if ((_A & 128)==128) {_F|=_N;}
        if (_A==0) {_F|=_Z;}
}

//------------------------------------------------------------------
void ProcessADC_C_61(  void )
{
        word  address;
        byte  zpage;

        _d1=_A;
        if ((_F&_C)!=0) _d1++;

        zpage=GETABYTE(); 
        address=Deek( (zpage+_X) &255); 
        _d1+=Peek(address);    
        Cycles=6;

        // do flags
        _F&=(_I+_D);                                                            // clear carry as well
        if ((_d1&0x100)!=0) _F|=_C;
        _A=_d1&255;
        if ((_A & 128)==128) {_F|=_N;}
        if (_A==0) {_F|=_Z;}
}

//------------------------------------------------------------------
void ProcessADC_C_71(  void )
{
        word  address;
        byte  zpage;

        _d1=_A;
        if ((_F&_C)!=0) _d1++;

        zpage=GETABYTE(); 
        address=Deek(zpage);    
        _d1+=Peek(address+_Y); 
        Cycles=5; 

        // do flags
        _F&=(_I+_D);                                                            // clear carry as well
        if ((_d1&0x100)!=0) _F|=_C;
        _A=_d1&255;
        if ((_A & 128)==128) {_F|=_N;}
        if (_A==0) {_F|=_Z;}
}

//------------------------------------------------------------------
uint16 AddDecimal ( uint16 d1, uint8 a)
{
        uint16  d,c,ans;

                d=d1&0xf;               // get first digit
                d+=(a&0xf);
                if (d>9) {
                        ans=d-10;
                        c=1;
                }else {
                        c=0;    // get half carry
                        ans=d;
                }
                d=(d1&0xf0)>>4;         // get first digit
                d+=(a&0xf0)>>4;
                d+=c;                                           // add half carry
                if (d>9){
                        ans+=((d-10)<<4)+0x100;
                } else {
                        ans+=(d<<4);
                }
        return  ans;
}

//------------------------------------------------------------------
void ProcessADC_C(  void )
{
register        uint16  _d1;
register        uint16  __F;
        word    address,a,d,c,ans;
        byte    zpage;
        uint16  data;
        int     test;
        
        __F=_F;
        _d1=0;  //_A;
        //if ((__F&_C)!=0) _d1++;
        switch (opcode) {
                case 0x69       :  _d1+=(data=GETABYTE()); Cycles=2; break;
           case 0x65    :       zpage=GETABYTE(); _d1+=(data=Peek(zpage));        Cycles=3; break;
           case 0x75    :       zpage=GETABYTE(); _d1+=(data=Peek((zpage+_X)&255));     Cycles=4; break;
           case 0x6D    :       address=GETAWORD(); _d1+=(data=Peek(address));    Cycles=4; break;
           case 0x7D    :       {
                                                                address=GETAWORD(); 
                                                                a=address&0xff00;
                                                                _d1+=(data=Peek(address+_X)); 
                                                                if (((address+_X)&0xff00)!=a){
                                                                        Cycles=5;                                               //page cross+1
                                                                }else {
                                                                        Cycles=4; 
                                                                }
                                                                break; 
                                                        }
           case 0x79    :       {       
                                                                address=GETAWORD(); 
                                                                a=address&0xff00;
                                                                _d1+=(data=Peek(address+_Y)); 
                                                                if (((address+_Y)&0xff00)!=a){
                                                                        Cycles=5;                                               //page cross+1
                                                                }else {
                                                                        Cycles=4; 
                                                                }
                                                                break; 
                                                        }
           case 0x61    :       zpage=GETABYTE(); address=Deek((zpage+_X)&255); _d1+=(data=Peek(address));    Cycles=6; break; 
           case 0x71    :       {
                                                                zpage=GETABYTE(); 
                                                                address=Deek(zpage); 
                                                                a=address&0xff00;                                       // need to check for page boundary
                                                                _d1+=(data=Peek(address+_Y));
                                                                if (((address+_Y)&0xff00)!=a){
                                                                        Cycles=6;                                                       //page cross+1
                                                                }else{
                                                                        Cycles=5; 
                                                                }
                                                                break; 
                                                        }
        }

        test=(signed char)_d1+(signed char)_A;
        
        // do actual ADD!
        if ((_F&_D)!=0){                // decimal mode?
                if ((__F&_C)!=0) c=1; else c=0;         _d1=AddDecimal(_d1,c);  // add carry to decimal number
                if ((_d1&0x100)!=0) c=1; else c=0;
                _d1&=0xff;
                _d1=AddDecimal(_d1,_A); // add carry to decimal number
                if (c==1) _d1|=0x100;
        } else {
                _d1+=_A;
                if ((__F&_C)!=0) _d1++;
        }

//        printf("\n%d %d %x %x :  %d",_d1,_A,_d1,_A,test);
        
        if ((__F&_C)!=0) test++;


        // do flags
        __F&=(_I+_D);                                                           // clear carry as well
        if ((_d1&0x100)!=0)__F|=_C;

//        test=test+128;

//        if (test==(test&255)) {
        if ((test<=127) && (test>=-128)) {
        } else {
            __F|=_V;
        }



//        if ((((_A&0x80)==0) && ((_d1&0x80)==0x80)) ||
//            (((_A&0x80)==0x80) && ((_d1&0x180)==0x100))) __F|=_V;
        _A=_d1&255;
        if ((_A & 128)==128) {__F|=_N;}
        if (_A==0) {__F|=_Z;}
        _F=__F;
}
