//****************************************************************************
//
// Process the "STY" instruction 
//
// SAY    ***
// This opcode ANDs the contents of the Y register with <ab+1> and stores the 
// result in memory.
//
// One supported mode:
//
// SAY abcd,X      ;9C cd ab    ;No. Cycles= 5
//
// Example:
//
// SAY $7700,X     ;9C 00 77
//
// Equivalent instructions:
//
// PHA
// TYA
// AND #$78
// STA $7700,X
// PLA
//
//****************************************************************************
void ProcessSAY_C_9C( void )
{
	word  address;
	byte  temp;

	Cycles=5; 
	address=GETAWORD();
	temp=_Y&(((address>>8)+1)&0xff);
	Poke (address+_X,temp);
}
