//****************************************************************************
//
// Process the "AND" instruction 
//
//   XAA    ***
//   XAA transfers the contents of the X register to the A register and then 
//   ANDs the A register with an immediate value.
//
//   One supported mode:
//
//   XAA #ab         ;8B ab       ;No. Cycles= 2
//
//   Example:
//
//   XAA #$44        ;8B 44
//
//   Equivalent instructions:
//
//   TXA
//   AND #$44
//
//****************************************************************************

void ProcessXAA_C_8B( void )
{
	_A=_X&GETABYTE(); 
	Cycles=2;
	DOCOMP (_A);
}

