//****************************************************************************
//
//
//        The Minus4 project - Copyright (c) Mike Dailly 1996,7
//
//
// This source and the Minus4 project remains the copyright of Mike Dailly, 
// but can be freely used and changed for NON-Commercial purposes. 
//
//								 Keep emulators free!
//
// Remember if you add or change anything, you MUST send a copy
// complete with source to me at mike@scotch.demon.co.uk
// If its just a bug fix, then just send the changed file, with a comment
// telling me WHERE you fixed and WHAT you fixed.
//
// 
//										  DISASM.C
//                                      
//					  The file contains the 6502 emulation
//
// Version  By   Date     Description
//
// v1.00    MD 08/04/95	  All Instructions emulated in high level
// V1.2	   MD 28/07/96	  Perhaps I should have kept up this list...
//                        I'll try in future.          		 
//                                 		 
//****************************************************************************
#include "headers\md.h"
#include "headers\all.h"
#include "headers\screen.h"
#include "headers\draw.h"
#include "headers\6502.h"
#include "headers\6502asm.h"

#define	  	IMM	0	
#define	  	ABS	1	
#define	  	ZPG	2	
#define	  	IMP	3	
#define	  	I_X	4	
#define	  	I_Y	5	
#define	  	Z_X	6	
#define	  	A_X	7	
#define	  	A_Y	8	
#define	  	REL	9	
#define	  	IND	10	
#define	  	Z_Y	11	
#define	  	DONE	12	

#define		OPCODE_MODE	      0x0000000f
#define		NOLOCATION	      0x00000010		// don't fill in a loction value
#define		NOLOCATIONVALUE	0x00000020		// don't fill in a PEEK of location value

#include	"symbols.c"

extern	char	*pSourceFile;


extern	unsigned char		_A;
extern	unsigned char		_X;
extern	unsigned char		_Y;
extern	unsigned char		_F;
extern	uint8					_SP;
extern	uint32	 			_PC;  
extern	uint32	*MemoryReadTable;
extern   uint8    ROM;                 
extern	uint8		RomIndex;

uint8 GETABYTE( void );
#pragma aux GETABYTE =					\
		"mov	ecx,_PC"						\
		"mov  al,cl"						\
		"shl	ecx,2"	   				\
		"and  al,3"							\
		"add	ecx,MemoryReadTable"		\
		"mov	ecx,[ecx]"					\
		"or	cl,al"						\
		"inc	_PC"							\
		"mov	cl,[ecx]"					\
		modify [ecx al]					\
	   value [cl]

		int32	StartSrcPC=0x0;
		char	TextLine[1024];
		int32	Tabs[11]={1,16,21,0,0,0,0,0,0,0,0};		// start at 16..


typedef struct	 {
			unsigned char		b;
			char					s[4];
			uint32				flags;
} tTable;

	//
	// 6502 code to decompress program (including LOAD address)
	//
	uint8	unpackcode[0x12A]={
      0x01,0x10,0x12,0x10,0xCE,0x07,0x9E,0x34,0x31,0x31,0x37,0x20,0x4D,0x49,0x4E,0x55,
      0x53,0x34,0x00,0x00,0x00,0x00,0x78,0x8D,0x3F,0xFF,0xA2,0x2F,0xBD,0x26,0x10,0x95,
      0xC0,0xCA,0x10,0xF8,0x4C,0xC0,0x00,0xA0,0x00,0x84,0xFD,0xA9,0x01,0x85,0xFE,0xA9,
      0x55,0x85,0xFB,0xA9,0x10,0x85,0xFC,0xB1,0xFB,0x91,0xFD,0xE6,0xFB,0xD0,0x02,0xE6,
      0xFC,0xE6,0xFD,0xD0,0x02,0xE6,0xFE,0xA5,0xFB,0xC9,0x2A,0xD0,0xEA,0xA5,0xFC,0xC9,
      0x11,0xD0,0xE4,0x4C,0x00,0x01,0x78,0xA9,0xFA,0x85,0xFD,0xA9,0x00,0x85,0xFE,0x18,
      0xAD,0xD5,0x01,0x8D,0xD2,0x01,0x69,0xD5,0x85,0xFB,0xAD,0xD4,0x01,0x8D,0xD3,0x01,
      0x69,0x01,0x85,0xFC,0xA0,0x00,0xB1,0xFB,0xC9,0x80,0x90,0x03,0xE9,0x80,0xC8,0x85,
      0xFF,0x38,0xA5,0xFD,0xE5,0xFF,0x85,0xFD,0xA5,0xFE,0xE9,0x00,0x85,0xFE,0xC0,0x01,
      0xF0,0x1E,0x38,0xA5,0xFB,0xE9,0x02,0x85,0xFB,0xA5,0xFC,0xE9,0x00,0x85,0xFC,0xC8,
      0xB1,0xFB,0xA4,0xFF,0x91,0xFD,0x88,0x10,0xFB,0xA9,0x01,0x85,0xFF,0x4C,0x7F,0x01,
      0x18,0xA5,0xFB,0xE5,0xFF,0x85,0xFB,0xA5,0xFC,0xE9,0x00,0x85,0xFC,0xA4,0xFF,0xB1,
      0xFB,0x91,0xFD,0x88,0x10,0xF9,0xE6,0xFF,0x38,0xA5,0xFB,0xE9,0x01,0x85,0xFB,0xA5,
      0xFC,0xE9,0x00,0x85,0xFC,0x38,0xA5,0xFD,0xE9,0x01,0x85,0xFD,0xA5,0xFE,0xE9,0x00,
      0x85,0xFE,0x18,0xAD,0xD2,0x01,0xE5,0xFF,0x8D,0xD2,0x01,0xAD,0xD3,0x01,0xE9,0x00,
      0x8D,0xD3,0x01,0x0D,0xD2,0x01,0xF0,0x03,0x4C,0x1E,0x01,0xA6,0xFD,0x9A,0x68,0x8D,
      0xD1,0x01,0x68,0x8D,0xD0,0x01,0x68,0xAA,0x9D,0xD0,0xFD,0x68,0xAA,0x9D,0x3E,0xFF,
      0x68,0x85,0xFF,0x68,0x85,0xFE,0x68,0x85,0xFD,0x68,0x85,0xFC,0x68,0x85,0xFB,0x68,
      0xAA,0x68,0xA8,0x68,0x28,0x4C,0xCF,0x01,0x00,0x00
   };

		// compresion buffer
		uint8	Buffer[100000];		// 0xeffe usable
      uint8	*pBuffer;

		//
		// Opcodes left: 0b 1e 2b 6b 93 9b 9e 9f bb
		//
  			
          	tTable Dtable[] = { 
		0x69,"ADC",IMM,	0x6d,"ADC",ABS,	0x65,"ADC",ZPG,	0x61,"ADC",I_X,
		0x71,"ADC",I_Y,	0x75,"ADC",Z_X,	0x7d,"ADC",A_X,	0x79,"ADC",A_Y,

		0x29,"AND",IMM,	0x2d,"AND",ABS,	0x25,"AND",ZPG,	0x21,"AND",I_X,
		0x31,"AND",I_Y,	0x35,"AND",Z_X,	0x3D,"AND",A_X,	0x39,"AND",A_Y,

		0x0e,"ASL",ABS,	0x06,"ASL",ZPG,	0x0a,"ASL",IMP,	0x16,"ASL",Z_X,

		0x90,"BCC",REL,
		0xb0,"BCS",REL,
		0xF0,"BEQ",REL,

		0x2c,"BIT",ABS,	0x24,"BIT",ZPG,

		0x30,"BMI",REL,
		0xd0,"BNE",REL,
		0x10,"BPL",REL,

		0x00,"BRK",IMP,

		0x50,"BVC",REL,
		0x70,"BVS",REL,

		0x18,"CLC",IMP,
		0xd8,"CLD",IMP,
		0x58,"CLI",IMP,
		0xb8,"CLV",IMP,

		0xc9,"CMP",IMM,	0xcd,"CMP",ABS,	0xc5,"CMP",ZPG,	0xc1,"CMP",I_X,
		0xd1,"CMP",I_Y,	0xd5,"CMP",Z_X,	0xdd,"CMP",A_X,	0xD9,"CMP",A_Y,

		0xe0,"CPX",IMM,	0xec,"CPX",ABS,	0xe4,"CPX",ZPG,
		0xc0,"CPY",IMM,	0xcc,"CPY",ABS,	0xc4,"CPY",ZPG,

		0xce,"DEC",ABS,	0xc6,"DEC",ZPG,	0xd6,"DEC",Z_X,	0xde,"DEC",A_X,
		0xca,"DEX",IMP,
		0x88,"DEY",IMP,

		0x49,"EOR",IMM,	0x4D,"EOR",ABS,	0x45,"EOR",ZPG,	0x41,"EOR",I_X,
		0x51,"EOR",I_Y,	0x55,"EOR",Z_X,	0x5D,"EOR",A_X,	0x59,"EOR",A_Y,

		0xEE,"INC",ABS,	0xE6,"INC",ZPG,	0xF6,"INC",Z_X,	0xFE,"INC",A_X,
		0xE8,"INX",IMP,
		0xC8,"INY",IMP,

		0x4C,"JMP",ABS|NOLOCATIONVALUE,   0x6C,"JMP",IND|NOLOCATIONVALUE,
		0x20,"JSR",ABS|NOLOCATIONVALUE,

		0xA9,"LDA",IMM,	0xAD,"LDA",ABS,	0xA5,"LDA",ZPG,	0xA1,"LDA",I_X,
		0xB1,"LDA",I_Y,	0xB5,"LDA",Z_X,	0xBD,"LDA",A_X,	0xB9,"LDA",A_Y,

		0xA2,"LDX",IMM,	0xAE,"LDX",ABS,	0xA6,"LDX",ZPG,
		0xBE,"LDX",A_Y,	0xB6,"LDX",Z_Y,

		0xA0,"LDY",IMM,	0xAC,"LDY",ABS,	0xA4,"LDY",ZPG,
		0xB4,"LDY",Z_X,	0xBC,"LDY",A_X,

		0x4E,"LSR",ABS,	0x46,"LSR",ZPG,	0x4A,"LSR",IMP,
		0x56,"LSR",Z_X,	0x5E,"LSR",A_X,

		0xEA,"NOP",IMP,

		0x09,"ORA",IMM,	0x0D,"ORA",ABS,	0x05,"ORA",ZPG,	0x01,"ORA",I_X,
		0x11,"ORA",I_Y,	0x15,"ORA",Z_X,	0x1D,"ORA",A_X,	0x19,"ORA",A_Y,

		0x48,"PHA",IMP,
		0x08,"PHP",IMP,
		0x68,"PLA",IMP,
		0x28,"PLP",IMP,

		0x2E,"ROL",ABS,	0x26,"ROL",ZPG,	0x2A,"ROL",IMP,
		0x36,"ROL",Z_X,	0x3E,"ROL",A_X,

		0x6E,"ROR",ABS,	0x66,"ROR",ZPG,	0x6A,"ROR",IMP,
		0x76,"ROR",Z_X,	0x7E,"ROR",A_X,

		0x40,"RTI",IMP,
		0x60,"RTS",IMP,

		0xE9,"SBC",IMM,	0xED,"SBC",ABS,	0xE5,"SBC",ZPG,	0xE1,"SBC",I_X,
		0xF1,"SBC",I_Y,	0xF5,"SBC",Z_X,	0xFD,"ORA",A_X,	0xF9,"SBC",A_Y,
		0xEB,"SBC",IMM,	// NOT a normal SBC opcode

		0x38,"SEC",IMP,
		0xF8,"SED",IMP,
		0x78,"SEI",IMP,

		0x8D,"STA",ABS,	0x85,"STA",ZPG,	0x81,"STA",I_X,	0x91,"STA",I_Y,
		0x95,"STA",Z_X,	0x9D,"STA",A_X,	0x99,"STA",A_Y,

		0x8E,"STX",ABS,	0x86,"STX",ZPG,	0x96,"STX",Z_Y,
		0x8C,"STY",ABS,	0x84,"STY",ZPG,	0x94,"STY",Z_X,

		0xAA,"TAX",IMP,
		0xA8,"TAY",IMP,
		0xBA,"TSX",IMP,
		0x8A,"TXA",IMP,
		0x9A,"TXS",IMP,
		0x98,"TYA",IMP,


// EXTRA OPCODES HERE!!


		0xEF,"INS",ABS,	0xE7,"INS",ZPG,	0xE3,"INS",I_X,	0xF3,"INS",I_Y,
		0xF7,"INS",Z_X,	0xFF,"INS",A_X,	0xFB,"INS",A_Y,

		0x8F,"AXS",ABS,	0x87,"AXS",ZPG,	0x97,"AXS",Z_Y,	0x83,"AXS",I_X,

		0x0F,"ASO",ABS,	0x07,"ASO",ZPG,	0x03,"ASO",I_X,	0x13,"ASO",I_Y,
		0x17,"ASO",Z_X,	0x1F,"ASO",A_X,	0x1B,"ASO",A_Y,

		0xCF,"DCM",ABS,	0xC7,"DCM",ZPG,	0xC3,"DCM",I_X,	0xD3,"DCM",I_Y,
		0xD7,"DCM",Z_X,	0xDF,"DCM",A_X,	0xDB,"DCM",A_Y,

		0xAF,"LAX",ABS,	0xA7,"LAX",ZPG,	0xA3,"LAX",I_X,	0xb3,"LAX",I_Y,
		0xB7,"LAX",Z_X,	0xBF,"LAX",A_Y,


		0x1A,"NOP",IMP,	0x3A,"NOP",IMP,	0x5A,"NOP",IMP,	0x7A,"NOP",IMP,
		0xDA,"NOP",IMP,	0xFA,"NOP",IMP,
		
		0xAB,"OAL",IMM,
		0x4B,"ALR",IMM,
		0xCB,"SAX",IMM,

		// Skip NEXT byte?!?!
		0x80,"SKB",ZPG,	0x82,"SKB",ZPG,	0xC2,"SKB",ZPG,	0xE2,"SKB",ZPG,
		0x04,"SKB",ZPG,	0x14,"SKB",ZPG,	0x34,"SKB",ZPG,	0x44,"SKB",ZPG,
		0x54,"SKB",ZPG,	0x64,"SKB",ZPG,	0x74,"SKB",ZPG,	0xD4,"SKB",ZPG,
		0xF4,"SKB",ZPG,	0x89,"SKB",ZPG,

		// Skip next word!
		0x0C,"SKW",ABS,	0x1C,"SKW",ABS,	0x3C,"SKW",ABS,	0x5C,"SKW",ABS,
		0x7C,"SKW",ABS,	0xDC,"SKW",ABS,	0xFC,"SKW",ABS,


		0x4F,"LSE",ABS,	0x47,"LSE",ZPG,	0x57,"LSE",Z_X,
		0x5F,"LSE",A_X,	0x5B,"LSE",A_Y,	0x43,"LSE",I_X,	0x53,"LSE",I_Y,


		0x6F,"RRA",ABS,	0x7F,"RRA",A_X,	0x7B,"RRA",A_Y,
		0x67,"RRA",ZPG,	0x77,"RRA",Z_X,	0x63,"RRA",I_X,	0x73,"RRA",I_Y,

		0x2f,"RLA",ABS,	0x3f,"RLA",A_X,	0x3b,"RLA",A_Y,
		0x27,"RLA",ZPG,	0x37,"RLA",Z_X,	0x23,"RLA",I_X,	0x33,"RLA",I_Y,

		0x02,"HLT",IMP,	0x12,"HLT",IMP,	0x22,"HLT",IMP,	0x32,"HLT",IMP,
		0x42,"HLT",IMP,	0x52,"HLT",IMP,	0x62,"HLT",IMP,	0x72,"HLT",IMP,
		0x92,"HLT",IMP,	0xB2,"HLT",IMP,	0xD2,"HLT",IMP,	0xF2,"HLT",IMP,

		0x9c,"SAY",A_X,
		0x8B,"XAA",IMM,

		0xff,"???",DONE};


		uint8				CallTable[65536];
		int32				RangeLow,RangeHigh;
		uint32			CallBranchAddress;
		uint32			Address_SWAP;

		uint8				opcode;
		uint32			debug=0;
		char				disline[256];
		char				_OPCODE[16];
		unsigned char	MODE;
		char				ModeLine[40];
		char				_Hex[40];
		int				adder;
		uint32			*RoutineMap;
		uint32			*DataMap;

		uint8				TextColour=7;
		uint32		   Location;
		uint32		   LocationValue;
		int32				SymbolTable=1;			// Look up addresses in symbol table?
		char				*pSymbol;

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void ClearCallTable( void )
{
	int	i;

	for (i=0;i<65536;i++){
		CallTable[i]=0;
	}
}
//****************************************************************************
//
// Display Registers
//
//****************************************************************************
void PrintLineC ( int x,int y, char *s )
{
	char	*Scr;

	Scr=(char *)0xb8000+(x*2)+(y*160);
	while (*s!=0x0){
		if (s[0]!='\n') { *Scr=*s++; } else {s++;}
		Scr+=2;
	}
}

void SetTextCol(uint8 Col)
{
	TextColour=(TextColour&0xf0)|Col;
}
void SetBackCol(uint8 Col)
{
	TextColour=(TextColour&0xf)|Col;
}
void SetPrintCol(uint8 Col)
{
	TextColour=Col;
}


//****************************************************************************
//
// Define Opcode DIS-Table
//
//****************************************************************************
void	SearchOpcode (unsigned char opcode)
{
	int	i,done;

	done=0;
	i=0;
	while (done==0) {
		if ((opcode==Dtable[i].b) || ((Dtable[i].flags&OPCODE_MODE)==DONE)) {
			done=1;
			strcpy (_OPCODE,Dtable[i].s);
			MODE=(Dtable[i].flags);
		}
		i++;
	}

}

void GetSymbol(int32 i)
{
   tSymbolTable	*pSym;

	pSymbol=NULL;
	pSym=&Symbols[0];
	while(pSym->value!=0xffffffff){
		if (pSym->value==i){
       	pSymbol=&(pSym->Name[0]);
			return;
		}
		pSym++;
	}
}

//****************************************************************************
//
// Define Opcode DIS-Table
//
//****************************************************************************
void GetModeLine( unsigned char MODE )
{
	char sb[128];
	char sw[17];
	char	b;
	unsigned short w,pc3;
	uint16	bb,i;

   pc3=_PC;
   w=GetWord();
   _PC=pc3;
   b=GetByte();
   strcpy (sb,"$00");
   strcpy (sw,"$0000");

	if ((opcode==0x20) OR (opcode==0x4c)) {	//OR (opcode==0x6c)){
		if ((w>=RangeLow) AND (w<=RangeHigh)) CallTable[w]=1;
		CallBranchAddress=w;
	}

	if (SymbolTable==1){
	
	   if (((MODE&OPCODE_MODE) !=IMM) AND
	       ((MODE&OPCODE_MODE) !=REL)){
				
				GetSymbol(w);
				if (pSymbol!=NULL){
		   		strcpy(&sw,pSymbol);
				}else{
				   Hex (&sw[1], w, 4);
				}
				GetSymbol(b);
				if (pSymbol!=NULL){
		   		strcpy(&sb,pSymbol);
				}else{
				   Hex (&sb[1], b, 2);
				}
		} else {
		   Hex (&sw[1], w, 4);
	      Hex (&sb[1], b, 2);
		}
	}else{
		Hex (&sw[1], w, 4);
	   Hex (&sb[1], b, 2);
	}


	switch (MODE&OPCODE_MODE) {
		case	IMM	:		adder=2; sprintf (ModeLine,"#%s",sb);	break;
		case	ABS	:		adder=3; sprintf (ModeLine,"%s",sw);	LocationValue=Peek(w); break;
		case	ZPG	:		adder=2; sprintf (ModeLine,"%s",sb);	LocationValue=Peek(b); break;
		case	IMP	:		adder=1; sprintf (ModeLine," ");			break;
		case	I_X	:		adder=2; sprintf (ModeLine,"(%s,x)",sb);	bb=b; Location=Deek((bb+_X)&255); LocationValue=Peek(Location); break;
		case	I_Y	:		adder=2; sprintf (ModeLine,"(%s),y",sb);	Location=Deek(b)+_Y; LocationValue=Peek(Location); break;
		case	Z_X	:		adder=2; sprintf (ModeLine,"%s,x",sb);	LocationValue=Peek(b+_X); break;
		case	A_X	:		adder=3; sprintf (ModeLine,"%s,x",sw);	LocationValue=Peek(w+_X); break;
		case	A_Y	:		adder=3; sprintf (ModeLine,"%s,y",sw);   LocationValue=Peek(w+_Y); break;
		case	REL	:		{
									adder=2; 
									if (b>127) {
										b=-b;
										_PC-=b;
									} else {
										_PC+=(int) b;
									}
									CallBranchAddress=_PC;
									if ((_PC>=RangeLow) AND (_PC<=RangeHigh)) CallTable[_PC]=1;
									Hex (&sw[1], _PC, 4);
									sprintf (ModeLine,"%s",sw); 	break;
								};
		case	IND	:		adder=3; sprintf (ModeLine,"(%s)",sw);	Location=Deek(w); break;
		case	Z_Y	:		adder=2; sprintf (ModeLine,"%s,y",sb);	LocationValue=Peek(b+_Y); break;
	}
}


//****************************************************************************
//
// Define Opcode DIS-Table
//
//****************************************************************************
void Disassemble( unsigned short PC_address )
{
	unsigned short 	PC2;  
	unsigned char		bData;
	unsigned short		wData;
	char					s1[80];

	Location=0xffffffff;
	LocationValue=0xffffffff;
	CallBranchAddress=0xffffffff;
	PC2=_PC;
	strcpy(s1,"0000");
	strcpy(disline,"");
	strcpy(_OPCODE,"");
	strcpy(ModeLine,"");

	_PC=PC_address;
	opcode=GETABYTE();
	Hex (&s1, PC_address, 4);
	SearchOpcode(opcode);
	GetModeLine(MODE);
	sprintf (disline,"%s   %s   %s",s1,_OPCODE,ModeLine);
	_PC=PC2;

	if (MODE&NOLOCATION)	Location=0xffffffff;
	if (MODE&NOLOCATIONVALUE)	LocationValue=0xffffffff;
}




//************************************************************
//                                                           *
//   Name    : Pack                                          *
//   Function: This is a VERY simple byte run packer.        *
//             It packs from the STACK pointer to $10100     *
//             or, up to $ffff and round to zero page        *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

#define	NEXTBYTE(off)	Memory[((Addr-off)&0xffff)]
#define	RUN	1
#define	COPY	0
#define	ENDADDR	0x100fb

void Pack( char *pName )
{
	int32	Addr,EndAddr,handle;
	int32	index=99999,count;
	uint8	*pBuff,*pBuff2;
	uint8	a,b,c,cop;
	uint8	Mode,done;
	int32	FileSize=0;
	uint8	sp;


	sp=_SP;
	PushReg (_F);							// push flags last! (so we can get 'em before carrying on)
	PushReg (_A);							
	PushReg (_X);							
	PushReg (_Y);							
	PushReg (Memory[0xfb]);
	PushReg (Memory[0xfc]);
	PushReg (Memory[0xfd]);
	PushReg (Memory[0xfe]);
	PushReg (Memory[0xff]);
	PushReg (ROM^1);						// ROM IN=1, ROM OUT=0 (we want reverse!)
	PushReg (RomIndex);					// store which ROM we want to use

	PushReg (_PC&0xff);
	PushReg ((_PC&0xff00)>>8);

	EndAddr=(_SP+0x100);					// END address
   Addr=0xfa;

	pBuff=&Buffer[99999];				// write BACKWARDS!

	done=0;
	while (done==0){

		// First find out what we want NEXT
	   a=NEXTBYTE(0);
	   b=NEXTBYTE(1);
	   c=NEXTBYTE(2);
	   if ((a==b) AND (b==c)) Mode=RUN; else Mode=COPY;
		
		if (Mode==RUN){		
			cop=a;
			count=0;
			while ((cop==NEXTBYTE(0)) AND (count<128) AND (Addr!=EndAddr)){
				Addr--;
				Addr&=0xffff;
				count++;
				
			}
			count--;
			*pBuff--=count;
			*pBuff--=cop;
			FileSize+=2;
		} else {
			cop=0;
			count=0;
			pBuff2=pBuff;
			pBuff--;				// skip counter
			FileSize++;
			while ((cop==0) AND (count<128) AND (Addr!=EndAddr)){
	         a=NEXTBYTE(0);
	         b=NEXTBYTE(1);
	         c=NEXTBYTE(2);
				if ((a==b) AND (b==c)){
					cop=1;
				}else{
					*pBuff--=NEXTBYTE(0);
					FileSize++;
					Addr--;
					Addr&=0xffff;
					count++;
				}
			}
			*pBuff2=(count-1)+128;
		}
		if (Addr==EndAddr) done=1;
	}
	*pBuff--=(FileSize&0xff);					// write file size
	*pBuff--=((FileSize&0xff00)>>8);

	Pull (&_A);					// pull start addr
	Pull (&_A);
	Pull (&RomIndex);					// store which ROM we want to use
	Pull (&ROM);						// ROM IN=1, ROM OUT=0 (we want reverse!)
	ROM^=1;
	Pull (&Memory[0xff]);
	Pull (&Memory[0xfe]);
	Pull (&Memory[0xfd]);
	Pull (&Memory[0xfc]);
	Pull (&Memory[0xfb]);
	Pull (&_X);
	Pull (&_Y);
	Pull (&_A);
	Pull (&_F);


	remove (pName);	// first delete the file (if its there)
   handle=open (pName,O_WRONLY|O_BINARY|O_CREAT,S_IRWXU|S_IRWXG);
	unpackcode[67+7]=(FileSize+0x1125+6)&0xff;
	unpackcode[73+7]=(FileSize+0x1125+6)>>8;
	write (handle,&(unpackcode[0]),0x12A);
	pBuffer=pBuff+1;
   write (handle,pBuffer,FileSize+2);
   close (handle);
	_SP=sp;
}


//************************************************************
//                                                           *
//   Name    : Unpack                                        *
//   Function: A sample unpacker                             *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void UnPack( void )
{
	int32		Addr;
	int32		index=0,count;
	uint8		*pBuff,*pBuff2;
	uint8		a,b,c,cop;
	uint8		Mode,done;
	uint16	size;

	pBuff=pBuffer;
	size=((uint32)*pBuff++)<<8;
 	size+=((uint32)*(pBuff++));
	Addr=0xfa;

	pBuff+=(size-1);  
	while (size!=0){
		count=*pBuff--;
		size--;

		if (count<128){							// a RUN?
			a=*pBuff--;
			size--;

			count++;
			while (count>0){
				Memory[(Addr&0xffff)]=a;
				Addr--;
				Addr&=0xffff;
				count--;
			}
		}else{
			count-=128;
			count++;
			while (count>0){
				Memory[(Addr&0xffff)]=*pBuff--;
				Addr--;
				Addr&=0xffff;
				size--;
				count--;
			}

		}	
	}
	_SP=(Addr&0xff);								// set STACK pointer

	Pull (&_A);
	_PC=_A<<8;
	Pull (&_A);					// pull start addr
	_PC|=_A;

	Pull (&RomIndex);					// store which ROM we want to use
	Poke	(0xfdd0+RomIndex,0);		// select ROM

	Pull (&ROM);						// ROM IN=0, ROM OUT=1
	Poke (0xff3e+ROM,0);				// select rom/ram
	Pull (&Memory[0xff]);
	Pull (&Memory[0xfe]);
	Pull (&Memory[0xfd]);
	Pull (&Memory[0xfc]);
	Pull (&Memory[0xfb]);
	Pull (&_X);
	Pull (&_Y);
	Pull (&_A);
	Pull (&_F);

}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
int32	HexChar (char a)
{
	char	HEX[]="0123456789ABCDEF";
	int32	count;

	count=0;
	if ((a>='a') AND (a<='z')){
		a=a-32;								// make uppercase
	}
	while (count<16){
		if (HEX[count]==a) return count;
		count++;
	}
	return -1;	// error not a HEX char
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
int32 ReadHex(char *pScr)
{
	int	v;

	v=HexChar(pScr[0])*0x1000;
	v=v+HexChar(pScr[1])*0x100;
	v=v+HexChar(pScr[2])*0x10;
	v=v+HexChar(pScr[3]);

	return v;
}	



//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
typedef	struct tSourceLine{
			char			*pSourceLine;		// point to source
struct	tSourceLine	*pNext;				// NEXT source line
struct	tSourceLine	*pLast;				// LAST source line
			uint32		Address;				// address of source line
}tSourceLine;

		uint32			*pSourceIndex;		// source index
   	char				*pSourceFileAddress;		// pointer to BASE of file.
		tSourceLine		*pFirstLine;		
		tSourceLine		*pLastLine;		
		
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

tSourceLine *NewLine(void)
{
	tSourceLine	*pLine;

	pLine=(tSourceLine*) MyMalloc(sizeof(tSourceLine));		// allocate new block

	if (pFirstLine==NULL){
		pFirstLine=pLine;
		pLastLine=pLine;
	}else{
		pLastLine->pNext=pLine;
		pLine->pNext=NULL;
		pLine->pLast=pLastLine;
		pLastLine=pLine;
	}
	return pLine;
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void LoadSourceFile(char *pFile)
{
	char			*pScr;
	char			a;
	int32			v;
   tSourceLine	*pLine;


	pSourceIndex=(uint32*) MyMalloc(0x40000);			// allocate index memory
	pSourceFileAddress=(char*) WindLoad(pFile);	// load source file
	pScr=pSourceFileAddress;


	pFirstLine=NULL;
	pLastLine=NULL;

	a=*pScr;
	if ((a<'0') OR (a>'9')) a=0;
	while(a!=0){
		v=ReadHex(pScr);							// get LINE number
		if (v>=0x10000) break;					// end of file...
		
		pScr+=7;										// move to address
		v=ReadHex(pScr);							// get address line occurs at
		if (v>=0x10000) break;					// end of file...

		pLine=NewLine();
		pLine->Address=v;
		pScr+=17;
		if ((*pScr==0xd) OR (*pScr==0xa)){
			pLine->pSourceLine=NULL;
		}else{
			pLine->pSourceLine=pScr;		// point to source code
		}


		while(*pScr!=0x0d){					// wait till we hit the END of current line
			pScr++;
		}
		*pScr=0;	// end of line
		pScr+=2;

		pSourceIndex[pLine->Address]=((uint32)pLine);

		a=*pScr;										// search for end of file 
		if ((a<'0') OR (a>'9')) a=0;
	}
}
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void FreeSourceFile( void )
{
   tSourceLine	*pLine,*pLine2;

	MyFree( pSourceIndex );			// free allocated memory
	MyFree( pSourceFileAddress );
	pLine=pFirstLine;
	while(pLine!=NULL){
		pLine2=pLine->pNext;
		MyFree(pLine);
		pLine=pLine2;
	}
	return;
}




//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
int32 GetTabStop(index)
{
	int32	i,i2;

	i=1;
	index++;
	while (i<11){
		if (Tabs[i]==0){
			return (Tabs[i-1]-Tabs[i-2]);		// get diff betweenLAST tabs
		}

		if (index<Tabs[i]){						// get space LEFT to tab to
			return (Tabs[i]-index);
		}
		i++;
	}
	return 1;
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
char	*ProcessLine(char *pLine)
{
	int32	index,tab,i;


	memset (&TextLine[0],32,80);
	index=0;

	while ((*pLine!=0x0) AND (index<81)){
		if (*pLine==0x9){
			tab=GetTabStop(index);
			for (i=0;i<tab;i++){
				TextLine[index]=' ';
				index++;
			}
		}else{
			TextLine[index]=*pLine;
			index++;
		}
		pLine++;
	}


	if (index>79){
		TextLine[80]=0;
	}else{
	   while (index<79){
			   TextLine[index]=' ';
			   index++;
	   }
	   TextLine[index]=0;
	}

	return (&TextLine[0]);
}

#define	BREAK_PC		1
#define	SKIP_PC		2
#define	BREAK_MEM	4

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

PrintSourceLine2(int32 line, tSourceLine *pLine)
{
	//tSourceLine	*pLine,*pLine2;
   char			s[1024];
	char			*pText;

	if (pSourceFile==NULL) return;

	memset(&s[0],32,80);
	s[80]=0;
  	PrintLine (0,26+line,&s[0]);

	if (pLine==NULL) return;
	if (pLine->pSourceLine==NULL) return;


	pText=ProcessLine(pLine->pSourceLine);

	if ((_PC==pLine->Address) AND (pLine==(tSourceLine*)pSourceIndex[pLine->Address])){
//	if (_PC==pLine->Address) {
		sprintf(&s[0],"b02t0F>%s",pText);
	}else if ((BreakPoints[pLine->Address]&BREAK_PC)!=0){
		sprintf(&s[0],"b04t0F %s",pText);
	}else{
		sprintf(&s[0]," %s",pText);
	}
  	PrintLine (0,26+line,&s[0]);
}



//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void SourceLevelDis(void)
{
	int32			i,aa,lp,count;
	tSourceLine	*pLine,*pLine2;

	if (pSourceFile==NULL) return;			//NO source level debugging active


   //
   // make sure _PC falls at a Disassembled line, and if not make 
   // either SCROLL to include it, or SET the current disassmebler point.
   //
	
	if (pSourceIndex[_PC]==NULL) return;		// NO source at current line

	aa=0;
	count=0;
	pLine=(tSourceLine*) pSourceIndex[StartSrcPC];		// get line to print
	if (pLine!=NULL){

      for (lp=0;lp<20;lp++) {
		   if (pLine->Address==_PC) break;
		   pLine=pLine->pNext;
	   }

SCROLLMORE:
		if (pLine!=NULL){

	      if (pLine->Address!=_PC) {
		      pLine2=pLine;
		      while (pLine2->Address==pLine->Address){
			      pLine2=pLine2->pNext;
		      }
		      // Scroll
		      if (pLine2->Address==_PC){
			      pLine2=pLine=(tSourceLine*) pSourceIndex[StartSrcPC];		// get line to print
		         while (pLine2->Address==pLine->Address){
			         pLine2=pLine2->pNext;
		         }
			      StartSrcPC=pLine2->Address;
		      }else{
			      StartSrcPC=_PC;				// JUMP to address
		      }
	      }
		}

		pLine=(tSourceLine*) pSourceIndex[StartSrcPC];		// get line to print
		if (pLine!=NULL){
         for (lp=0;lp<20;lp++) {
		      if (pLine->Address==_PC) break;
		      pLine=pLine->pNext;
	      }

			if ((lp==20) AND (pLine->Address!=_PC)){
				goto SCROLLMORE;
			}
			pLine2=pLine;
		   while (pLine2->Address==pLine->Address){
			   pLine2=pLine2->pNext;
			   if (pLine2==NULL) break;
				if (pLine2->Address!=pLine->Address) break;
			   lp++;
		   }
		   if (lp<20) count=0; else count=lp-19;
   	}
	}else{
		count=0;
		StartSrcPC=_PC;				// JUMP to address
	}
		

	//
   // now PRINT it.
	//
	pLine=(tSourceLine*) pSourceIndex[StartSrcPC];		// get line to print
	for (i=0;i<count;i++){
		if (pLine!=NULL) {
			pLine=pLine->pNext;
		}
	}

//	pLine=(tSourceLine*) pSourceIndex[StartSrcPC];		// get line to print
   for (lp=0;lp<20;lp++) {
		PrintSourceLine2(lp,pLine);
		if (pLine!=NULL) {
			pLine=pLine->pNext;
   	}
   }	
}





