//****************************************************************************
//
//
//        The Minus4 project - Copyright (c) Mike Dailly 1996,97,98
//
//
// This source and the Minus4 project remains the copyright of Mike Dailly, 
// but can be freely used and changed for NON-Commercial purposes. 
//
//								 Keep emulators free!
//
// Remember if you add or change anything, you MUST send a copy
// complete with source to me at mike@scotch.demon.co.uk
// If its just a bug fix, then just send the changed file, with a comment
// telling me WHERE you fixed and WHAT you fixed.
//
// 
//
//										  DISK.C
//                                      
//					 This file contains the 6502 emulation
//
// This file holds all disk accessing. Loading from HD, and emulating the
// 1541 Floppy drive.
//
//
// Version  By   Date     Description
//
// v1.00    MD 14/11/97	  Move all Disk access into here for easy management.
//
// v1.01		MD 14/01/98	  Fixed "fake" disk system and added a loading bar.
//
//
//****************************************************************************
#include <direct.h>
#include "dos.h"
#include "headers\md.h"
#include "headers\all.h"
#include "headers\screen.h"
#include "headers\draw.h"
#include "headers\6502.h"
#include "headers\6502asm.h"
#include "headers\disasm.h"
#include "headers\keyb.h"
#include	"headers\keyboard.h"
#include	"headers\sound.h"
#include	"headers\sb.h"
#include "headers\wind.h"
#include "headers\main.h"

	extern	char 		C_Table[256];
	extern	char 		Table[256];

	tMenuList		*pMenuFirst=NULL;				// first menu item
	tMenuList		*pMenuLast=NULL;				// first menu item
	uint32	      MenuCount=0;
	int32		      MenuNumber1=0;
	uint8				done=0;

	tDir		*pDir;
	uint8		SectorBuffer[256];
	char		*pCurrPath;

	uint8		*pFileSystem;
	uint8		*pFileEND;
	uint32	FIndex=0;
	uint32	FEnd=1;
	uint8		DMA_STORE;				// value being stored into DISK system
	uint8		LAST_DMA_STORE;
	uint32	status=0;
	uint32	IO=0;
	uint8		lastbyte=0;
	char		DMAFileName[32];
	uint32	nameindex=0;
	uint8		nextb;

	int		TRACK,SECTOR;
	char		CurrentDisk[128];
	char		*pCurrentDisk=&CurrentDisk;
	uint16	baseadd=0x800;

	tWindow	*pLoading;
	tGadget	*pMessage;
	tGadget	*pCount;
   uint32	FileLoading=0;
	uint32	LoadingBar=0;
	char		LoadingName[128];

	uint32	sectors[40]={
				0,21,42,63,84,105,126,147,168,189,210,231,252,273,294,315,336,	// tracks 1-17
				357,376,395,414,433,452,471,
				490,508,526,544,562,580,
				598,615,632,649,666,
				683,700,717,734,751};


//************************************************************
//                                                           *
//   Name    :	Len                                           *
//   Function: Return the length of a string						 *
//                                                           *
//   In   : char* = string to count									 *
//   Out  : int32 = length                                   *
//                                                           *
//************************************************************
int32	Len(char *pStr)
{
	int32	i=0;

	while (*pStr!=0x0){
		i++;
		pStr++;
	}
	return i;
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void GetText (char *pText)
{
	int32	temp;

	temp=0;
	while (pText[temp]!=0){
			 pText[temp]=Table[pText[temp]];
				temp++;
	}
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void GetSector (int handle, uint8 Track, uint8 Sector)
{
	lseek (handle,(sectors[Track-1]+Sector)*256, SEEK_SET);
	read (handle,&SectorBuffer[0],256);
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void LoadD64FileSys (int handle,uint8 Track, uint8 Sector)
{
	//int 		handle;
	uint32	Size,i,i2;
	uint16	Address,Add;
	uint8		first=0;
	int		h2;
	uint32	FileSize;

	FIndex=0;
	FEnd=1;
	//Size=GetSize(pD64Name);
	
  //	handle=open (pD64Name,O_RDONLY|O_BINARY);
	if (handle!=-1) {
	
		while (Track!=0){
			GetSector(handle,Track,Sector);
			Track=SectorBuffer[0];
			Sector=SectorBuffer[1];

			if (first==0){
				FileSize=0;
				first=1;
				if (Track==0) i2=Sector+1; else i2=256;		//+0
			} else {
				if (Track==0) i2=Sector+1; else i2=256;	//+3
			}

			for (i=2;i<i2;i++){
				pFileSystem[FileSize]=SectorBuffer[i];
				FileSize++;
			}
		}
		//close (handle);
		FEnd=FileSize;
	}
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
int FindFileDir( int handle )
{
	int32	i,i2,temp,i3;
	char	s[17];
	char	info[128];
	int	track;
	int	sector;
	char	*ptype;
	uint8	ty;
	char	prot;
	tMenuList	*pMenu;
	uint8	found;

	
	TRACK=0; SECTOR=0;		// init to NOT found
	track=18;
	sector=1;
	while (track!=0){
		GetSector(handle,track,sector);
		for (i=0;i<8;i++){
			pDir=(tDir *) &SectorBuffer[2+(sizeof(tDir)*i)];
			if ((pDir->Track!=0) OR (pDir->Sector!=0)){

				switch (pDir->FileType&0x3f){
					case 0:	ptype="DEL"; break;
					case 1:	ptype="SEQ"; break;
					case 2:	ptype="PRG"; break;
					case 3:	ptype="USR"; break;
					case 4:	ptype="REL"; break;
				}
				if ((pDir->FileType&4)!=0) prot='>'; else prot=' ';

				s[16]=0x0;
				for (i2=0;i2<17;i2++) s[i2]=pDir->FileName[i2];
				GetText(&s);


				found=0;
				for (i2=0;i2<nameindex;i2++){
					if (DMAFileName[i2]=='*'){		// ANY thing now?
						break;							// from now on is OKAY!
					}
					if (DMAFileName[i2]!='?'){
						if (s[i2]!=DMAFileName[i2]) found=1;
					}
				}

				// FOUND IT!!
				if (found==0){
					i2=0; i3=0;
					while ((s[i2]!=160) AND (i2<16)){								// filename
						LoadingName[i3]=s[i2];
						i3++;
						i2++;
					}
					LoadingName[i3]='.';
					LoadingName[i3+1]=ptype[0];
					LoadingName[i3+2]=ptype[1];
					LoadingName[i3+3]=ptype[2];
					LoadingName[i3+4]=0x0;

					TRACK=pDir->Track;
					SECTOR=pDir->Sector;
					return 0;
				}
			}
		}
		track=SectorBuffer[0];
		sector=SectorBuffer[1];
	}
	return 1;
}
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
int	AddSpaces (int curr, char *s, int max)
{
	int	i2,i=0;

	while ((s[i]!=0x0) AND (i<max)){
		i++;
	}

	if (i>=max) return curr;

	for (i2=0;i2<max-i;i2++){
	   pFileSystem[curr]=0x20;	// space
		curr++;
	}
	return curr;
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
uint32	AddDirEntry (uint32 index, int blocks, char *s,char *ptype, char prot)
{
	char	      t[17];
	int32			i,i2;

	pFileSystem[index]=(baseadd+index+0x1e-2)&0xff;				// point to NEXT basic line
	pFileSystem[index+1]=((baseadd+index+0x1e)&0xff00)>>8;
	index+=2;

	pFileSystem[index]=blocks&0xff;					// make line number
	pFileSystem[index+1]=((blocks&0xff00)>>8);
	index+=2;
	sprintf(t,"%d",blocks);
	index=AddSpaces(index,t,4);

	pFileSystem[index]=0x22; 											// start "
	index++;

	i2=0;
	while ((s[i2]!=160) AND (i2<16)){								// filename
		pFileSystem[index]=s[i2];
		index++;
		i2++;
	}
	pFileSystem[index]=0x22;   										// end "
	index++;
	while (i2<16){
	  pFileSystem[index]=0x20;											// and pad with spaces
	  index++;
	  i2++;
	}

	pFileSystem[index]=0x20; 											// space
	pFileSystem[index+1]=ptype[0];									// store program type
	pFileSystem[index+2]=ptype[1];
	pFileSystem[index+3]=ptype[2];
	pFileSystem[index+4]=prot;											// protected?
	pFileSystem[index+5]=0;												// and end line
	index+=6;				

	return index;
}

//************************************************************
//                                                           *
//   Name    : LoadDir                                       *
//   Function: Load the directory into memory                *
//             Makes up a plus/4 directory. And stores it in *
//             pFileSystem ready for loading.                *
//                                                           *
//   In   : handle = pointer to open file...                 *
//   Out  : 1=okay!                                          *
//                                                           *
//************************************************************

int LoadDir( int handle )
{
	int32	      i,i2,temp;
	char	      s[17];
	char	      info[128];
	int	      track;
	int	      sector;
	char	      *ptype;
	uint8	      ty;
	char	      prot;
	tMenuList	*pMenu;
	uint8			found;
	uint32		index=0;
	uint32		spaces;
	char			Free[23]="BLOCKS FREE.          ";

	pFileSystem[index]=0x0;		// set file address
	pFileSystem[index+1]=0x8;
	index+=2;


	TRACK=0; SECTOR=0;		// init to NOT found

	// ************************************************************
	//								 Load Disk Name 
	// ************************************************************
	track=18;
	sector=0;
	GetSector (handle,18,0);		// get header block

	pFileSystem[index]=(baseadd+index+0x1e-2)&0xff;				// Next Line pointer
	pFileSystem[index+1]=((baseadd+index+0x1e)&0xff00)>>8;
	pFileSystem[index+2]=0;			// line number
	pFileSystem[index+3]=0;
	pFileSystem[index+4]=0x12;		// inverse!
	pFileSystem[index+5]=0x22;		// "
	index+=6;

	// Now get DISK name...
	for (i=144;i<160;i++) {
		pFileSystem[index]=SectorBuffer[i]; 
		index++;
	}
	pFileSystem[index]=0x22;		// end "
	pFileSystem[index+1]=0x20;		// space
	index+=2;

	for (i=162;i<167;i++) {			// and finally the disk ID
		pFileSystem[index]=SectorBuffer[i];
		index++;
	}
	pFileSystem[index]=0;		// and end the line
	index++;


	// ************************************************************
	//								Now Load Directory! 
	// ************************************************************

	sector=1;		// now load actual directory!
	while (track!=0){
		GetSector(handle,track,sector);
		for (i=0;i<8;i++){
			pDir=(tDir *) &SectorBuffer[2+(sizeof(tDir)*i)];
			if ((pDir->Track!=0) OR (pDir->Sector!=0)){
				switch (pDir->FileType&0x3f){
					case 0:	ptype="DEL"; break;
					case 1:	ptype="SEQ"; break;
					case 2:	ptype="PRG"; break;
					case 3:	ptype="USR"; break;
					case 4:	ptype="REL"; break;
				}
				if ((pDir->FileType&4)!=0) prot='<'; else prot=' ';

				for (i2=0;i2<17;i2++) s[i2]=pDir->FileName[i2];
				index=AddDirEntry(index,pDir->NumberBlocks,&s[0],ptype,prot);
			}
		}
		track=SectorBuffer[0];
		sector=SectorBuffer[1];
	}

	// ************************************************************
	//						   And display blocks free.
	// ************************************************************

	pFileSystem[index]=(baseadd+index+0x1e-2)&0xff;
	pFileSystem[index+1]=((baseadd+index+0x1e)&0xff00)>>8;
	pFileSystem[index+2]=0;
	pFileSystem[index+3]=0;
	index+=4;
	for (i=0;i<22;i++){
		pFileSystem[index]=Free[i];
		index++;
	}
	pFileSystem[index]=0;		// end this line
	pFileSystem[index+1]=0;		// next line BLANK
	pFileSystem[index+2]=0;
	index+=3;

	FileSize=index;
	FEnd=index;
	return 1;
}

//************************************************************
//                                                           *
//   Name    :	LoadGAMEdir                                   *
//   Function: This "fakes" a real directory from a .D64 file*
//             for one from the GAME directory. This allows  *
//             .PRG files to be loaded from minus/4 and NOT  *
//             F10. This would also allow cool and simple    *
//             file saving...                                *
//                                                           *
//   In   : none                                             *
//   Out  : pFileSystem has a fake DIR                       *
//          FEnd has the size                                *
//                                                           *
//************************************************************
int LoadGAMEdir( void )
{
struct dirent	*pDir;
		DIR		*pOpenDir;
		uint32	index=0,i;
		char		Minus4Dir[16]="MINUS4 DIRECTORY";
		char		Minus4Dir2[5]="FF 2A";
		char		Free[23]="BLOCKS FREE.          ";
		uint32	size;
		char		type[4]="PRG";
		char		name[17];
		char		Name[1024];
                                     
	pFileSystem[index]=0x0;			// set file address
	pFileSystem[index+1]=0x8;
	index+=2;

	// ************************************************************
	//								 Load Disk Name 
	// ************************************************************

	pFileSystem[index]=(baseadd+index+0x1e-2)&0xff;				// Next Line pointer
	pFileSystem[index+1]=((baseadd+index+0x1e)&0xff00)>>8;
	pFileSystem[index+2]=0;			// line number
	pFileSystem[index+3]=0;
	pFileSystem[index+4]=0x12;		// inverse!
	pFileSystem[index+5]=0x22;		// "
	index+=6;

	// Now get DISK name...
	for (i=0;i<16;i++) {
		pFileSystem[index]=Minus4Dir[i];
		index++;
	}
	pFileSystem[index]=0x22;		// end "
	pFileSystem[index+1]=0x20;		// space
	index+=2;

	for (i=0;i<5;i++) {			// and finally the disk ID
		pFileSystem[index]=Minus4Dir2[i];
		index++;
	}
	pFileSystem[index]=0;		// and end the line
	index++;

	// ************************************************************
	//			      make up directory from GAME directory
	// ************************************************************
	sprintf	(&Name[0],"%s*.prg",pFileName);
	pOpenDir=opendir(&Name[0]);		//"*.prg");

	pDir=readdir(pOpenDir);
	while (pDir!=NULL){
		size=pDir->d_size;		//GetSize(&pDir->d_name[0]);
		i=Len (&pDir->d_name);
		strcpy(&name,&pDir->d_name,i);
		while (i<17){
			name[i]=160;
			i++;
		}

		size=((size+255)&0xffff00)/256;
		index=AddDirEntry (index, size, &name[0],type, ' ');
	
		pDir=readdir(pOpenDir);
	}
	closedir(pOpenDir);

	// ************************************************************
	//						   And display blocks free.
	// ************************************************************

	pFileSystem[index]=(baseadd+index+0x1e-2)&0xff;
	pFileSystem[index+1]=((baseadd+index+0x1e)&0xff00)>>8;
	pFileSystem[index+2]=0;
	pFileSystem[index+3]=0;
	index+=4;
	for (i=0;i<22;i++){
		pFileSystem[index]=Free[i];
		index++;
	}
	pFileSystem[index]=0;		// end this line
	pFileSystem[index+1]=0;		// next line BLANK
	pFileSystem[index+2]=0;
	index+=3;

	FileSize=index;
	FEnd=index;
	return 1;
}


//************************************************************
//                                                           *
//   Name    : LoadFreezeGame                                *
//   Function: Load in a frozen state game, registers and    *
//             critical memory locations                     *
//                                                           *
//   In   : pName = file name to load                        *
//   Out  : none                                             *
//                                                           *
//************************************************************
extern uint32	ROMINF;
extern uint32	ROM;
extern uint32	cTimer1;						// Current Timer
extern uint32	Timer1;						// timer init value
extern uint32	TIMER1_LO;							// value written to LOW?
extern uint32	cTimer2;
extern uint32	Timer2;
extern uint32	TIMER2_LO;
extern uint32	cTimer3;
extern uint32	Timer3;
extern uint32	TIMER3_LO;


void LoadFreezeGame( char *pName )
{
	int		handle;
	uint16	Add;
	char		Name[1024];
   uint16	version;

	sprintf (&Name[0],"%s%s",pFileName,pName);
	handle=open (&Name[0],O_RDONLY|O_BINARY);
	Add=0x0000;
	read (handle,&Add,2);						// read load address
	read (handle,&version,2);					// read FREEZE version

	read (handle,&_PC,4);							// read register
	read (handle,&_F,4);							// read register
	read (handle,&_A,4);							// read register
	read (handle,&_X,4);							// read register
	read (handle,&_Y,4);							// read register
	read (handle,&_SP,4);						// read register

	read (handle,&ROMINF,4);					// read ROM bank data!
	read (handle,&ROM,4);						// ROM on/off?
	read (handle,&cTimer1,4);					// Current Timer
	read (handle,&Timer1,4);					// timer init value
	read (handle,&TIMER1_LO,4);				// value written to LOW?

	read (handle,&cTimer2,4);						
	read (handle,&Timer2,4);						
	read (handle,&TIMER2_LO,4);					
	read (handle,&cTimer3,4);						
	read (handle,&Timer3,4);						
	read (handle,&TIMER3_LO,4);					
	
	read (handle,Memory,0x10000);				// read ALL off memory!

	if (ROM==1){
		RomOn();										// ROM=1 - Set roms active!
	} else {
		RomOff();
	}
	SetRomZone (ROMINF);
	close (handle);
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void AddMenu (uint8 ftype, char *pText, uint8 track, uint8 sector)
{
	tMenuList *pMenu;


	pMenu=(tMenuList *)MyMalloc(sizeof(tMenuList));
	if (pMenu==NULL) return;						// return if no memory

	pMenu->FileType=ftype;
	pMenu->Track=track;
	pMenu->Sector=sector;

	strcpy(pMenu->Text,pText);				// copy string

	if (pMenuFirst==NULL){
		pMenuFirst=pMenu;
		pMenuLast=pMenu;
	} else {
		pMenuLast->pNext=pMenu;
		pMenuLast=pMenu;
	}
	pMenu->pNext=NULL;
	MenuCount++;
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void DeleteMenu ( void )
{
	tMenuList	*pMenu=pMenuFirst;
	tMenuList	*pMenu2;


	while (pMenu!=NULL){
		pMenu2=pMenu->pNext;			// get link
		MyFree(pMenu);					// free memory
		pMenu=pMenu2;					// get NEXT link to follow
	}

	pMenuFirst=NULL;
	pMenuLast=NULL;
	MenuCount=0;
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void PrintDir( int handle )
{
	int32	i,i2,temp;
	char	s[17];
	char	info[128];
	int	track;
	int	sector;
	char	*ptype;
	uint8	ty;
	char	prot;
	tMenuList	*pMenu;



	track=18;
	sector=1;
	while (track!=0){
		GetSector(handle,track,sector);
		for (i=0;i<8;i++){
			pDir=(tDir *) &SectorBuffer[2+(sizeof(tDir)*i)];
			if ((pDir->Track!=0) OR (pDir->Sector!=0)){

				switch (pDir->FileType&0x3f){
					case 0:	ptype="DEL"; break;
					case 1:	ptype="SEQ"; break;
					case 2:	ptype="PRG"; break;
					case 3:	ptype="USR"; break;
					case 4:	ptype="REL"; break;
				}
				if ((pDir->FileType&4)!=0) prot='>'; else prot=' ';

				s[16]=0x0;
				for (i2=0;i2<17;i2++) s[i2]=pDir->FileName[i2];
				sprintf (info,"%c%s    %s    %d",prot,ptype,s,pDir->NumberBlocks);
				GetText(&info);

				if ((pDir->FileType&0x3f)==2)
					AddMenu(1,&info, pDir->Track, pDir->Sector);				// CAN select
				else
					AddMenu(0,&info,0,0);				// CAN'T select
		
		
				//printf (info);
				//printf ("\n");
			}
		}
		track=SectorBuffer[0];
		sector=SectorBuffer[1];
	}
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void PrintName ( int handle )
{
	char	s[32];
	int32	i,i2;

	GetSector (handle,18,0);		// get header block
	i2=1;
	s[0]='"';
	for (i=144;i<162;i++) {
		s[i2]=SectorBuffer[i]; 
		i2++;
	}
	s[i2]='"';
	i2++;
	for (i=162;i<167;i++) {
		s[i2]=SectorBuffer[i]; 
		i2++;
	}
	s[i2]=0x0;
	GetText(&s);
	AddMenu(0xff,&s[0],0,0);				// "special" select
	//printf(s);
	//printf("\n");
}


//************************************************************
//                                                           *
//   Name    : GetC64Dir                                     *
//   Function: return the complete directory of a D64 file   *
//                                                           *
//   In   : pFilename = file to get DIR of                   *
//   Out  : dir array filled.                                *
//                                                           *
//************************************************************
void GetC64Dir ( char *name )
{
	int handle;
	uint32	Size;
	char		Name[1024];

	Size=GetSize(name);
	
	//sprintf (&Name[0],"%s%s",pFileName,name);
	handle=open (name,O_RDONLY|O_BINARY);
	//handle=open (&Name[0],O_RDONLY|O_BINARY);
	if (handle!=-1) {
		//printf ("    Loading Dir\n\n");
		PrintName ( handle );
		PrintDir( handle );
		close (handle);
	}
	
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void PrintTextMenu( uint32 start )
{
	tMenuList	*pMenu;
	uint32	i;

	pMenu=pMenuFirst;
	while ((start!=0) AND (pMenu!=NULL)) {
		pMenu=pMenu->pNext;
		start--;
	}

	i=1;
	start=20;
	while ((start!=0) AND (pMenu!=NULL)) {
		PrintLine (20,i,&pMenu->Text[0]);
		start--;
		i++;
		pMenu=pMenu->pNext;
	}
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

int32		CheckStatus(int32 start)
{
	tMenuList	*pMenu;
	uint32	i;
	int32		selected=start;

	pMenu=pMenuFirst;
	while ((start!=0) AND (pMenu!=NULL)) {
		pMenu=pMenu->pNext;
		start--;
	}

	if (pMenu==NULL) return -1;
	if (pMenu->FileType==0) return -1;

	return selected;
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

tMenuList	*GetInfo(int32 start)
{
	tMenuList	*pMenu;
	uint32	i;
	int32		selected=start;

	pMenu=pMenuFirst;
	while ((start!=0) AND (pMenu!=NULL)) {
		pMenu=pMenu->pNext;
		start--;
	}

	return pMenu;			// return pointer
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
int32	ProcessMenu( int32 selected )
{
	int32		Top=0;
	uint8		firsttime=0;

	wipe();

	if (selected<0) 
		selected=0;		// init = -1
	else {
		Top=selected;
	}

	while ((Keys2[K_ENTER]==0) AND (Keys2[K_ESCAPE]==0)){
		if((Keys2[K_UP]!=0) OR
		   (Keys2[K_DOWN]!=0) OR
		   (firsttime==0))
      { 
			firsttime=1;
			WaitVBlank ();
			Cls();	
			PrintTextMenu( Top );
			PrintLine (10,23,"Up and Down to change selection, then Enter to select");

			if (Keys2[K_UP]!=0)   { 
				if (selected>0) selected--; 
				wipe(); 
				if ((selected-Top)<0) Top--;
			}
			if (Keys2[K_DOWN]!=0) { 
				if (selected<MenuCount-1) selected++; 
				wipe(); 
				if ((selected-Top)>=20) Top++;
			}

			PrintLine (18,selected-Top+1,"->");
		}
	}

	selected=CheckStatus(selected);


	if (Keys2[K_ESCAPE]!=0) selected=-2;

	wipe();
	return	selected;
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void LoadFile (char *pName,uint8 Track, uint8 Sector)
{
	int 		handle;
	uint32	Size,i,i2;
	uint16	Address,Add;
	uint8		first=0;
	int		h2;
	uint32	FileSize;

	Size=GetSize(pName);
	strcpy (CurrentDisk,pName);
	
	handle=open (pName,O_RDONLY|O_BINARY);
	if (handle!=-1) {
	
		while (Track!=0){
			GetSector(handle,Track,Sector);
			Track=SectorBuffer[0];
			Sector=SectorBuffer[1];

			if (first==0){
				Address=SectorBuffer[2];
				Address=Address+(SectorBuffer[3]*256);
				Add=Address;
				FileSize=0;

				if (Track==0) i2=Sector+1; else i2=256;		//+0
				for (i=4;i<i2;i++){
					Memory[Address]=SectorBuffer[i];
					Address++;
					FileSize++;
				}
				first=1;
			} else {

				if (Track==0) 
					i2=Sector+1; 									//+3
				else 
					i2=256;
				for (i=2;i<i2;i++){
					Memory[Address]=SectorBuffer[i];
					Address++;
					FileSize++;
				}
			}	

		}

		close (handle);
		//close (h2);
	}
	Doke(0x2b,0x1001);								// setup start of basic
	Doke(0x2d,(FileSize+Add));					// setup END of basic
	Doke(0x2f,(FileSize+Add));					// setup END of basic
	Doke(0x31,(FileSize+Add));					// setup END of basic
	Doke(0x9d,(FileSize+Add));					// setup END of basic
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

int32 LoadD64(char *pName)
{
	int32		MenuNumber;
	tMenuList		*pMenu;
	char		Name[1024];

	sprintf (&Name[0],"%s%s",pFileName,pName);
	GetC64Dir (&Name[0]);
	MenuNumber=ProcessMenu(0);
	if (MenuNumber<0) {
		DeleteMenu();
		return MenuNumber;
	}

	if (pMenu->FileType!=0xff){
	   pMenu=GetInfo(MenuNumber);				   					// get track and sector of first block!
	   LoadFile (&Name[0],pMenu->Track, pMenu->Sector);
	}else{
	   strcpy (CurrentDisk,pName);								// make this the current disk
	}
	DeleteMenu();
	return MenuNumber;
}
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void	GetDir (char	*pFileSpec)
{
struct dirent	*pDir;
	DIR		*pOpenDir;
	char		Name[1024];

	sprintf	(&Name[0],"%s%s",pFileName,pFileSpec);
	//pOpenDir=opendir(pFileSpec);
	pOpenDir=opendir(&Name[0]);

	pDir=readdir(pOpenDir);
	while (pDir!=NULL){
		AddMenu (1,&pDir->d_name[0],0,0);
		pDir=readdir(pOpenDir);
	}
	closedir(pOpenDir);
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void LoadProgram ( char *pPath )
{
	int32		MenuNumber_temp;
	int32		MenuNumber2;
	tMenuList		*pMenu;
	uint32	D64,PRG,FRE;
	char		Name[32];

	done=0;
	//chdir (pPath);
	SetMode(3);
	ScreenMode=CharScreen;

	while (done==0) {
		GetDir("*.d64");			// include any .D64 files
		D64=MenuCount;
		GetDir("*.prg");			// include any .PRG files
		PRG=MenuCount;
		GetDir("*.FRE");			// include any .PRG files
		FRE=MenuCount;
		GetDir("*.TAP");			// include any .TAP files (tape samples)
	
		//
		// select them!
		// 
		MenuNumber_temp=MenuNumber1;
		MenuNumber1=ProcessMenu(MenuNumber1);
		if (MenuNumber1<0) {
			done=1;
			MenuNumber1=MenuNumber_temp;
		} else if (MenuNumber1<D64) {
			pMenu=GetInfo(MenuNumber1);				   					// get track and sector of first block!
			strcpy(&Name[0],&pMenu->Text[0]);
			DeleteMenu();
			MenuNumber2=LoadD64(&Name[0]);
			if (MenuNumber2>=0) done=1;
		} else if (MenuNumber1<PRG) {
			pMenu=GetInfo(MenuNumber1);				   					
			LoadGame(&pMenu->Text[0]);
			DeleteMenu();
			done=1;
		} else if (MenuNumber1<FRE) {
			pMenu=GetInfo(MenuNumber1);				   					
			LoadFreezeGame(&pMenu->Text[0]);
			DeleteMenu();
			done=1;
		} else {
			pMenu=GetInfo(MenuNumber1);				   					
			FASTLOADER=1;														// ALLOW fast loaders!
			sprintf(&TapeFileName[0],"%s",&pMenu->Text[0]);       // set
			DeleteMenu();
			done=1;
		}
			
	}
	//chdir (pCurrPath);
	DeleteMenu();
	ScreenMode=BitMapScreen;
	wipe();
	wipe2();
	InitScreen ();
	Cls();
}


//************************************************************
//                                                           *
//   Name    : LoadFileFirst()										 *
//   Function: Whenever the disk systenm loads a file, it    *
//             load it into memory first for ease of use.    *
//             This section should also emulate the DIR      *
//             command.... filename of "$"?                  *
//                                                           *
//************************************************************
void LoadFileFirst( void )
{
			int		handle,err;
struct	find_t	DirInfo;
			char		s[256];
			char		Name[1024];

	FEnd=1;
	FIndex=0;
   FileLoading=0;
	//if (pFileName!=NULL)	chdir (pFileName);


	// *********************************************************
	//	If no disk selected use GAME directory as the disk image!
	// *********************************************************
	if (CurrentDisk[0]==0x0){
	   if (DMAFileName[0]=='$'){
			LoadGAMEdir();
	   } else {
			if (DMAFileName[nameindex-1]=='*'){
				DMAFileName[nameindex]='.';		// add what we need for MSDOS
				DMAFileName[nameindex+1]='*';
				nameindex+=2;
			}
			DMAFileName[nameindex]=0x0;
			sprintf	(&Name[0],"%s%s",pFileName,DMAFileName);
			err=_dos_findfirst(&Name[0],_A_NORMAL,&DirInfo);
			if (err==0){
			   FEnd=DirInfo.size;	//GetSize(&DirInfo.name);
			   if (FEnd!=0){
					sprintf	(&Name[0],"%s%s",pFileName,&DirInfo.name);
					strcpy (&LoadingName,&DirInfo.name);
	   	      handle=open (&Name[0],O_RDONLY|O_BINARY);	// open DOS file
				   read (handle,pFileSystem,FEnd);
				   close (handle);
               FileLoading=1;
			   }
			}
		}
	} else {

		// *******************************************************
		// IF we have a disk image... use THAT!
		// *******************************************************

	   handle=open (&CurrentDisk[0],O_RDONLY|O_BINARY);

	   if (DMAFileName[0]=='$'){									// directory asked for??
		   LoadDir( handle );
	   } else {
	      err=FindFileDir( handle );
	      if (err==0)	{
		      LoadD64FileSys (handle,TRACK, SECTOR );		// load file into memory
            FileLoading=1;
	      }
	   } 
	   close (handle);
	}
//	if (pFileName!=NULL)	chdir (pCurrPath);

	if (FileLoading==1){
		if (LoadingBar==0) {
	      pLoading=OpenWindow (NULL, 80,80,160,40);
	      pLoading->Options=0;			// border less, and stuff.
	      pLoading->flags|=wREFRESH;		// and refresh it!
         pLoading->clipx1=0;
         pLoading->clipx2=pLoading->maxxsize;
         pLoading->clipy1=0;
         pLoading->clipy2=pLoading->maxysize;
		   sprintf(s,"Loading...%s",&LoadingName);
	      pMessage=AddText(pLoading,2,2, &s);
	      InitWindow (pLoading);						// Clear window, and draw boarders
		}
	}
}


//************************************************************
//                                                           *
//   Name    :	ProcessDiskDrive                              *
//   Function: This is the disk drive emulation section.		 *
//                                                           *
//   In   : $FEF0 - Disk DMA byte									 *
//   Out  : $FEF0 - actual data etc..								 *
//                                                           *
//************************************************************
void ProcessDiskDrive ( void )
{
	int	i,handle;

	if (status==IDLE){
		switch (DMA_STORE){
			case 0x55	:	Memory[0xfef0]=0x55;			// init DMA...
								Memory[1]=Memory[1]&0x3f;
                        if (FileLoading==1) {
									if (LoadingBar==0) CloseWindow (pLoading);
                           pLoading=NULL;
                           FileLoading=0;
								}
								DMA_return;
			case 0x20	:  IO=IOWRITE;						// data write
								DMA_return;
			case 0x42	:
			case 0x40	:  IO=IOREAD;						// data write
								DMA_return;

			case 0x61	:	status=FILEDATA;				// file SAVE data
								FIndex=0;						// init file index
								return;

			case 0x62	:										// 0x62 is SEQ files
			case 0x60	:  status=FILEDATA;				// reveive file data
								LoadFileFirst();				// load requested file into memory first!
								DMA_return;
			case 0xe0   :  DMA_return;						// e0= close channel

			case 0xf1	:										// 0xf1 = GetName (save)
			case 0xf2	:
			case 0xff	:
			case 0xf0	:  status=GETNAME;				// reveive file data
								for (i=0;i<16;i++) DMAFileName[i]=0x0; 	// match ANY name
								nameindex=0;
								DMA_return;
			case 0x00	: 	DMA_return;						// end seq. (ignore)
		} 
	// ------------------------------------------------------------------
	} else if (status==GETNAME){
		if (DMA_STORE==0x81) {
			status=IDLE;
			DMA_return;											// end of seq?
		}

		if ((DMA_STORE!=0X83) AND (DMA_STORE!=0X00)){
			if (DMA_STORE=='*'){
				DMAFileName[nameindex]=DMA_STORE;				// store *
				nameindex++;											// and move to END of string
				status=IDLE;
				DMA_return;
			}
			if (DMA_STORE==',') DMA_STORE=0x0;					// some file names are "test,s,w" or "test,s,r"
			DMAFileName[nameindex]=DMA_STORE;				
			nameindex++;											
			if (nameindex==2){
         	if (((DMAFileName[0]=='0') AND						// the DLOAD will give a file name like "0:3dpool"
					 (DMAFileName[1]==':')) OR
         	    ((DMAFileName[0]=='@') AND						// save"@:????"
					 (DMAFileName[1]==':'))){                  // and we don't want the 0:
					for (i=0;i<16;i++) DMAFileName[i]='?'; 	// start again!
					nameindex=0;
				}
			}
		}
	// ------------------------------------------------------------------
	} else if (status==FILEDATA) {
		if (DMA_STORE==0x84){
			if (IO==IOREAD){
			   Memory[0xfef0]=pFileSystem[FIndex];
			   FIndex++;
			   if (FIndex==FEnd) {
               if (FileLoading==1){
					   if (LoadingBar==0) CloseWindow (pLoading);
                  pLoading=NULL;
                  FileLoading=0;
				   }
				   Memory[0xfef1]=3;			// flag file DONE
				   status=IDLE;
			   }
		  	}
		} else if (LAST_DMA_STORE==0x83) {
			if (IO==IOWRITE){
			   pFileSystem[FIndex]=DMA_STORE;
			   FIndex++;
		  	}
		} else if (DMA_STORE==0x81) {			// end of file write
			char		Name[1024];
			
			sprintf	(&Name[0],"%s%s",pFileName,DMAFileName);
		   handle=open (&Name[0],O_WRONLY|O_BINARY|O_CREAT,S_IRWXU|S_IRWXG);
   		write (handle,pFileSystem,FIndex);
   		close (handle);
				
		   Memory[0xfef1]=3;			// flag file DONE
		   status=IDLE;
		
		} else if (DMA_STORE==0x55){
			status=IDLE;
			Memory[0xfef0]=0x55;			// init DMA...
			Memory[1]=Memory[1]&0x3f;
			DMA_return;

		}
	}
	// ------------------------------------------------------------------
	LAST_DMA_STORE=DMA_STORE;
}
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void	PrintLoading( void )
{
	uint32	i,i2,i3;
   char		s[10];

	if (LoadingBar==1) return;

	if (FileLoading!=1) return;
	i=FEnd<<16;
	i2=FIndex<<16;
	i3=i/100;

   i2=i2/i3;

	//sprintf (&s,"%d of %d",FIndex,FEnd);
	//strcpy (pCount->pMessage,&s);
	//pCount->flags|=gREFRESH;

	DrawCols[0]=255;
	DrawCols[1]=245;
	DrawCols[2]=244;
	DrawCols[3]=243;
	DrawCols[4]=240;

	DrawButtonDown(pLoading,27,11,31+101,23);
	DrawButtonUp  (pLoading,28,12,31+i2,22);
	
}

