//****************************************************************************
//
//
//	The Minus4 project - Copyright (c) Mike Dailly 1996,7
//
//
// This source and the Minus4 project remains the copyright of Mike Dailly, 
// but can be freely used and changed for NON-Commercial purposes. 
//
//								 Keep emulators free!
//
// Remember if you add or change anything, you MUST send a copy
// complete with source to me at mike@scotch.demon.co.uk
// If its just a bug fix, then just send the changed file, with a comment
// telling me WHERE you fixed and WHAT you fixed.
//
// 
//	Minus4 Written by:
// ------------------
//
// MD - Mike Dailly, Main framework and basic emulator.
//
//
// 
//
//****************************************************************************
#include <direct.h>
#include "dos.h"
#include "headers\md.h"
#include "headers\all.h"
#include "headers\screen.h"
#include "headers\draw.h"
#include "headers\6502.h"
#include "headers\6502asm.h"
#include "headers\disasm.h"
#include "headers\keyb.h"
#include	"headers\keyboard.h"
#include "headers\sound.h"
#include "headers\soundb.h"
#include "headers\wind.h"


#define	IDLE			0		// nothing
#define	COMMAND		1		// command comming
#define	GETNAME		2
#define	SENDDATA		3
#define	FILEDATA		4
#define	IOREAD		1
#define	IOWRITE		2

#define	DMA_return	lastbyte=DMA_STORE; return

	extern	char 		C_Table[256];
	extern	char 		Table[256];

	uint32	MALLOCS[1024][2];

	uint32	MemoryTotal=0,MallocCount=0;

	tMenuList		*pMenuFirst=NULL;				// first menu item
	tMenuList		*pMenuLast=NULL;				// first menu item
	uint32	MenuCount=0;
	int32		MenuNumber1=0;
	int32		TIMER_ON=1;

	tDir		*pDir;
	uint8		SectorBuffer[256];
	char		*pCurrPath;
	uint8		done=0;
	uint32	VBLANK;

	uint8		*pFileSystem;
	uint8		*pFileEND;
	uint32	FIndex=0;
	uint32	FEnd=1;
	uint8		DMA_STORE;				// value being stored into DISK system
	uint32	status=0;
	uint32	IO=0;
	uint8		lastbyte=0;
	char		DMAFileName[17];
	uint32	nameindex=0;
	uint8		nextb;
	uint8		*pCompTable_old;

	int		TRACK,SECTOR;
	char		CurrentDisk[128];

	tWindow	*pMaster;
	tGadget	*pJoystick1,*pJoystick2;
	tGadget	*txt1,*txt2,*txt3,*txt4,*txt5,*txt6,*txt7,*txt8,*txt9,*txt10,*txt11;
	tMenu		*pMenu,*pSub,*pSub2,*pTest;
//	int32		wcol=0;
//	int16		xxx,yyy;


		uint32	sectors[40]={
					0,21,42,63,84,105,126,147,168,189,210,231,252,273,294,315,336,	// tracks 1-17
					357,376,395,414,433,452,471,
					490,508,526,544,562,580,
					598,615,632,649,666,
					683,700,717,734,751};

//************************************************************
//							               								 *
//   Name    : InitMalloc/MyMalloc/DoFree		    				 *
//   Function: Memory allocation routines to keep track of   *
//	     			allocated memory. I had a bad bug with rouge  *
//	     			memory pointers....			   					 *
//							   												 *
//************************************************************
void InitMalloc (void)
{
 	int	i;

	for (i=0;i<1024;i++){
		MALLOCS[i][0]=0;
		MALLOCS[i][1]=0;
	}
}
void *MyMalloc (uint32 size)
{
	int	i;
 	MemoryTotal+=size;

	MallocCount++;
	for (i=0;i<1024;i++){
		if (MALLOCS[i][1]==0){
			MALLOCS[i][1]=size;
			MALLOCS[i][0]=(uint32) malloc(size);
			return (void*)MALLOCS[i][0];
		}
	}
	return malloc(size);			// can't remember... but allocate anyway!
}
void DoFree (void *Address)
{
	int	i;

	MallocCount--;
	for (i=0;i<1024;i++){
		if (MALLOCS[i][0]==(uint32) Address){
 			MemoryTotal-=MALLOCS[i][1];
			MALLOCS[i][0]=0;
			MALLOCS[i][1]=0;
			free(Address);
			return;
		}
	}
	free(Address);		// not IN list! but FREE anyway!
}

//***********************************************************
//							   												*
//   Name    :					       									*
//   Function:					       									*
//							   												*
//   In   :						  											*
//   Out  :						  											*
//							   												*
//************************************************************
void InitWindowSystem ( void )
{
	InitSystem (Screen,368,240);							// Tell system screen address and size
	pMaster=OpenWindow (NULL, 100,70,160,100);
	SetWindowPen (pMaster,255,245,244,243,240);		// set to a green colour scheme
	pMaster->Options|=HIDE;
	EnableMouse=0;

	pMenu=AddMenuItem (pMaster ,NULL, "FILE ",  1 );
  		pSub=AddMenuItem (pMaster ,pMenu, "NEW       ", 11 );
  		pSub2=AddMenuItem (pMaster ,pMenu, "SAVE   ", 12 );
			pTest=AddMenuItem (pMaster ,pSub2, "SNAPSHOT ", 121 );
		  	pTest=AddMenuItem  (pMaster ,pSub2, ".BMP     ", 122  );
		pSub=AddMenuItem (pMaster ,pMenu, "LOAD   ", 13 );
			pTest=AddMenuItem (pMaster ,pSub, "D64 FILE   ", 131 );
		  	pTest=AddMenuItem (pMaster ,pSub, "PRG FILE ", 132  );
		  	pTest=AddMenuItem (pMaster ,pSub, "FRE FILE ", 133  );
		pSub=AddMenuItem (pMaster ,pMenu, "SELECT ", 14 );


	// Joystick stuff
	pJoystick1=AddBooleanGadget(pMaster,TICK,6,13);
	txt1=AddText(pMaster,16,14, "Enable Joystick 1");
	pJoystick2=AddBooleanGadget(pMaster,TICK,6,23);
	txt2=AddText(pMaster,16,23, "Enable Joystick 2");
	txt3=AddTextButton(pMaster, 100,12, 50,16,"Calabrate");

	// Command Line Option
	txt4=AddBooleanGadget(pMaster,TICK,6,33);
	txt5=AddText(pMaster,16,34, "50Hz Timer Active");
	if (TIMER_ON!=0) txt4->value=-1;
	txt6=AddBooleanGadget(pMaster,TICK,6,43);
	txt7=AddText(pMaster,16,44, "Sound Active");
	if (SOUND!=0) txt6->value=-1;
	txt10=AddBooleanGadget(pMaster,TICK,6,53);
	txt11=AddText(pMaster,16,54, "Samples Active (DMA 1, PORT 220)");
	if (DOVBLANK!=0) txt8->value=-1;

	txt8=AddBooleanGadget(pMaster,TICK,6,63);
	txt9=AddText(pMaster,16,64, "VBlank Syncing");
	if (DOVBLANK!=0) txt8->value=-1;

//				if (strcmp(argv[i],"-x")==0) ModeX=1;
//				if (strcmp(argv[i],"-v")==0) DOVBLANK=1;
//				if (strcmp(argv[i],"-d")==0) startdebug=1;
//				if (strcmp(argv[i],"-a")==0) SOUND=0; 
//				if (strcmp(argv[i],"-t")==0) TIMER_ON=0; 
//				if (strcmp(argv[i],"-s")==0) SB_ON=1; 

}

//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************
void GetText (char *pText)
{
	int32	temp;

	temp=0;
	while (pText[temp]!=0){
				pText[temp]=Table[pText[temp]];
				temp++;
	}
}

//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************
void GetSector (int handle, uint8 Track, uint8 Sector)
{
	lseek (handle,(sectors[Track-1]+Sector)*256, SEEK_SET);
	read (handle,&SectorBuffer[0],256);
}


//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************
void LoadD64FileSys (int handle,uint8 Track, uint8 Sector)
{
	//int 		handle;
	uint32	Size,i,i2;
	uint16	Address,Add;
	uint8		first=0;
	int		h2;
	uint32	FileSize;

	FIndex=0;
	FEnd=1;
	//Size=GetSize(pD64Name);
	
  //	handle=open (pD64Name,O_RDONLY|O_BINARY);
	if (handle!=-1) {
	
		while (Track!=0){
			GetSector(handle,Track,Sector);
			Track=SectorBuffer[0];
			Sector=SectorBuffer[1];

			if (first==0){
				FileSize=0;
				first=1;
				if (Track==0) i2=Sector; else i2=256;
			} else {
				if (Track==0) i2=Sector+3; else i2=256;
			}

			for (i=2;i<i2;i++){
				pFileSystem[FileSize]=SectorBuffer[i];
				FileSize++;
			}
		}
		//close (handle);
		FEnd=FileSize;
	}
}


//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************
int FindFileDir( int handle )
{
	int32	i,i2,temp;
	char	s[17];
	char	info[128];
	int	track;
	int	sector;
	char	*ptype;
	uint8	ty;
	char	prot;
	tMenuList	*pMenu;
	uint8	found;

	
	TRACK=0; SECTOR=0;		// init to NOT found
	track=18;
	sector=1;
	while (track!=0){
		GetSector(handle,track,sector);
		for (i=0;i<8;i++){
			pDir=(tDir *) &SectorBuffer[2+(sizeof(tDir)*i)];
			if ((pDir->FileType&0x7f)!=0){							// file deleted?

				switch (pDir->FileType&0x3f){
					case 1:	ptype="SEQ"; break;
					case 2:	ptype="PRG"; break;
					case 3:	ptype="USR"; break;
					case 4:	ptype="REL"; break;
				}
				if ((pDir->FileType&4)!=0) prot='>'; else prot=' ';

				s[16]=0x0;
				for (i2=0;i2<17;i2++) s[i2]=pDir->FileName[i2];
				GetText(&s);


				found=0;
				for (i2=0;i2<nameindex;i2++){
					if (DMAFileName[i2]!='?'){
						if (s[i2]!=DMAFileName[i2]) found=1;
					}
				}

				// FOUND IT!!
				if (found==0){
					TRACK=pDir->Track;
					SECTOR=pDir->Sector;
					return 0;
				}
			}
		}
		track=SectorBuffer[0];
		sector=SectorBuffer[1];
	}
	return 1;
}


//************************************************************
//							   *
//   Name    : LoadFileFirst()										 *
//   Function: Whenever the disk systenm loads a file, it    *
//	     load it into memory first for ease of use.    *
//	     This section should also emulate the DIR      *
//	     command.... filename of "$"?		  *
//							   *
//************************************************************
void LoadFileFirst( void )
{
	int	handle,err;

	FEnd=1;
	FIndex=0;
	if (pFileName!=NULL)	chdir (pFileName);
	handle=open (&CurrentDisk[0],O_RDONLY|O_BINARY);
	err=FindFileDir( handle );
	if (err==0)	{
		LoadD64FileSys (handle,TRACK, SECTOR );			// load file into memory
	}
	close (handle);
	if (pFileName!=NULL)	chdir (pCurrPath);
}


//************************************************************
//							   *
//   Name    :	ProcessDiskDrive			      *
//   Function: This is the disk drive emulation section.		 *
//							   *
//   In   : $FEF0 - Disk DMA byte									 *
//   Out  : $FEF0 - actual data etc..								 *
//							   *
//************************************************************
void ProcessDiskDrive ( void )
{
	int	i;

	if (status==IDLE){
		switch (DMA_STORE){
			case 0x55	:	Memory[0xfef0]=0x55;			// init DMA...
								Memory[1]=Memory[1]&0x3f;
								DMA_return;
			case 0x20	:  IO=IOWRITE;					// data write
								DMA_return;
			case 0x42	:
			case 0x40	:  IO=IOREAD;					// data write
								DMA_return;
			case 0x62	:									// 0x62 is SEQ files
			case 0x60	:  status=FILEDATA;			// reveive file data
								LoadFileFirst();			// load requested file into memory first!
								DMA_return;
			case 0xf2	:
			case 0xff	:
			case 0xf0	:  status=GETNAME;			// reveive file data
								for (i=0;i<16;i++) DMAFileName[i]='?'; 	// match ANY name
								nameindex=0;
								DMA_return;
			case 0x00	: 	DMA_return;					// end seq. (ignore)
		} 
	} else if (status==GETNAME){
		if (DMA_STORE==0x81) {
			status=IDLE;
			DMA_return;							// end of seq?
		}

		if ((DMA_STORE!=0X83) AND (DMA_STORE!=0X00)){
			if (DMA_STORE=='*'){
				nameindex=16;
				status=IDLE;
				DMA_return;
			}
			DMAFileName[nameindex]=DMA_STORE;
			nameindex++;
		}
	} else if (status==FILEDATA) {
		if (DMA_STORE==0x84){
			Memory[0xfef0]=pFileSystem[FIndex];
			FIndex++;
			if (FIndex==FEnd) {
				Memory[0xfef1]=3;		// flag file DONE
				status=IDLE;
			}
		} else if (DMA_STORE==0x55){
			status=IDLE;
			Memory[0xfef0]=0x55;			// init DMA...
			Memory[1]=Memory[1]&0x3f;
			DMA_return;

		}
	}
}

//************************************************************
//							   *
//   Name    : LoadFreezeGame				*
//   Function: Load in a frozen state game, registers and    *
//	     critical memory locations		     *
//							   *
//   In   : pName = file name to load			*
//   Out  : none					     *
//							   *
//************************************************************
extern uint32	ROMINF;
extern uint32	ROM;
extern uint32	cTimer1;						// Current Timer
extern uint32	Timer1;						// timer init value
extern uint32	TIMER1_LO;							// value written to LOW?


void LoadFreezeGame( char *pName )
{
	int		handle;
	uint16	Add;

	handle=open (pName,O_RDONLY|O_BINARY);
	Add=0x0000;
	read (handle,&Add,2);						// write load address

	read (handle,&_PC,4);							// write register
	read (handle,&_F,4);							// write register
	read (handle,&_A,4);							// write register
	read (handle,&_X,4);							// write register
	read (handle,&_Y,4);							// write register
	read (handle,&_SP,4);							// write register

	read (handle,&ROMINF,4);						// write ROM bank data!
	read (handle,&ROM,4);							// ROM on/off?
	read (handle,&cTimer1,4);						// Current Timer
	read (handle,&Timer1,4);						// timer init value
	read (handle,&TIMER1_LO,4);							// value written to LOW?
	read (handle,Memory,0x10000);	// Dump ALL off memory!

	if (ROM==1){
		RomOn();						// ROM=1 - Set roms active!
	} else {
		RomOff();
	}
	SetRomZone (ROMINF);
	close (handle);
}
		
//************************************************************
//							   *
//   Name    : MakeCompTable				 *
//   Function: this creates an array for comparing a register*
//	     and what flags we get back from it.	   *
//							   *
//************************************************************

extern	uint8		*pCompTable2;
extern	uint8		CompTable;

void MakeCompTable( void )
{
	uint8		*pCompTable=&CompTable;
	uint8		F;
	uint16	test;
	
	pCompTable_old=MyMalloc(512);
	pCompTable2=(((uint32) pCompTable_old+255)&0xffffff00);

	for (test=0;test<256;test++){
		F=0;
		if ((test & 128)==128) {F|=_N;}
		if (test==0) {F|=_Z;}
		pCompTable[test]=F;
		pCompTable2[test]=F;
	}
}
	
//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************
void AddMenu (uint8 ftype, char *pText, uint8 track, uint8 sector)
{
	tMenuList *pMenu;


	pMenu=(tMenuList *)MyMalloc(sizeof(tMenuList));
	if (pMenu==NULL) return;						// return if no memory

	pMenu->FileType=ftype;
	pMenu->Track=track;
	pMenu->Sector=sector;

	strcpy(pMenu->Text,pText);				// copy string

	if (pMenuFirst==NULL){
		pMenuFirst=pMenu;
		pMenuLast=pMenu;
	} else {
		pMenuLast->pNext=pMenu;
		pMenuLast=pMenu;
	}
	pMenu->pNext=NULL;
	MenuCount++;
}

//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************
void DeleteMenu ( void )
{
	tMenuList	*pMenu=pMenuFirst;
	tMenuList	*pMenu2;


	while (pMenu!=NULL){
		pMenu2=pMenu->pNext;			// get link
		MyFree(pMenu);					// free memory
		pMenu=pMenu2;					// get NEXT link to follow
	}

	pMenuFirst=NULL;
	pMenuLast=NULL;
	MenuCount=0;
}


//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************
void PrintDir( int handle )
{
	int32	i,i2,temp;
	char	s[17];
	char	info[128];
	int	track;
	int	sector;
	char	*ptype;
	uint8	ty;
	char	prot;
	tMenuList	*pMenu;



	track=18;
	sector=1;
	while (track!=0){
		GetSector(handle,track,sector);
		for (i=0;i<8;i++){
			pDir=(tDir *) &SectorBuffer[2+(sizeof(tDir)*i)];
			if ((pDir->FileType&0x7f)!=0){							// file deleted?

				switch (pDir->FileType&0x3f){
					case 1:	ptype="SEQ"; break;
					case 2:	ptype="PRG"; break;
					case 3:	ptype="USR"; break;
					case 4:	ptype="REL"; break;
				}
				if ((pDir->FileType&4)!=0) prot='>'; else prot=' ';

				s[16]=0x0;
				for (i2=0;i2<17;i2++) s[i2]=pDir->FileName[i2];
				sprintf (info,"%c%s    %s    %d",prot,ptype,s,pDir->NumberBlocks);
				GetText(&info);

				if ((pDir->FileType&0x3f)==2)
					AddMenu(1,&info, pDir->Track, pDir->Sector);				// CAN select
				else
					AddMenu(0,&info,0,0);				// CAN'T select
		
		
				//printf (info);
				//printf ("\n");
			}
		}
		track=SectorBuffer[0];
		sector=SectorBuffer[1];
	}
}

//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************

void PrintName ( int handle )
{
	char	s[32];
	int32	i,i2;

	GetSector (handle,18,0);		// get header block
	i2=1;
	s[0]='"';
	for (i=144;i<162;i++) {
		s[i2]=SectorBuffer[i]; 
		i2++;
	}
	s[i2]='"';
	i2++;
	for (i=162;i<167;i++) {
		s[i2]=SectorBuffer[i]; 
		i2++;
	}
	s[i2]=0x0;
	GetText(&s);
	AddMenu(0,&s[0],0,0);				// CAN'T select
	//printf(s);
	//printf("\n");
}


//************************************************************
//							   *
//   Name    : GetC64Dir				     *
//   Function: return the complete directory of a D64 file   *
//							   *
//   In   : pFilename = file to get DIR of		   *
//   Out  : dir array filled.				*
//							   *
//************************************************************
void GetC64Dir ( char *name )
{
	int handle;
	uint32	Size;

	Size=GetSize(name);
	
	handle=open (name,O_RDONLY|O_BINARY);
	if (handle!=-1) {
		//printf ("    Loading Dir\n\n");
		PrintName ( handle );
		PrintDir( handle );
		close (handle);
	}
	
}


//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************

void PrintTextMenu( uint32 start )
{
	tMenuList	*pMenu;
	uint32	i;

	pMenu=pMenuFirst;
	while ((start!=0) AND (pMenu!=NULL)) {
		pMenu=pMenu->pNext;
		start--;
	}

	i=1;
	start=20;
	while ((start!=0) AND (pMenu!=NULL)) {
		PrintLine (20,i,&pMenu->Text[0]);
		start--;
		i++;
		pMenu=pMenu->pNext;
	}
}

//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************

int32		CheckStatus(int32 start)
{
	tMenuList	*pMenu;
	uint32	i;
	int32		selected=start;

	pMenu=pMenuFirst;
	while ((start!=0) AND (pMenu!=NULL)) {
		pMenu=pMenu->pNext;
		start--;
	}

	if (pMenu==NULL) return -1;
	if (pMenu->FileType==0) return -1;

	return selected;
}

//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************

tMenuList	*GetInfo(int32 start)
{
	tMenuList	*pMenu;
	uint32	i;
	int32		selected=start;

	pMenu=pMenuFirst;
	while ((start!=0) AND (pMenu!=NULL)) {
		pMenu=pMenu->pNext;
		start--;
	}

	return pMenu;			// return pointer
}

//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************
int32	ProcessMenu( int32 selected )
{
	int32		Top=0;
	uint8		firsttime=0;

	Wipe();

	if (selected<0) 
		selected=0;		// init = -1
	else {
		Top=selected;
	}

	while ((Keys2[K_ENTER]==0) AND (Keys2[K_ESCAPE]==0)){
		if((Keys2[K_UP]!=0) OR
		   (Keys2[K_DOWN]!=0) OR
		   (firsttime==0))
      { 
			firsttime=1;
			WaitVBlank ();
			Cls();	
			PrintTextMenu( Top );
			PrintLine (10,23,"Up and Down to change selection, then Enter to select");

			if (Keys2[K_UP]!=0)   { 
				if (selected>0) selected--; 
				wipe(); 
				if ((selected-Top)<0) Top--;
			}
			if (Keys2[K_DOWN]!=0) { 
				if (selected<MenuCount-1) selected++; 
				wipe(); 
				if ((selected-Top)>=20) Top++;
			}

			PrintLine (18,selected-Top+1,"->");
		}
	}

	selected=CheckStatus(selected);


	if (Keys2[K_ESCAPE]!=0) selected=-2;

	Wipe();
	return	selected;
}


//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************
void LoadFile (char *pName,uint8 Track, uint8 Sector)
{
	int 		handle;
	uint32	Size,i,i2;
	uint16	Address,Add;
	uint8		first=0;
	int		h2;
	uint32	FileSize;

	Size=GetSize(pName);
	strcpy (CurrentDisk,pName);
	
	handle=open (pName,O_RDONLY|O_BINARY);
	if (handle!=-1) {
	
		while (Track!=0){
			GetSector(handle,Track,Sector);
			Track=SectorBuffer[0];
			Sector=SectorBuffer[1];

			if (first==0){
				Address=SectorBuffer[2];
				Address=Address+(SectorBuffer[3]*256);
				Add=Address;
				FileSize=0;

				if (Track==0) i2=Sector; else i2=256;
				for (i=4;i<i2;i++){
					Memory[Address]=SectorBuffer[i];
					Address++;
					FileSize++;
				}
				first=1;
			} else {

				if (Track==0) 
					i2=Sector+3; 
				else 
					i2=256;
				for (i=2;i<i2;i++){
					Memory[Address]=SectorBuffer[i];
					Address++;
					FileSize++;
				}
			}	

		}

		close (handle);
		//close (h2);
	}
	Doke(0x2b,0x1001);								// setup start of basic
	Doke(0x2d,(FileSize+Add-2));					// setup END of basic
	Doke(0x9d,(FileSize+Add-2));					// setup END of basic
}

//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************

int32 LoadD64(char *pName)
{
	int32		MenuNumber;
	tMenuList		*pMenu;


	GetC64Dir (pName);
	MenuNumber=ProcessMenu(0);
	if (MenuNumber<0) {
		DeleteMenu();
		return MenuNumber;
	}

	pMenu=GetInfo(MenuNumber);				   					// get track and sector of first block!
	LoadFile (pName,pMenu->Track, pMenu->Sector);
	DeleteMenu();
	return MenuNumber;
}
//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************

void	GetDir (char	*pFileSpec)
{
struct dirent	*pDir;
	DIR		*pOpenDir;

	pOpenDir=opendir(pFileSpec);

	pDir=readdir(pOpenDir);
	while (pDir!=NULL){
		AddMenu (1,&pDir->d_name[0],0,0);
		pDir=readdir(pOpenDir);
	}
	closedir(pOpenDir);
}


//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************

void LoadProgram ( char *pPath )
{
	int32		MenuNumber_temp;
	int32		MenuNumber2;
	tMenuList		*pMenu;
	uint32	D64,PRG;
	char		Name[32];

	done=0;
	chdir (pPath);
	SetMode(3);
	ScreenMode=CharScreen;

	while (done==0) {
		GetDir("*.d64");			// include any .D64 files
		D64=MenuCount;
		GetDir("*.prg");			// include any .PRG files
		PRG=MenuCount;
		GetDir("*.FRE");			// include any .PRG files
	
		//
		// select them!
		// 
		MenuNumber_temp=MenuNumber1;
		MenuNumber1=ProcessMenu(MenuNumber1);
		if (MenuNumber1<0) {
			done=1;
			MenuNumber1=MenuNumber_temp;
		} else if (MenuNumber1<D64) {
			pMenu=GetInfo(MenuNumber1);				   					// get track and sector of first block!
			strcpy(&Name[0],&pMenu->Text[0]);
			DeleteMenu();
			MenuNumber2=LoadD64(&Name[0]);
			if (MenuNumber2>=0) done=1;
		} else if (MenuNumber1<PRG) {
			pMenu=GetInfo(MenuNumber1);				   					// get track and sector of first block!
			DeleteMenu();
			LoadGame(&pMenu->Text[0]);
			done=1;
		} else {
			pMenu=GetInfo(MenuNumber1);				   					// get track and sector of first block!
			DeleteMenu();
			LoadFreezeGame(&pMenu->Text[0]);
			done=1;
		}
			
	}
	chdir (pCurrPath);
	DeleteMenu();
	ScreenMode=BitMapScreen;
	InitScreen ();
	Cls();
}

//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************
void (__interrupt __far *Old_Timer_Isr)();
int32	Icount=0;
#define	TIMER_VEC	0x1c
#define	_50Hz			23863
#define	_60Hz			19886
#define	_SYSTEMTIME	0xFFFF

void __interrupt __far Timer ( void )
{
	Icount++;
	VBLANK=1;
	Old_Timer_Isr();
}


void TimerOff( void )
{
	_dos_setvect (TIMER_VEC, Old_Timer_Isr );
	SetTimer ( _SYSTEMTIME );
}
void TimerOn ( void )
{
	Old_Timer_Isr=_dos_getvect( TIMER_VEC );	// get timer interrupt vector.
	_dos_setvect (TIMER_VEC, Timer);
	SetTimer ( _50Hz );
}

#define	CONTROL_8253	0x43
#define	CONTROL_WORD	0x3c
#define	COUNTER_0		0x40
#define	COUNTER_1		0x41
#define	COUNTER_2		0x42


void SetTimer ( uint32 val )
{
	outp ( CONTROL_8253, CONTROL_WORD );
	outp ( COUNTER_0,  (val&255) );
	outp ( COUNTER_0, ((val>>8)&255) );
}

//************************************************************
//							   *
//   Name    :					       *
//   Function:					       *
//							   *
//   In   :						  *
//   Out  :						  *
//							   *
//************************************************************
extern	uint32			SBcount;

void main ( int Count, char *argv[] )
{
	char		key;
	uint32	i;
	char		*Param;
	uint8		startdebug=0;


	InitMalloc ();
	SBcount=0;
	//
	// If you ADD anything to Minus4, feel free to add your name
   // here. But remember to send me a copy, complete with source!
	//
	printf ("\nMinus4 - The Plus/4 Emulator Version 1.3\n");
	printf ("   Copyright (C) Mike Dailly 1996,97\n\n\n");


	pCurrPath=getcwd(NULL,0);
	pFileName=NULL;
	if (Count>1){
		pFileName=argv[1];
		if (strcmp (pFileName,"/?")==0) { //OR (pFileName=="-?"))
			printf ("\nminus4 <Game Directory> [options]");
			printf ("\n-x = Enable ModeX and use 360x240x256col");
			printf ("\n-a = Disable AUDIO.");
			printf ("\n-t = Disable 50Hz/60Hz Timer");
			printf ("\n-s = ENABLE soundblaster samples (must be DMA 1 & PORT 220 just now)");
			printf ("\n-v = Enable vertical blank sync.");
			printf ("\n-d = Start in debug mode.\n");
			printf ("\n\n");
			exit (1);
		}
		if (Count>2){
			for (i=2;i<Count;i++){
				if (strcmp(argv[i],"-x")==0) ModeX=1;
				if (strcmp(argv[i],"-v")==0) DOVBLANK=1;
				if (strcmp(argv[i],"-d")==0) startdebug=1;
				if (strcmp(argv[i],"-a")==0) SOUND=0; 
				if (strcmp(argv[i],"-t")==0) TIMER_ON=0; 
				if (strcmp(argv[i],"-s")==0) SB_ON=1; 
			}
		}
	}

	if (TIMER_ON==1){
		TimerOn();
	}

	for (i=0;i<256;i++){
		Table[i]=i&0xff;
		if (C_Table[i]!=0x20) Table[i]=C_Table[i];
	}
	
	pFileSystem=MyMalloc(256000);				// allocate 256K for file system
	Initialise_Keyboard ();
	MakeCompTable();
	Init6502();
	InitSound();
	InitSB ();
	printf ("Init 8501:\n");
	InitScreen ();
	InitWindowSystem();

//	MyFree(Screen);
//	MyFree(pCompTable_old);
//	MyFree(pFileSystem);
//	ShutDownWindows();
//	
//	printf ("Calls Left=%d, Memory Being Used=%d bytes\n",MallocCount,MemoryTotal);
//	Restore_Keyboard ();
//   return;
//	exit(1);

   printf ("\n-------------------------------------------------\n\n");

	debug=startdebug;
	SetMode(3);

	while (EXIT_PRG==0){
		if (debug==0){
		
			ScreenMode=BitMapScreen;
			InitScreen ();
			Cls();
			_screen=1;
			Process2();
			SetMode(3);
			debug=1;
		} else{
			ScreenMode=CharScreen;
			_screen=1;
			CopyScreen (0);
			Process();
			debug=0;
		}
	}
	SetMode(3);
	Restore_Keyboard ();
	ShutDownSound();
	DisableSB ();
	
	if (TIMER_ON==1){
		TimerOff();
	}


	//
	// Free memory..
	//
	MyFree(pMemory);
	MyFree(MemoryWrite);
	MyFree(MemoryRead);
	MyFree(MemoryRead2);
	for (i=0;i<MAXROM;i++){
		if(pROMS[i]!=NULL) MyFree(pROMS[i]);
	}
	MyFree(pCompTable_old);
	MyFree(pFileSystem);
	MyFree(Screen);
	ShutDownWindows();

//	printf ("Calls Left=%d, Memory Being Used=%d bytes\n",MallocCount,MemoryTotal);
}



