//****************************************************************************
//
//
//        The Minus4 project - Copyright (c) Mike Dailly 1996,97,98
//
//
// This source and the Minus4 project remains the copyright of Mike Dailly, 
// but can be freely used and changed for NON-Commercial purposes. 
//
//								 Keep emulators free!
//
// Remember if you add or change anything, you MUST send a copy
// complete with source to me at mike@scotch.demon.co.uk
// If its just a bug fix, then just send the changed file, with a comment
// telling me WHERE you fixed and WHAT you fixed.
//
// 
//	Minus4 Written by:
// ------------------
//
// MD - Mike Dailly, Main framework and basic emulator.
// TB - Tibor Biczo, Debuging and tecnical issues.
//
// 
//
//****************************************************************************
#include <direct.h>
#include "dos.h"
#include "headers\md.h"
#include "headers\all.h"
#include "headers\screen.h"
#include "headers\draw.h"
#include "headers\6502.h"
#include "headers\6502asm.h"
#include "headers\disk.h"
#include "headers\disasm.h"
#include "headers\keyb.h"
#include	"headers\keyboard.h"
#include "headers\sound.h"
#include "headers\soundb.h"
#include "headers\wind.h"

#define	MAX_MALLOCS	8192

	extern	char 		C_Table[256];
	extern	char 		Table[256];
	extern	uint8		*pHeader;				// TAPE sample

	uint32	SourceLevelDebugger=0;
	char		SourceFile[256];
	char		*pSourceFile;
	uint32	MALLOCS[MAX_MALLOCS][2];
	uint32	MemoryTotal=0,MallocCount=0;
	int32		TIMER_ON=1;
volatile	uint32	VBLANK;
	uint8		*pCompTable_old;
extern   uint16      newpc;


extern	uint32	DOCOPYSCREEN;
	tWindow	*pMaster;
	tGadget	*pJoystick1,*pJoystick2;
	tGadget	*txt1,*txt2,*txt3,*txt4,*txt5,*txt6,*txt7,*txt8,*txt9,*txt10,*txt11;
	tMenu		*pMenu,*pSub,*pSub2,*pTest;
	char		FileName[2048];
	char		AutoLoadName[1024];
	char		AutoRun[1024];


//************************************************************
//                                                           *
//   Name    : InitMalloc/MyMalloc/DoFree                    *
//   Function: Memory allocation routines to keep track of   *
//             allocated memory. I had a bad bug with rouge  *
//             memory pointers....                           *
//                                                           *
//************************************************************
void InitMalloc (void)
{
 	int	i;

	for (i=0;i<MAX_MALLOCS;i++){
		MALLOCS[i][0]=0;
		MALLOCS[i][1]=0;
	}
}
void *MyMalloc (uint32 size)
{
	int	i;
 	MemoryTotal+=size;

	MallocCount++;
	for (i=0;i<MAX_MALLOCS;i++){
		if (MALLOCS[i][1]==0){
			MALLOCS[i][1]=size;
			MALLOCS[i][0]=(uint32) malloc(size);
			return (void*)MALLOCS[i][0];
		}
	}
	return malloc(size);			// can't remember... but allocate anyway!
}
void DoFree (void *Address)
{
	int	i;

	if (Address==NULL) return;			// dont try and free this!!!

	MallocCount--;
	for (i=0;i<MAX_MALLOCS;i++){
		if (MALLOCS[i][0]==(uint32) Address){
 			MemoryTotal-=MALLOCS[i][1];
			MALLOCS[i][0]=0;
			MALLOCS[i][1]=0;
			free(Address);
			return;
		}
	}
	free(Address);		// not IN list! but FREE anyway!
}

//************************************************************
//                                                           *
//   Name    :	InitWindowSystem                              *
//   Function: Init windows and gadgets used in front end    *
//                                                           *
//   In   : none                                             *
//   Out  : none                                             *
//                                                           *
//************************************************************
void InitWindowSystem ( void )
{
	pMaster=OpenWindow (NULL, 100,70,160,100);
	SetWindowPen (pMaster,255,245,244,243,240);		// set to a green colour scheme
	//pMaster->Options|=HIDE;

	pMenu=AddMenuItem (pMaster ,NULL, "FILE ",  1 );
  		pSub=AddMenuItem (pMaster ,pMenu, "NEW       ", 11 );
  		pSub2=AddMenuItem (pMaster ,pMenu, "SAVE   ", 12 );
			pTest=AddMenuItem (pMaster ,pSub2, "SNAPSHOT ", 121 );
		  	pTest=AddMenuItem  (pMaster ,pSub2, ".BMP     ", 122  );
		pSub=AddMenuItem (pMaster ,pMenu, "LOAD   ", 13 );
			pTest=AddMenuItem (pMaster ,pSub, "D64 FILE   ", 131 );
		  	pTest=AddMenuItem (pMaster ,pSub, "PRG FILE ", 132  );
		  	pTest=AddMenuItem (pMaster ,pSub, "FRE FILE ", 133  );
		pSub=AddMenuItem (pMaster ,pMenu, "SELECT ", 14 );


	// Joystick stuff
	pJoystick1=AddBooleanGadget(pMaster,TICK,6,13);
	txt1=AddText(pMaster,16,14, "Enable Joystick 1");
	if ((JOYSTICK&1)!=0) pJoystick1->value=-1;
	pJoystick2=AddBooleanGadget(pMaster,TICK,6,23);
	if ((JOYSTICK&2)!=0) pJoystick2->value=-1;
	txt2=AddText(pMaster,16,23, "Enable Joystick 2");
	txt3=AddTextButton(pMaster, 100,12, 50,16,"Calabrate");

	// Command Line Option
	txt4=AddBooleanGadget(pMaster,TICK,6,33);
	txt5=AddText(pMaster,16,34, "50Hz Timer Active");
	if (TIMER_ON!=0) txt4->value=-1;
	txt6=AddBooleanGadget(pMaster,TICK,6,43);
	txt7=AddText(pMaster,16,44, "Sound Active");
	if (SOUND!=0) txt6->value=-1;
	txt10=AddBooleanGadget(pMaster,TICK,6,53);
	txt11=AddText(pMaster,16,54, "Samples Active.");
	if (SB_ON!=0) txt10->value=-1;

	txt8=AddBooleanGadget(pMaster,TICK,6,63);
	txt9=AddText(pMaster,16,64, "VBlank Syncing");
	if (DOVBLANK!=0) txt8->value=-1;

}

		
//************************************************************
//                                                           *
//   Name    : MakeCompTable                                 *
//   Function: this creates an array for comparing a register*
//             and what flags we get back from it.           *
//                                                           *
//************************************************************

extern	uint8		*pCompTable2;
extern	uint8		CompTable;

void MakeCompTable( void )
{
	uint8		*pCompTable=&CompTable;
	uint8		F;
	uint16	test;
	
	pCompTable_old=MyMalloc(512);
	pCompTable2=(uint8*) (((uint32) pCompTable_old+255)&0xffffff00);

	for (test=0;test<256;test++){
		F=0;
		if ((test & 128)==128) {F|=_N;}
		if (test==0) {F|=_Z;}
		pCompTable[test]=F;
		pCompTable2[test]=F;
	}
}
	
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void (__interrupt __far *Old_Timer_Isr)();
int32	Icount=0;
#define	TIMER_VEC	0x1c
#define	_50Hz			23863
#define	_60Hz			19886
#define	_SYSTEMTIME	0xFFFF

void __interrupt __far Timer ( void )
{
	Icount++;
	VBLANK=1;
	Old_Timer_Isr();
}


void TimerOff( void )
{
	_dos_setvect (TIMER_VEC, Old_Timer_Isr );
	SetTimer ( _SYSTEMTIME );
}
void TimerOn ( void )
{
	Old_Timer_Isr=_dos_getvect( TIMER_VEC );	// get timer interrupt vector.
	_dos_setvect (TIMER_VEC, Timer);
	SetTimer ( _50Hz );
}

#define	CONTROL_8253	0x43
#define	CONTROL_WORD	0x3c
#define	COUNTER_0		0x40
#define	COUNTER_1		0x41
#define	COUNTER_2		0x42


void SetTimer ( uint32 val )
{
	outp ( CONTROL_8253, CONTROL_WORD );
	outp ( COUNTER_0,  (val&255) );
	outp ( COUNTER_0, ((val>>8)&255) );
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
extern	uint32			SBcount;

void main ( int Count, char *argv[] )
{
	char		key;
	uint32	i;
	char		*Param;
	uint8		startdebug=0;

	AutoLoadName[0]=0x0;
	InitMalloc ();
	SBcount=0;
	//
	// If you ADD anything to Minus4, feel free to add your name
   // here. But remember to send me a copy, complete with source!
	//
	printf ("\nMinus4 - The Plus/4 Emulator Version 1.6.1\n");
	printf ("   Copyright (C) Mike Dailly 1996,97,98\n\n\n");

	pSourceFile=NULL;
	SB_ON=1;
	TapeEdge=3;
	CurrentDisk[0]=0x0;
	pCurrPath=getcwd(NULL,0);
	pFileName=NULL;
	if (Count>1){
		pFileName=argv[1];
		if (strcmp (pFileName,"/?")==0) { //OR (pFileName=="-?"))
			printf ("\nminus4 [options]");
			printf ("\n-x = Enable ModeX and use 360x240x256col");
			printf ("\n-X = Enable ModeX and use 360x240x256col 50Hz");
			printf ("\n-c = Do Modex copy mode 2");
			printf ("\n-a = Disable AUDIO.");
			printf ("\n-t = Disable 50Hz/60Hz Timer");
			printf ("\n-s = \"DISABLE\" soundblaster samples.");
			printf ("\n-v = Enable vertical blank sync.");
			printf ("\n-d = Start in debug mode.");
			printf ("\n-l = Disable \"loading bar\".");
			printf ("\n-S = Disable symbol table");
			printf ("\n-[1-5] = Set tape edge detect level, 4 = Default");
			printf ("\n-D <Games Directory>= Set games directory");
			printf ("\n-p <filename.prg> <sys???\/run>= AutoLoad .PRG file+RUN command");
			printf ("\n-L <debugfile.LST> enable source level debugging");
			printf ("\n\n");
			exit (1);
		}
		pFileName=NULL;
		for (i=1;i<Count;i++){
			if (strcmp(argv[i],"-1")==0) TapeEdge=0;
			if (strcmp(argv[i],"-2")==0) TapeEdge=1;
			if (strcmp(argv[i],"-3")==0) TapeEdge=2;
			if (strcmp(argv[i],"-4")==0) TapeEdge=3;
			if (strcmp(argv[i],"-5")==0) TapeEdge=4;

			if (strcmp(argv[i],"-x")==0) ModeX=1;
			if (strcmp(argv[i],"-X")==0) ModeX=2;
			if (strcmp(argv[i],"-c")==0) DOCOPYSCREEN=1;
			if (strcmp(argv[i],"-v")==0) DOVBLANK=1;
			if (strcmp(argv[i],"-d")==0) startdebug=1;
			if (strcmp(argv[i],"-a")==0) SOUND=0; 
			if (strcmp(argv[i],"-t")==0) TIMER_ON=0; 
			if (strcmp(argv[i],"-s")==0) SB_ON=0; 
			if (strcmp(argv[i],"-l")==0) LoadingBar=1;
			if (strcmp(argv[i],"-S")==0) SymbolTable=0;		// disable symbol table
			if (strcmp(argv[i],"-D")==0) pFileName=argv[i+1];
			if (strcmp(argv[i],"-p")==0) { sprintf (&AutoLoadName[0],"%s",argv[i+1]);
													 sprintf (&AutoRun[0],"%s",argv[i+2]);
												  }
			if (strcmp(argv[i],"-L")==0) { sprintf (&SourceFile[0],"%s",argv[i+1]);
													 pSourceFile=&SourceFile[0];
												  }
		}
	}

	if (pSourceFile!=NULL){
		LoadSourceFile(pSourceFile);
	}


	//
	// if sound blaster active, disable timer.
	//
	if (SB_ON==0){
	   if (TIMER_ON==1){
		   TimerOn();
	   }
	} else {
		TIMER_ON=0;
	}

	//
	// Make a GOOD base path
	//
	if (pFileName!=NULL){
	   if (pFileName[Len(pFileName)-1]!='\\'){
		   sprintf (&FileName[0],"%s\\",pFileName);
	   } else {
		   sprintf (&FileName[0],"%s",pFileName);
	   }
	} else {
		strcpy (FileName,".\\");
	}
	pFileName=&FileName[0];


	//
	// Make compare table
	//
	for (i=0;i<256;i++){
		Table[i]=i&0xff;
		if (C_Table[i]!=0x20) Table[i]=C_Table[i];
	}
	

	pFileSystem=MyMalloc(256000);				// allocate 256K for file system
	Initialise_Keyboard ();
	MakeCompTable();
	Init6502();
	InitSound();
	InitSB ();
	printf ("Init 8501:\n");
	InitScreen ();
	
	InitSystem (Screen,368,240);				// Tell WINDOW system screen address and size
	EnableMouse=0;

   printf ("\n-------------------------------------------------\n\n");

	debug=startdebug;
	SetMode(3);

	
   if (AutoLoadName[0]!=0x0){
		BreakPoints[0xd90a]=1;			// set AUTORUN break point
   }

	while (EXIT_PRG==0){
		if (debug==0){
		
			ScreenMode=BitMapScreen;
			InitScreen ();
			Cls();
			WaitVBlank();
			Play();      							// Sync play as close as we can to VBLANK

			_screen=1;
			Process2();

         if (AutoLoadName[0]!=0x0){
				BreakPoints[0xd90a]=0;			// clear autorun break point
				LoadGame(&AutoLoadName[0]);
				AutoLoadName[0]=0x0;
				Poke(0xef,Len(&AutoRun[0])+1 );		// set buffer size+RET
				for (i=0;i<Len(&AutoRun[0]);i++){
					if ((AutoRun[i]>='a') AND (AutoRun[i]<='z')){
						AutoRun[i]=AutoRun[i]-32;
					}
					Poke(0x527+i,AutoRun[i]);		// set buffer size
				}
				Poke(0x527+i,0xd);		// set buffer size
         }else{
				if (pSourceFile!=NULL){
					SetMode50(3);			// 50 line mode for SOURCE level debugger
			   }else{
				   SetMode(3);				// normal mode for NO source
				}
			   debug=1;
			}
		} else{
			ScreenMode=CharScreen;
			_screen=1;
			CopyScreen (0);
			Process();
			debug=0;
		}
	}
	SetMode(3);
	Restore_Keyboard ();
	ShutDownSound();
	DisableSB ();
	
	if (TIMER_ON==1){
		TimerOff();
	}


	// ******************************************************
	//
	// Free memory..
	//
	// ******************************************************
	MyFree(pMemory);
	MyFree(MemoryWrite);
	MyFree(MemoryRead);
	MyFree(MemoryRead2);
	for (i=0;i<MAXROM;i++){
		if(pROMS[i]!=NULL) MyFree(pROMS[i]);
	}
	MyFree(pCompTable_old);
	MyFree(pFileSystem);
	MyFree(Screen);
	ShutDownWindows();

	if (pSourceFile!=NULL){
		FreeSourceFile(pSourceFile);
	}

	// Did we finish loading a tape? if not... free it first
	if (pHeader!=NULL) MyFree(pHeader);


	// make sure everything has been shut down
	if ((MallocCount!=0) OR (MemoryTotal!=0)){
		printf ("Error: Calls left=%d, Memory still being used=%d bytes\n",MallocCount,MemoryTotal);
	}
}



