        org   $1001
        .byte $01,$10           ; LOAD address


        .byte $12,$10           ; next line number
        .byte $00,$00           ; ?
        .byte $9e               ; SYS
        .byte $34,$31,$31,$37   ; 4117
        .byte $20
        .byte $4d,$49,$4e,$55,$43,$34
        .byte $00
        .byte $00
        .byte $00
        .byte $00

        sei
        sta   $ff3f             ; ROM out

        ;----------------------------------------------------------------------
        ;
        ; This copies the "file copier" into zero page (a safe place to run)
        ;
        ;----------------------------------------------------------------------

        ldx   #EndSmall-StartSmall    ; copy "small" copier down
SmallLp lda   STARTCOPY+1,x
        sta   $c0,x
        dex
        bpl   SmallLp
STARTCOPY
        jmp   $00c0


        ;----------------------------------------------------------------------
        ;
        ; This small chunk copies the WHOLE file to $100 and up.
        ; Since it would overwrite the actual copy it must be BELOW (or above).
        ; Zero page is a perfect place for it...
        ;
        ;----------------------------------------------------------------------

        org   $c0
StartSmall
        ldy   #0
        sty   $fd  
        lda   #$01              ; store Dest addr (hi)
        sta   $fe

        lda   #STARTUNPACK      ; store START addr
        sta   $fb               
        lda   #STARTUNPACK/$100
        sta   $fc

Lp1     lda   ($fb),y
        sta   ($fd),y
        inc   $fb
        bne   Skip1
        inc   $fc
Skip1   
        inc   $fd
        bne   Skip2
        inc   $fe

Skip2   lda   $fb
LABEL1  cmp   #ENDUNPACK              ; self mod here
        bne   Lp1
        lda   $fc
LABEL2  cmp   #ENDUNPACK/$100         ; self mod here
        bne   Lp1
        jmp   $100
EndSmall


        ;----------------------------------------------------------------------
        ;
        ; This is the actual unpacker. it sits at $100 to about $1d0 (bit close)
        ; Theres a few places this could be "shrunk" But a better packer would
        ; be nicer....
        ; we also want to avoid using the stack (if we can), since theres not 
        ; "much" space left.
        ;
        ;----------------------------------------------------------------------
        org   $100
unpack
        sei
        lda   #$fa              ; set START address (fixed)
        sta   $fd
        lda   #$00
        sta   $fe

        clc
        lda   size+1            ; Get SIZE of data 
        sta   countlo           ; don't need this now, as "size" is next to it!
        adc   #$D5              ; add on BASE of pack data
        sta   $fb
        lda   size
        sta   counthi
        adc   #$01
        sta   $fc


;---------------------------
; Get compression token
;---------------------------
GetToken
        ldy   #$00
        lda   ($fb),y
        cmp   #$80
        bcc   DoRun
        sbc   #$80              ; carry already set from CMP/BRANCH above
        iny                     ; flag as a COPY

DoRun   sta   $ff
        sec
        lda   $fd
        sbc   $ff
        sta   $fd
        lda   $fe
        sbc   #$00
        sta   $fe

        cpy   #1                ; are we doing a COPY?
        beq   DoCopy

;---------------------------
; decompress a copy
;---------------------------

        sec                     ; add 2(min) sec, and adc#1
        lda   $fb
        sbc   #$02
        sta   $fb
        lda   $fc
        sbc   #$00
        sta   $fc

        iny                     ; get FILL byte
        lda   ($fb),y
        ldy   $ff
FillLoop
        sta   ($fd),y
        dey    
        bpl   FillLoop

        lda   #$01
        sta   $ff
        jmp   Check

;---------------------------
; decompress a copy
;---------------------------
DoCopy 
        clc
        lda   $fb
        sbc   $ff
        sta   $fb
        lda   $fc
        sbc   #$00
        sta   $fc

        ldy   $ff               ; store counter (for subtract later)
CopyLoop
        lda   ($fb),y
        sta   ($fd),y
        dey
        bpl   CopyLoop
        inc   $ff               ; +1 for count dec

        sec                     ; Next Token
        lda   $fb
        sbc   #$01
        sta   $fb
        lda   $fc
        sbc   #$00
        sta   $fc

Check
        sec                     ; Next Token
        lda   $fd
        sbc   #$01
        sta   $fd
        lda   $fe
        sbc   #$00
        sta   $fe

        clc
        lda   countlo
        sbc   $ff
        sta   countlo
        lda   counthi
        sbc   #$00
        sta   counthi
        ora   countlo
        beq   EndOfUnpack
        jmp   GetToken

        ;
        ; This does the restart... its can be shrunk a lot using
        ; self-mod code.
        ;
EndOfUnpack   
        ldx   $fd         ; get STACK ptr (unpack ends at top of stack)
        txs
        pla
        sta   jump+2      ; get START address
        pla   
        sta   jump+1
        pla
        tax
        sta   $fdd0,x     ; select ROM
        pla
        tax
        sta   $ff3e,x     ; select RAM/ROM
        pla   
        sta   $ff         ; we could do a loop here.. still 15 bytes
        pla   
        sta   $fe
        pla   
        sta   $fd
        pla   
        sta   $fc
        pla   
        sta   $fb
        pla
        tax
        pla
        tay
        pla
        plp
jump    jmp   jump        ; continue game!


countlo .byte 0
counthi .byte 0
size          .byte

EndPack       .byte

EEE     EQU   EndSmall-StartSmall    ; copy "small" copier down
AAA     EQU   EndPack-unpack
BBB     EQU   LABEL1-StartSmall
CCC     EQU   BBB+2
DDD     EQU   LABEL2-StartSmall
FFF     EQU   DDD+2

ENDCOPY       EQU   STARTCOPY+EEE+1
STARTUNPACK   EQU   ENDCOPY
ENDUNPACK     EQU   STARTUNPACK+AAA
SELFMOD1      EQU   STARTCOPY+CCC
SELFMOD2      EQU   STARTCOPY+FFF

