//******************************************************************************
//									 																	 *
//							 																			 *
//								Window control system											 *
//																										 *
//									  C Frame work							  						 *
//																										 *
//						     Copyright Mike Dailly 1996   									 *
//                                                                             *
//																										 *
// Ver 1.0		MD			Basic windows and buttons and mouse control				 *
//                      Added in window resizing and draging                   *
//                      Added in virtual window size using sliders             *
//                      Added in custom backdrops+window options               *
//                      Added multi-window support for windows-in-windows      *
//                      Fixed bug in sysblock+syssprite routines (clipping)    *
//                                                                             *
//                                                                             *
// Ver 1.1		MD			Added V1 of prop sliders (Horiz+vert)						 *
//                      Added in printing routines. Prop+fixed                 *
//                      Added TEXT gadgets                                     *
//                      Added text+integer gadgets                             *
//                      Added in text buttons.                                 *
//                                                                             *
// Ver 1.2	   MD			Changed most gadgets over to a structured system 		 *
//                      (Line drawn approch) allowing window+pen colours       *
//                      Added window+gadget colour systems                     *
//                      Added V1 of menu system                                *
//                      Fix prop bug. Didnt do 0 length values (ie 10 to 10)   *
//                      Fix prop bug. Didnt do neg values (ie -100 to +100)    *
//                      Prop-gadget now V1.1                                   *
//                                                                             *
// Ver 1.3		MD			Fixed menu system V1.1 (general fixes)						 *
//                      Added Load command.                                    *
//                                                                             *
//                                                                             *
//******************************************************************************
//#define __WindowInterfaceCalls__

#include <stdio.h>
#include <fcntl.h>
#include <math.h>
#include <dos.h>
#include "headers\md.h"
#include "headers\all.h"
#include "headers\screen.h"
#include "headers\draw.h"
#include "headers\wind.h"


#define	CURSOR	'#'
#define	WHITE		0
#define	LGRAY		1
#define	MGRAY		2
#define	DGRAY		3
#define	BLACK		4
#define	BARYSIZE	11

extern	uint32	MemoryTotal;

typedef	struct {
		int16	cx1;
		int16	cy1;
		int16	cx2;
		int16	cy2;
}clips;


	uint8 DefaultColours[]={
				0x00,0x00,0x00,	0x6F,0x4A,0x25,	0xFF,0xF5,0x00,
				0x05,0x40,0x00,	0x08,0x84,0x00,	0x04,0xCC,0x00,
				0x00,0x60,0xB0,	0x35,0x90,0xFF,	0x6F,0xAA,0xF0,
				0x80,0x00,0x00,	0xC0,0x00,0x00,	0xFF,0x7A,0x00,
				0x40,0x40,0x40,	0x80,0x80,0x80,	0xC0,0xC0,0xC0,
				0xFF,0xFF,0xFF};


	uint8	MousePointer[]={
		0xFC,0xFD,0xFD,0xFC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0xFD,0xFE,0xFF,0xFE,0xFD,0xFC,0x00,0x00,0x00,0x00,0xFC,0xFD,0xFD,0xFC,0x00,0x00,
		0xFD,0xFE,0xFF,0xFF,0xFE,0xFD,0xFC,0x00,0xFC,0xFC,0xFD,0xFF,0xFE,0xFD,0x00,0x00,
		0xFC,0xFD,0xFE,0xFF,0xFF,0xFE,0xFE,0xFD,0xFE,0xFF,0xFE,0xFD,0xFF,0xFE,0xFC,0x00,
		0x00,0xFC,0xFD,0xFE,0xFF,0xFF,0xFF,0xFE,0xFD,0xFE,0xFF,0xFE,0xFF,0xFF,0xFD,0x00,
		0x00,0x00,0x00,0xFC,0xFD,0xFF,0xFF,0xFF,0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,0x00,
		0x00,0x00,0xFC,0xFC,0xFC,0xFD,0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,0x00,
		0x00,0xFC,0xFD,0xFE,0xFD,0xFC,0xFD,0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFD,0x00,
		0x00,0xFD,0xFE,0xFF,0xFE,0xFD,0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,0xFA,0xFA,0xF9,
		0x00,0xFC,0xFD,0xFE,0xFF,0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,0xFA,0xFA,0xFA,0xF9,
		0x00,0x00,0xFC,0xFD,0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xFE,0x15,0xFB,0xFA,0xFA,0xF9,
		0x00,0x00,0x00,0xFC,0xFD,0xFE,0xFF,0xFF,0xFE,0xFE,0xFA,0xFB,0xFA,0xFA,0xFA,0xF9,
		0x00,0x00,0x00,0x00,0x00,0x00,0xFC,0xFD,0xFD,0xF9,0xFA,0xFA,0xFA,0xFA,0xF9,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF9,0xF9,0xF9,0xF9,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};


		int16		aPropFont[]={6,6,7,6,6,6,6,6,6,6,6,6,6,6,7,7,4,4,4,4,6,5,6,6,6,6,6,6,5,7,6,6,
									 6,2,4,6,6,6,6,3,3,3,6,4,3,4,2,6,5,4,5,5,5,5,5,5,5,5,3,3,4,4,4,5,
									 6,6,6,6,6,5,5,6,5,4,5,6,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,4,6,4,5,6,
									 4,5,5,5,5,5,5,5,5,2,3,4,2,6,5,5,5,5,4,4,4,5,6,6,4,5,4,4,2,4,6,6,
									 
									 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
									 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
									 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
									 6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6};

		
			tWindow	ScreenWindow;
			tWindow	*pWScreen;
			tWindow	HardwareWindow;
			tWindow	*pHardware;
			tMouse	MouseData;
			tMouse	*pMouse;
			tWindow	*pDefaultWindow;				// Keep a list of all windows!
			tWindow	*pFirstWindow;				// Keep a list of all windows!
			tWindow	*pLastWindow;
			uint8		EnableMouse;
			uint8		*GadBit;

			int16		mclicky,mclicky;
			int16		Lastmx,Lastmy;
			int16		CurrentFunction;
			uint8		*FontDat;
			tFont		*pFont,Font;
			int16		lbut;
			int16		FoundWindow;
			tWindow	*pButWindow;
			int16		BGxoff;
			int16		BGyoff;
			tGadget	*pButGadget;
			int16		BWxoff;
			int16		BWyoff;

			int16		clipsp;
			clips		clipstack[20];			

			char		key;	
			int16		EditMode;
			int16		Edindex;
			tGadget	*pEdGadget;

			uint8		DefDrawCols[5];
			uint8		DrawCols[5];
			uint8		PenColour;
			tMenu		*pSelected;
			tMenu		*pLastSelected;
			int16		MenuRefresh;
			int16		MenuLast;
			tWindow	*pMenuWindow;
			uint32	FileSize;
			int16		mousex,mousey;
			int16		mousebut;

//***********************************************************
//                                                          * 
//   Name    : SetColour                                    * 
//   Function: Sets a colour register to an R,G,B value     * 
//                                                          * 
//   In   : ColR=Colour Register to change                  * 
//          R   = Red   Colour Value                        * 
//          G   = Green Colour Value                        * 
//          B   = Blue  Colour Value                        * 
//   Out  : None                                            * 
//                                                          * 
//                                                          *
//***********************************************************

void	WIN_SetColour (int ColR, int R, int G, int B)
{
	outp ( ColourNo,   (unsigned char) ColR );
	outp ( ColourAttr, (unsigned char) R);// >> 2);
	outp ( ColourAttr, (unsigned char) G);// >> 2);
	outp ( ColourAttr, (unsigned char) B);// >> 2);
}



//************************************************************
//                                                           *
//   Name    : FileSize                                      *
//   Function: Get the size of a file                        *
//                                                           *
//   In   : char *name = pointer to the file name.           *
//   Out  : FileSize, or 0 if an error.                      *
//                                                           *
//************************************************************

uint32	GetFileSize (char *name)
{
	int				done;
	struct find_t	ffblk;

	done = _dos_findfirst( name,_A_NORMAL,&ffblk );
	_dos_findclose(&ffblk);
	if (done) return 0;
	return ffblk.size;			
}




//************************************************************
//                                                           *
//   Name    : Load                                          *
//   Function: Load in a file to memory                      *
//                                                           *
//   In   : char  *name = pointer to the file name.          *
//   Out  : uint8 *     = pointer to the loaded data         *
//                       Or NULL=error                       *
//                                                           *
//************************************************************

uint8  *WindLoad(char *name)
{
	int				handle;
	unsigned			bytes;
	struct find_t	ffblk;
	int				done;
	char 				*LoadData;
	char 				*temp;
	long				tempsize;
	int				BlockSize;


	FileSize=GetFileSize(name);					// get size of required buffer
	if (FileSize==0) return NULL;				// File not found, exit with error


	if ( _dos_open ( name, O_RDONLY, &handle ) != 0   ) return NULL;
	if ( (LoadData=( char *) MyMalloc (FileSize)  ) == NULL) return NULL;

	tempsize=FileSize;
	temp=LoadData;
	do{
		if (tempsize>0x8000) { BlockSize=0x8000; } else { BlockSize=tempsize; }
		if (_dos_read(handle, temp, BlockSize, &bytes) != 0)
		{
			MyFree(LoadData);
			LoadData=  NULL;
			return     NULL;
		}

		tempsize-= 0x8000;
		temp    += 0x8000;
	} while ( tempsize>0 );



	_dos_close (handle);
	return LoadData;
}

//************************************************************
//                                                           *
//   Name    : Save                                          *
//   Function: Save memory to file                           *
//                                                           *
//   In   : char *name = pointer to the file name.           *
//          uint8 *data= pointer to data to save             *
//          Size       = size of file                        *
//   Out  : none                                             *
//                                                           *
//************************************************************

void    WindSave(char *name, uint8 *Data, uint32 Size)
{
        int                             handle;
        unsigned                        bytes;
        struct find_t   ffblk;
        int                             done;
        char                            *LoadData;
        char                            *temp;
        long                            tempsize;
        int                             BlockSize;


        handle=open (name,O_RDWR|O_CREAT|O_BINARY);

        tempsize=Size;
        temp=Data;
        do{
                        if (tempsize>0x8000) { BlockSize=0x8000; } else { BlockSize=tempsize; }
                        done=write(handle, temp, BlockSize);
            tempsize-= 0x8000;
            temp    += 0x8000;
        } while ( tempsize>0 );

        close (handle);
        return;
}



//************************************************************
//                                                           *
//   Name    : PopClip() PushClip()                          *
//   Function: push and pop clip windows                     *
//                                                           *
//************************************************************
void PopClip (tWindow *pWindow)
{
	clipsp--;
	pWindow->clipx1=clipstack[clipsp].cx1;
	pWindow->clipy1=clipstack[clipsp].cy1;
	pWindow->clipx2=clipstack[clipsp].cx2;
	pWindow->clipy2=clipstack[clipsp].cy2;
}

void PushClip (tWindow *pWindow)
{
	clipstack[clipsp].cx1=pWindow->clipx1;
	clipstack[clipsp].cy1=pWindow->clipy1;
	clipstack[clipsp].cx2=pWindow->clipx2;
	clipstack[clipsp].cy2=pWindow->clipy2;
	clipsp++;
}


//************************************************************
//                                                           *
//   Name    : SetSubWindow                                  *
//   Function: Sets a window inside another window, making   *
//             sure it does NOT go out side the larger window*
//             and clipping it if it does.                   *
//                                                           *
//   In   : pWindow = window for new clip window             *
//          x1,y1,x2,y2 = new clip window                    *
//   Out  : none                                             *
//                                                           *
//************************************************************

void SetSubWindow (tWindow *pWindow, int32 x1,int32 y1,int32 x2,int32 y2)
{
	int32	cx1,cx2,cy1,cy2;	

	cx1=pWindow->clipx1;
	cy1=pWindow->clipy1;
	cx2=pWindow->clipx2;
	cy2=pWindow->clipy2;

	PushClip(pWindow);
	if (y1<cy1) {
		y1=cy1;
	}
	if (y2>cy2) {
		y2=cy2;
	}
	if (x1<cx1) {
		x1=cx1;
	}
	if (x2>cx2) {
		x2=cx2;
	}


	pWindow->clipx1=x1;
	pWindow->clipy1=y1;
	pWindow->clipx2=x2;
	pWindow->clipy2=y2;

}


//************************************************************
//                                                           *
//   Name    : SystemLine                                    *
//   Function: Draw a line into a variable size buffer       *
//                                                           *
//   In   : Window = Window Structure address                *
//          x1,y1,x2,y2 = cords                              *
//          xsize  = xscreen size                            *
//          col = pixel colour                               *
//   Out  : none                                             *
//                                                           *
//                                                           *
//************************************************************

void  SysLine ( tWindow *pWindow, int x1, int y1, int x2, int y2, int col )
{
	char	*Scr;
	int32	Dx,Dy,count;
	int32	aDx,aDy;
	int16	x,y,cx1,cy1,cx2,cy2,xsize;
	int32	sign;
	char  a;
	uint8	*BitMap;

	cx1=pWindow->clipx1;
	cy1=pWindow->clipy1;
	cx2=pWindow->clipx2;
	cy2=pWindow->clipy2;
	xsize=pWindow->maxxsize;
	BitMap=pWindow->BitMap;

	x2=x2-x1;
	y2=y2-y1;
	aDx=abs(x2);
	aDy=abs(y2);
	if (aDx>aDy)	 {
		if (x2>0) {
			Dx=0x10000;
		} else {
			Dx=-0x10000;
		}
		Dy=(y2<<16)/aDx;
		count=aDx;
	} else {
		if (y2>0) {
			Dy=0x10000;
		} else {
			Dy=-0x10000;
		}
		Dx=(x2<<16)/aDy;
		count=aDy;
	}

	x1=x1<<16;
	y1=y1<<16;
	a=col;
	do {
		x=x1>>16; y=y1>>16;
		if  ((x<cx2) AND (y<cy2) AND (x>=cx1) AND (y>=cy1)) {
			Scr=BitMap+(x+(y*xsize));
			*Scr=a;
		}
		x1=x1+Dx;
		y1=y1+Dy;
		count=count-1;
	} 
	while (count>0);
}

//************************************************************
//                                                           *
//   Name    : SysBox                                        *
//   Function: Draw a box into a window with colour          *
//                                                           *
//************************************************************/

void SysBox (tWindow *pWindow, int16 x1,int16 y1,int16 x2,int16 y2,uint8 col)
{
	SysLine (pWindow, x1,y1,x2,y1,col);
	SysLine (pWindow, x2,y1,x2,y2,col);
	SysLine (pWindow, x2,y2,x1,y2,col);
	SysLine (pWindow, x1,y2,x1,y1,col);
}


//************************************************************
//                                                           *
//   Name    : SysBox                                        *
//   Function: Draw a box into a window with colour          *
//                                                           *
//************************************************************/

void SysFillBox (tWindow *pWindow, int16 x1,int16 y1,int16 x2,int16 y2,uint8 col)
{
	int16	i;

	for (i=y1;i<y2+1;i++){
		SysLine (pWindow, x1,i,x2,i,col);
	}
}



/*************************************************************
/*                                                           *
/*   Name    :                                               *
/*   Function:                                               *
/*                                                           *
/*   In   :                                                  *
/*   Out  :                                                  *
/*                                                           *
/*                                                           *
/*************************************************************/
void SysPlot (tWindow *pWindow,int16 x,int16 y,uint8 col)
{
	char	*Scr;
	int16	cx1,cy1,cx2,cy2,xsize;

	cx1=pWindow->clipx1;
	cy1=pWindow->clipy1;
	cx2=pWindow->clipx2;
	cy2=pWindow->clipy2;

	if ((x>=cx1) AND (x<cx2) AND (y>=cy1) AND (y<cy2)) {
		Scr=pWindow->BitMap+(x+(y*pWindow->maxxsize));
		*Scr=col;
	}
}

//************************************************************
//                                                           *
//   Name    : Box3D                                         *
//   Function: Print a 3D box at X,Y                         *
//                                                           *
//   In   : pWindow= window to print to                      *
//          x1,y1,x2,y2 = box cords                          *
//   Out  : none                                             *
//                                                           *
//************************************************************
void	Box3D (tWindow *pWindow, int32 x1,int32 y1, int32 x2, int32 y2)
{
//	SysBox  (pWindow,x1  ,y1  ,x2  ,y2  ,DrawCols[LGRAY]);
//	SysBox  (pWindow,x1+1,y1+1,x2+1,y2+1,DrawCols[DGRAY]);
//	SysBox  (pWindow,x1-1,y1-1,x2+2,y2+2,DrawCols[BLACK]);
//	SysBox  (pWindow,x1+2,y1+2,x2-1,y2-1,DrawCols[BLACK]);
//
//	SysPlot (pWindow, x1  ,y1,DrawCols[WHITE]);
//	SysPlot (pWindow, x2+1,y1,DrawCols[MGRAY]);
//	SysPlot (pWindow, x2  ,y1+2,DrawCols[MGRAY]);
//	SysPlot (pWindow, x1+2,y2,DrawCols[MGRAY]);
//	SysPlot (pWindow, x1  ,y2+1,DrawCols[MGRAY]);

	SysLine  (pWindow,x1  ,y1  ,x1  ,y2  ,DrawCols[BLACK]);
	SysLine  (pWindow,x1  ,y1  ,x2  ,y1  ,DrawCols[BLACK]);
	SysLine  (pWindow,x2  ,y2  ,x1  ,y2  ,DrawCols[LGRAY]);
	SysLine  (pWindow,x2  ,y2  ,x2  ,y1  ,DrawCols[LGRAY]);

}

//************************************************************
//                                                           *
//   Name    : DrawButtonUp                                  *
//   Function: Print a button UP                             *
//                                                           *
//   In   : pWindow= window to print to                      *
//          x1,y1,x2,y2 = button cords                       *
//   Out  : none                                             *
//                                                           *
//************************************************************
void	DrawButtonUp (tWindow *pWindow, int32 x1,int32 y1, int32 x2, int32 y2)
{
	SysFillBox (pWindow, x1,y1,x2,y2,DrawCols[MGRAY]);			// fill center

	SysLine (pWindow,x1+1,y1+1,x2-1,y1+1 ,DrawCols[LGRAY]);
	SysLine (pWindow,x1+1,y1+1,x1+1,y2-1 ,DrawCols[LGRAY]);
	SysLine (pWindow,x2-1,y2-1,x2-1,y1+1 ,DrawCols[DGRAY]);
	SysLine (pWindow,x2-1,y2-1,x1+1,y2-1 ,DrawCols[DGRAY]);
	SysBox  (pWindow,x1  ,y1  ,x2  ,y2  ,DrawCols[BLACK]);

	SysPlot (pWindow, x1+1,y1+1,DrawCols[WHITE]);
}


//************************************************************
//                                                           *
//   Name    : DrawButtonDown                                *
//   Function: Print a button Down                           *
//                                                           *
//   In   : pWindow= window to print to                      *
//          x1,y1,x2,y2 = button cords                       *
//   Out  : none                                             *
//                                                           *
//************************************************************
void	DrawButtonDown (tWindow *pWindow, int32 x1,int32 y1, int32 x2, int32 y2)
{
	SysFillBox (pWindow, x1,y1,x2,y2,DrawCols[MGRAY]);			// fill center

	SysBox  (pWindow,x1  ,y1  ,x2  ,y2  ,DrawCols[BLACK]);
	SysLine (pWindow,x1+1,y1+1,x2  ,y1+1 ,DrawCols[DGRAY]);
	SysLine (pWindow,x1+1,y1+1,x1+1,y2 ,DrawCols[DGRAY]);
}


void DrawVBar(tWindow *pWindow, int16 x1,int16 y1,int16 x2,int16 y2)
{
	SysLine (pWindow,x1+1,y1+1,x1+1,y2-1 ,DrawCols[LGRAY]);
	SysLine (pWindow,x1+2,y1+1,x1+2,y2-1 ,DrawCols[DGRAY]);
	SysBox  (pWindow,x1  ,y1  ,x2-1 ,y2-1 ,DrawCols[BLACK]);
}

void DrawHBar(tWindow *pWindow, int16 x1,int16 y1,int16 x2,int16 y2)
{
	SysLine (pWindow,x1+1,y1+1,x2-1,y1+1 ,DrawCols[LGRAY]);
	SysLine (pWindow,x1+2,y1+2,x2-1,y1+2 ,DrawCols[DGRAY]);
	SysBox  (pWindow,x1  ,y1  ,x2-1,y1+3 ,DrawCols[BLACK]);
}

//************************************************************
//                                                           *
//   Name    : SetPen                                        *
//   Function: Set the pen colours from light to dark        *
//                                                           *
//   In   : white down to black                              *
//   Out  : none                                             *
//                                                           *
//                                                           *
//************************************************************

void SetPenColour (uint8 Col)
{
	PenColour=Col;
}
void SetDefaultPen (uint8 wh, uint8 lg, uint8 mg, uint8 dg, uint8 bl)
{
	DefDrawCols[WHITE]=wh;
	DefDrawCols[LGRAY]=lg;
	DefDrawCols[MGRAY]=mg;
	DefDrawCols[DGRAY]=dg;
	DefDrawCols[BLACK]=bl;
}


void SetWindowPen (tWindow *pWindow, uint8 wh, uint8 lg, uint8 mg, uint8 dg, uint8 bl)
{
	if (pWindow==NULL) {
	   DefDrawCols[WHITE]=wh;
	   DefDrawCols[LGRAY]=lg;
	   DefDrawCols[MGRAY]=mg;
	   DefDrawCols[DGRAY]=dg;
	   DefDrawCols[BLACK]=bl;
	} else {
	   pWindow->DrawCols[WHITE]=wh;
	   pWindow->DrawCols[LGRAY]=lg;
	   pWindow->DrawCols[MGRAY]=mg;
	   pWindow->DrawCols[DGRAY]=dg;
	   pWindow->DrawCols[BLACK]=bl;
	}
}


void SetGadgetPen (tGadget *pGadget, uint8 wh, uint8 lg, uint8 mg, uint8 dg, uint8 bl)
{
	pGadget->DrawCols[WHITE]=wh;
	pGadget->DrawCols[LGRAY]=lg;
	pGadget->DrawCols[MGRAY]=mg;
	pGadget->DrawCols[DGRAY]=dg;
	pGadget->DrawCols[BLACK]=bl;
	pGadget->flags|=gCOLOUR;				// set colour override
}


//************************************************************
//                                                           *
//   Name    : ResetMouse                                    *
//   Function: Reset the mouse system. graphics, sizes etc.  *
//                                                           *
//************************************************************

void	ResetMouse ( void )
{
	MouseData.pHand=&MousePointer;
	MouseData.clickx=0;
	MouseData.clicky=0;
	MouseData.xsize=16;
	MouseData.ysize=16;
	MouseData.xoffset=0;
	MouseData.yoffset=0;
	pMouse=&MouseData;
}

//************************************************************
//                                                           *
//   Name    : SetMouse                                      *
//   Function: Sets the current mouse pointer                *
//                                                           *
//   In   : MouseData = pointer to mouse structure           *
//   Out  : none                                             *
//                                                           *
//************************************************************

void	SetMouse ( tMouse *MouseData )
{
	pMouse=MouseData;
}
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void SetDefaultColours( void )
{
	int16	i,i2;
	uint8	a,b,c;

	i2=0;
	for (i=240;i<256;i++){
		a=DefaultColours[i2]>>2;
		b=DefaultColours[i2+1]>>2;
		c=DefaultColours[i2+2]>>2;
		i2+=3;

		WIN_SetColour(i,a,b,c);
	}
}
//************************************************************
//                                                           *
//   Name    : InitSystem                                    *
//   Function: Init the entire window system                 *
//                                                           *
//************************************************************

void InitSystem ( uint8 *ScreenAddress, int32 xsize, int32 ysize )
{
	int16	i,i2;
	uint8	a,b,c;

	GadBit=(uint8 *) &GadData;


	EnableMouse=1;
	clipsp=0;
	MenuLast=0;
	pSelected=NULL;
	pLastSelected=NULL;

	SetDefaultColours();
	SetDefaultPen (255,254,253,252,240);
	SetPenColour (255);

	ResetMouse();

	Font.pBitMap=(uint8 *) &FontData;				// Init FONT data. Font 1 is prop
	Font.pTable=&aPropFont;
	Font.xsize=6;
	Font.ysize=6;
	pFont=&Font;

	EditMode=0;
	pEdGadget=NULL;

	//
	//	Create a system screen window structure. this means that printing to
	// this is just like printing to a normal window. You could add another
	//	that points directly to the screen hardware. Then use the normal redraw
	//	to render multiple screens. Cool huh?
	//

	ScreenWindow.x=0;
	ScreenWindow.y=0;
	ScreenWindow.xsize=xsize;
	ScreenWindow.ysize=ysize;
	ScreenWindow.maxxsize=xsize;
	ScreenWindow.maxysize=ysize;
	ScreenWindow.clipx1=0;
	ScreenWindow.clipy1=0;
	ScreenWindow.clipx2=xsize;
	ScreenWindow.clipy2=ysize;
	ScreenWindow.minx=0;
	ScreenWindow.miny=0;
	ScreenWindow.maxx=xsize-1;
	ScreenWindow.maxy=ysize-1;
	ScreenWindow.offsetx=0;
	ScreenWindow.offsety=0;
	ScreenWindow.vxsize=0;
	ScreenWindow.vysize=0;
	ScreenWindow.vscrollx=xsize;
	ScreenWindow.vscrolly=ysize;
	ScreenWindow.flags=0;
	ScreenWindow.Options=0;										//DRAGDROP|RESIZE|BORDERS;
	ScreenWindow.WindowColour=0;								// default wipe colour
	ScreenWindow.BitMap=ScreenAddress;						// point to system screen
	ScreenWindow.pBackDrop=NULL;								// No background pic
	ScreenWindow.pFont=pFont;									// a defualt font
	ScreenWindow.pFirstMenu=NULL;
	ScreenWindow.pFirstGadget=NULL;
	ScreenWindow.pLastGadget=NULL;
	ScreenWindow.pParentWindow=NULL;							// NO parent!
	ScreenWindow.pFirstChildWindow=NULL;
	ScreenWindow.pLastChildWindow=NULL;
	ScreenWindow.pNextWindow=NULL;							// next and last screen?
	ScreenWindow.pLastWindow=NULL;
	pWScreen=&ScreenWindow;

	

	HardwareWindow.x=0;											// VRAW hardware
	HardwareWindow.y=0;
	HardwareWindow.xsize=xsize;
	HardwareWindow.ysize=ysize;
	HardwareWindow.maxxsize=xsize;
	HardwareWindow.maxysize=ysize;
	HardwareWindow.clipx1=0;
	HardwareWindow.clipy1=0;
	HardwareWindow.clipx2=xsize;
	HardwareWindow.clipy2=ysize;
	HardwareWindow.minx=0;
	HardwareWindow.miny=0;
	HardwareWindow.maxx=xsize-1;
	HardwareWindow.maxy=ysize-1;
	HardwareWindow.offsetx=0;
	HardwareWindow.offsety=0;
	HardwareWindow.vxsize=0;
	HardwareWindow.vysize=0;
	HardwareWindow.vscrollx=xsize;
	HardwareWindow.vscrolly=ysize;
	HardwareWindow.flags=0;
	HardwareWindow.Options=0;
	HardwareWindow.WindowColour=0;							// default wipe colour
	HardwareWindow.BitMap=(uint8 *) 0xa0000;				//ScreenAddress;						// point to system screen
	HardwareWindow.pBackDrop=NULL;							// No background pic
	HardwareWindow.pFont=pFont;								// a defualt font
	HardwareWindow.pFirstMenu=NULL;
	HardwareWindow.pFirstGadget=NULL;
	HardwareWindow.pLastGadget=NULL;
	HardwareWindow.pParentWindow=NULL;						// NO parent!
	HardwareWindow.pFirstChildWindow=NULL;					// set first CHILD window
	HardwareWindow.pLastChildWindow=NULL;
	HardwareWindow.pNextWindow=pWScreen;						// next and last screen?
	HardwareWindow.pLastWindow=pWScreen;
	pHardware=&HardwareWindow;

	pDefaultWindow=pWScreen;
	pFirstWindow=NULL;
	pLastWindow=NULL;
}

//************************************************************
//                                                           *
//   Name    : Len                                           *
//   Function: return length of a string                     *
//                                                           *
//   In   : pMessage = message holding string                *
//   Out  : uint16   = length of message                     *
//                                                           *
//************************************************************

uint16 WIN_Len(char *pMessage)
{
	uint16	i;

	i=0;
	while (pMessage[i]!=0x0){
		i++;
	}
	return (i);
}

//************************************************************
//                                                           *
//   Name    : GetTextLen                                    *
//   Function: returns the length in pixels of a text string *
//                                                           *
//   In   : pWindow = Pointer to a window structure          *
//          pMessage= actual string to print (ends with 0x0) *
//   Out  : length in pixels of a text string                *
//                                                           *
//************************************************************
int32	GetTextLen(tWindow *pWindow, char *pMessage)
{
	uint16	a;
	int16		x,y,index,xs,ys;
	tFont		*pWindowFont;
	int16		*pProp;
	int32		total;

	if (pWindow==NULL) pWindow=pDefaultWindow;
	pWindowFont=pWindow->pFont;						// Get windows font!
	pProp=pWindowFont->pTable;							// prop bit
	xs=pWindowFont->xsize;

	total=0;
	while (*pMessage!=0x0){
		a=*pMessage++;
	  	if (pProp==NULL) {		// Prop-Font?
			total+=xs;					// if not, just add width of font
	  	} else {
	  		total+=pProp[a];			// if so, then add from table.
	  	}
	}

	return (total);
}

//************************************************************
//                                                           *
//   Name    : Print                                         *
//   Function: Print text to a window                        *
//                                                           *
//   In   : pWindow = Pointer to a window structure          *
//          x1,y1   = x and y cord in window                 *
//          pMessage= actual string to print (ends with 0x0) *
//   Out  :                                                  *
//                                                           *
//                                                           *
//************************************************************
void Print (tWindow *pWindow, int16 x1,int16 y1, char *pMessage)
{
	uint16	a;
	int16		x,y,index,xs,ys;
	tFont		*pWindowFont;
	int16		*pProp;

	if (pWindow==NULL) pWindow=pDefaultWindow;
	pWindowFont=pWindow->pFont;						// Get windows font!
	pProp=pWindowFont->pTable;							// prop bit

	x=x1-(pWindow->offsetx>>16);
	y=y1-(pWindow->offsety>>16);
	index=pWindowFont->xsize*pWindowFont->ysize;	//	get size of each character

	xs=pWindowFont->xsize;
	ys=pWindowFont->ysize;

	while (*pMessage!=0x0){
		a=*pMessage++;
		SysSpriteMono (pWindow, pWindowFont->pBitMap+(a*index), x,y, xs,ys, xs, PenColour);

	  	if (pProp==NULL) {		// Prop-Font?
			x+=xs;					// if not, just add width of font
	  	} else {
	  		x+=pProp[a];			// if so, then add from table.
	  	}
	}

}


//************************************************************
//                                                           *
//   Name    : SysPrint                                      *
//   Function: System printing with a font to an exact       *
//             x and w within a window                       *
//                                                           *
//   In   : pWindow = Pointer to a window structure          *
//          pFont   = Pointer to a font structure            *
//          x1,y1   = x and y cord in window                 *
//          pMessage= actual string to print (ends with 0x0) *
//   Out  : none                                             *
//                                                           *
//                                                           *
//************************************************************
void SysPrint (tWindow *pWindow, tFont *pFont, int16 x1,int16 y1, char *pMessage)
{
	uint16	a;
	int16		x,y,index,xs,ys;
	tFont		*pWindowFont;
	int16		*pProp;

	pProp=pFont->pTable;							// prop bit

	x=x1;
	y=y1;
	index=pFont->xsize*pFont->ysize;					//	get size of each character
	
	xs=pFont->xsize;
	ys=pFont->ysize;

	while (*pMessage!=0x0){
		a=*pMessage++;
		SysSpriteMono (pWindow, pFont->pBitMap+(a*index), x,y, xs,ys, xs, PenColour);

	  	if (pProp==NULL) {		// Prop-Font?
			x+=xs;					// if not, just add width of font
	  	} else {
	  		x+=pProp[a];			// if so, then add from table.
	  	}
	}

}

//************************************************************
//                                                           *
//   Name    : PrintWindowFrame                              *
//   Function: Prints the surrounding window frame!          *
//                                                           *
//   In   : tWindow pointer                                  *
//   Out  : none                                             *
//                                                           *
//************************************************************
void	PrintWindowFrame (tWindow *pWindow)
{

	int32	i,i2;
	int16	x,y,xs,ys;
	int16	ccx1,ccx2,ccy1,ccy2;
	int32	scrollsize;
	int32	scrollindex;
	int32	scrollactual;

	
	ccx1=pWindow->clipx1;				// Save window!
	ccx2=pWindow->clipx2;
	ccy1=pWindow->clipy1;
	ccy2=pWindow->clipy2;

	x=pWindow->x;
	y=pWindow->y;
	xs=pWindow->xsize;
	ys=pWindow->ysize;

	pWindow->clipx1=0;					// clip window for printing frame
	pWindow->clipy1=0;
	pWindow->clipx2=pWindow->xsize;
	pWindow->clipy2=pWindow->ysize;


	if ((pWindow->Options&BORDERS)!=0) {
		//
		// Print The RIGHT scroll bar
		//
		scrollsize=(ys-44);
		scrollindex=(pWindow->vysize>>16); 
		if (scrollsize<=0) scrollsize=1;
		scrollindex=(scrollsize<<16)/scrollindex;			
		pWindow->vscrolly=scrollindex;
		scrollactual=(scrollindex*(pWindow->offsety>>16))>>16;

		SysBlock (pWindow, GadBit+512+8, xs-8,10, 8,4, 16);
		for (i=0;i<ys-41+2;i++){
			SysBlock (pWindow, GadBit+512+64+8, xs-8,14+i, 8,1, 16);
		}
		SysBlock (pWindow, GadBit+512+80+8, xs-8,ys-25, 8,4, 16);
		SysBlock (pWindow, GadBit+512+144+8, xs-8,14+scrollactual, 8,7, 16);	// print scroll bar
		SysBlock (pWindow, GadBit+512, xs-8,ys-22, 8,15, 16);				// print up/down arrows


		//
		// Print The Bottom scroll bar
		//
		scrollsize=(xs-40);
		scrollindex=(pWindow->vxsize>>16); 
		if (scrollsize<=0) scrollsize=1;
		scrollindex=(scrollsize<<16)/scrollindex;			
		pWindow->vscrollx=scrollindex;
		scrollactual=(scrollindex*(pWindow->offsetx>>16))>>16;


		SysBlock (pWindow, GadBit+1280, 4,ys-8, 4,8, 16);
		for (i=0;i<xs-33;i++){
			SysBlock (pWindow, GadBit+1280+4, 8+i,ys-8, 1,8, 16);
		}
		SysBlock (pWindow, GadBit+1280+5, xs-25,ys-8, 4,8, 16);
		SysBlock (pWindow, GadBit+512+144+8, 8+scrollactual,ys-8, 8,7, 16);	// print scroll bar
		SysBlock (pWindow, GadBit+1280+128, xs-22,ys-8, 16,8, 16);				// print left/right arrows


		//
		// print resize gadget (or BLANK gadget)
		//
		if ((pWindow->Options&RESIZE)!=0){
			SysBlock (pWindow, GadBit+256+80, xs-8,ys-8, 8,15, 16);			// resize gadget
		} else {
			SysBlock (pWindow, GadBit+256+88, xs-8,ys-8, 8,15, 16);			// NO resize gadget
		}	



		//
		// Print the LEFT side
		//
		SysBlock (pWindow, GadBit+256, 0,10, 5,2, 16);
		for (i=0;i<ys-13;i++){
			SysBlock (pWindow, GadBit+256+32, 0,11+i, 5,1, 16);
		}
		SysBlock (pWindow, GadBit+256+48, 0,ys-2, 5,2, 16);
	}


	if ((pWindow->Options&DRAGBAR)!=0){
		//
		// Print the TITLE bar
		//
		if ((pWindow->Options&CLOSE)!=0){
			SysBlock (pWindow, GadBit, 0,0, 11,BARYSIZE, 16);
			i2=0;
		} else {	
			SysBlock (pWindow, GadBit+8, 0,0, 4,BARYSIZE, 16);
			i2=8;
		}
		for (i=0;i<(xs-13+i2);i++){
			SysBlock (pWindow, GadBit+11, i+11-i2,0, 1,11, 16);
		}
		SysBlock (pWindow, GadBit+12, xs-2,0, 2,11, 16);	// finish off border
	}

	pWindow->clipx1=ccx1;			// restore window!
	pWindow->clipx2=ccx2;
	pWindow->clipy1=ccy1;
	pWindow->clipy2=ccy2;

}


//************************************************************
//                                                           *
//   Name    : ClearWindow                                   *
//   Function: Really crap routine that wipes the whole      *
//             bitmap with the chosen colour                 *
//             OR copies in the custom bitmap                *
//                                                           *
//   In   : pWindow = window to wipe.                        *
//   Out  : none                                             *
//                                                           *
//                                                           *
//************************************************************
void ClearWindow (tWindow *pWindow)
{
	uint8	col;
	int32	i;
	uint8	*back,*bit;

	if (pWindow->pBackDrop!=NULL) {
		back=pWindow->pBackDrop;
		bit=pWindow->BitMap;
		for (i=0;i<pWindow->maxxsize*pWindow->maxysize;i++){
			*bit++=*back++;
		}
		return;
	}

	col=pWindow->WindowColour;
	for (i=0;i<pWindow->maxxsize*pWindow->maxysize;i++){
		pWindow->BitMap[i]=col;
	}
}

//************************************************************
//                                                           *
//   Name    : InitWindow                                    *
//   Function: Init a new window and draw frame              *
//                                                           *
//   In   : tWindow pointer                                  *
//   Out  : none                                             *
//                                                           *
//************************************************************

void InitWindow (tWindow *pWindow)
{
	int32	i;
	int16	x,y,xs,ys;
	uint8	col;


	x=pWindow->x;
	y=pWindow->y;
	xs=pWindow->maxxsize;
	ys=pWindow->maxysize;

	// WIPE the windows bitmap
	ClearWindow (pWindow);
	PrintWindowFrame (pWindow);			// Draw in window frame!

}

//************************************************************
//                                                           *
//   Name    : LinkWindow                                    *
//   Function: Link a new window structure into the systems  *
//             window list.                                  *
//                                                           *
//   In   : pParent = Parent window or NULL (links to WB)    *
//          pWIndow = Window to link in.                     *
//   Out  : none                                             *
//                                                           *
//************************************************************
void LinkWindow (tWindow *pParent, tWindow *pWindow)
{
	tWindow	*temp;


	if (pWindow->BitMap==NULL) {		// Does window require memory for a bitmap?
		pWindow->BitMap=(uint8*)MyMalloc (pWindow->maxxsize*pWindow->maxysize);
		if (pWindow->BitMap==NULL) return;	// cant link error...
	}
	if (pWindow->pFont==NULL) {		// Does window require memory for a bitmap?
		pWindow->pFont=pFont;
	}
	if (pParent==NULL){
		pWindow->pParentWindow=NULL;							// set windows parent						
		pWindow->pNextWindow=NULL;
		pWindow->pLastWindow=pLastWindow;
		if (pLastWindow!=NULL) pLastWindow->pNextWindow=pWindow;
		pLastWindow=pWindow;
		if (pFirstWindow==NULL) pFirstWindow=pWindow;	// Setup first window!
	} else {
		pWindow->pParentWindow=pParent;						// set windows parent						
		temp=pParent->pLastChildWindow;						// get LAST child window
		pWindow->pNextWindow=NULL;
		pWindow->pLastWindow=temp;
		if (temp!=NULL) {
			temp->pNextWindow=pWindow;
		} else {
			pParent->pFirstChildWindow=pWindow;
			pParent->pLastChildWindow=pWindow;
		}
	}
}


//************************************************************
//                                                           *
//   Name    : OpenWindow                                    *
//   Function: Open a new window on screen.                  *
//             Allocates memory for it, and inits it.        *
//                                                           *
//   In   : int16 (x,y) = xcord and ycord                    *
//          int16 xsize = x size of window                   *
//          int16 yszie = y size of window                   *
//                                                           *
//   Out  : tWindow * pointer                                *
//                                                           *
//************************************************************

tWindow *OpenWindow (tWindow *pParent, int16 x,int16 y,int16 xsize,int16 ysize)
{
	uint8		*tmp;
	tWindow	*pWindow;
	tWindow	*temp;

	tmp=(uint8 *) MyMalloc(sizeof(tWindow)+(xsize*ysize));		// first allocate memory
	if (tmp==NULL) return NULL;
	
	pWindow=(tWindow *) tmp;
	pWindow->WindowColour=DefDrawCols[DGRAY];		// default to dark shade
	pWindow->PenColour=DefDrawCols[WHITE];			// default to dark shade
	pWindow->DrawCols[0]=DefDrawCols[0];					// copy current colours
	pWindow->DrawCols[1]=DefDrawCols[1];					
	pWindow->DrawCols[2]=DefDrawCols[2];					
	pWindow->DrawCols[3]=DefDrawCols[3];					
	pWindow->DrawCols[4]=DefDrawCols[4];					
	pWindow->x=x;
	pWindow->y=y;
	pWindow->xsize=xsize;
	pWindow->ysize=ysize;
	pWindow->minx=-xsize+1;
	pWindow->miny=-ysize+1;
	pWindow->maxx=pDefaultWindow->maxxsize-1;
	pWindow->maxy=pDefaultWindow->maxysize-1;
	pWindow->offsetx=0;
	pWindow->offsety=0;
	pWindow->maxxsize=xsize;
	pWindow->maxysize=ysize;
	pWindow->vxsize=xsize<<16;						// set virtual sizes
	pWindow->vysize=ysize<<16;
	pWindow->vscrollx=0;
	pWindow->vscrolly=0;
	pWindow->BitMap=tmp+sizeof(tWindow);
	pWindow->pBackDrop=NULL;
	pWindow->pFont=pFont;
	pWindow->pFirstMenu=NULL;
	pWindow->pFirstGadget=NULL;
	pWindow->pLastGadget=NULL;
	pWindow->pFirstChildWindow=NULL;
	pWindow->pLastChildWindow=NULL;
	pWindow->Options=DRAGDROP|VDRAGDROP|HDRAGDROP|RESIZE|BORDERS|DRAGBAR|CLOSE;

	pWindow->clipx1=5;
	pWindow->clipy1=11;
	pWindow->clipx2=xsize-8;
	pWindow->clipy2=ysize-8;
	
	pWindow->flags=wREFRESH;					// set base flags

	LinkWindow (pParent,pWindow);

	InitWindow (pWindow);						// Clear window, and draw boarders
	pWindow->flags|=wACTION;

	return pWindow;
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//                                                           *
//************************************************************

int32	CalcProp (int32 size, int32 min,int32 max,int32 actual)
{
	int32	i,scale;


	if (size<=0) return 0;

	scale=max-min;
	if (scale==0) scale=1;			// can't have a 0 distance!
	scale=((size-6)<<16)/scale;
	scale=(scale*(actual-min));
	return (scale>>16);
}


//************************************************************
//                                                           *
//   Name    : PrintGadget                                   *
//   Function: Print a single gadget into a window           *
//                                                           *
//   In   : pWindow = window to print to                     *
//          pGadget = gadget to print                        *
//   Out  : none                                             *
//                                                           *
//************************************************************
void PrintGadget ( tWindow *pWindow, tGadget *pGadget)
{
	int32	i,ix,iy,gtype;
	int32	offsetx,offsety,done;
	int32	x1,y1,x2,y2;
	uint8	Pen;

	Pen=PenColour;
	PenColour=pGadget->PenColour;
	offsetx=pWindow->offsetx>>16;
	offsety=pWindow->offsety>>16;
	x1=pGadget->x-offsetx;
	y1=pGadget->y-offsety;
	x2=x1+pGadget->xsize;
	y2=y1+pGadget->ysize;

	gtype=pGadget->type;
	i=pWindow->flags&wREFRESH;		// print if window or gadget needs refreshing
	i=i|pGadget->flags&gREFRESH;

	if (i!=0){
		if ( (gtype==BOOLEAN) OR (gtype==TICK) ){
			if (pGadget->value==0) {
				DrawButtonUp  (pWindow,x1,y1,x2-1,y2-1);
			} else {
			  if (gtype==BOOLEAN) {
					DrawButtonDown  (pWindow,x1,y1,x2-1,y2-1);
			  } else if (gtype==TICK) {
					DrawButtonUp  (pWindow,x1,y1,x2-1,y2-1);
					SysSprite (pWindow, GadBit+1024,pGadget->x-1-offsetx,pGadget->y-2-offsety,
									 		 11,10,16); 
			  }
 		   }
		}
		if ( gtype==HPROP ){
			SysFillBox (pWindow, x1,y1-1,x2,y2,pWindow->WindowColour);
			DrawHBar(pWindow, x1,y1,x2,y2);
			ix=CalcProp(pGadget->xsize,pGadget->minxsize,pGadget->maxxsize,pGadget->value);
			SysBlock (pWindow, GadBit+1536,pGadget->x-offsetx+ix+1,pGadget->y-1-offsety,5,6,16);
		}
		if ( gtype==VPROP ){
			SysFillBox (pWindow, x1-1,y1,x2+1,y2-1,pWindow->WindowColour);
			DrawVBar(pWindow, x1,y1,x2,y2);
			iy=CalcProp(pGadget->ysize,pGadget->minysize,pGadget->maxysize,pGadget->value);
			SysSprite (pWindow, GadBit+1536+5,pGadget->x-offsetx-1,pGadget->y+1-offsety+iy,6,5,16);

		}
		if ( (gtype==STRING) OR (gtype==INTEGER) ) {
			if ((pWindow->flags&wREFRESH)!=0){
				Box3D   (pWindow,x1,y1,x2,y2);
			}
			SysFillBox (pWindow, x1+2,y1+2,x2-1,y2-2,pWindow->WindowColour);
			SetSubWindow (pWindow, x1+2,y1+2,x2-1,y2);
			Print (pWindow,pGadget->x+2-pGadget->misc[0],pGadget->y+2,pGadget->pMessage);
			PopClip(pWindow);
		}
		if (gtype==TEXT) {
			SysFillBox (pWindow, x1,y1,x2-1,y2-1,pWindow->WindowColour);	// empty text window
			Print (pWindow,pGadget->x,pGadget->y,pGadget->pMessage);
		}

		if (gtype==TEXTBUTTON) {
			ix=(int16) GetTextLen(pWindow, pGadget->pMessage);
			ix=(pGadget->xsize-ix+1)>>1;
			iy=pWindow->pFont->ysize;
			iy=(pGadget->ysize-iy+1)>>1;
			

			if (pGadget->value==0) {
				DrawButtonUp  (pWindow,x1,y1,x2,y2);
			} else {
				DrawButtonDown  (pWindow,x1,y1,x2,y2);
				ix++;		// draw text down a bit
				iy++;
			}
			SetSubWindow (pWindow, x1+2,y1+2,x2-1,y2-1);
			Print (pWindow,pGadget->x+ix,pGadget->y+iy,pGadget->pMessage);
			PopClip(pWindow);
		}

		PenColour=Pen;
		pGadget->flags&=~gREFRESH;						// clear gadgets refresh.
	}
}


//************************************************************
//                                                           *
//   Name    : GetMenuSize                                   *
//   Function: Finds the number of items in a menu list      *
//                                                           *
//   In   : pMenu = base of level                            *
//   Out  : none                                             *
//                                                           *
//                                                           *
//************************************************************
int32	GetMenuSize (tMenu *pMenu)
{
	int32	total;

	total=0;
	while (pMenu!=NULL){
		total++;
		pMenu=pMenu->pNextItem;
	}
	return total;
}


//************************************************************
//                                                           *
//   Name    : RenderMenu                                    *
//   Function: Prints the menus.                             *
//                                                           *
//             NOTE: This also does collision checking!!!!   *
//   In   : pWindow= window to draw to                       *
//          pMenu  = current menu level                      *
//          offx,offy = pixel offset to draw from            *
//   Out  : none                                             *
//                                                           *
//                                                           *
//************************************************************
void	RenderMenu(tWindow *pWindow,tMenu *pMenu,int16	offx,int16 offy )
{
	int16		xs,ys,x,y,x2,y2,sx,xsize;
	int32		total;
	tMenu		*pM,*pChildMenu;


	ys=pWindow->pFont->ysize;			// get font height
	xsize=pWindow->pFont->ysize;			// get font height
	x=offx; y=offy;

	pM=pMenu;

	x2=GetTextLen (pWindow,pMenu->pMessage);
	total=GetMenuSize (pMenu)*ys;	// get height of menu
	DrawButtonUp  (pWindow, x-3,y-3, x+x2+(xsize<<1),y+total+(ys>>1));
	sx=x+x2+(xsize<<1)-2;

	//
	// First print current level
	//
	pChildMenu=NULL;
	while (pMenu!=NULL){
		if (pSelected==pMenu) {
			xs=GetTextLen (pWindow,pMenu->pMessage);
			DrawButtonUp (pWindow, x-1,y-1, sx,y+ys-1);
		}
								  
		SysPrint (pWindow,pWindow->pFont,x+xsize,y,pMenu->pMessage);
		if ((pMenu->flags&mSELECTED)!=0){
			pChildMenu=pMenu->pChildMenu;				// this child menu needs printing
			x2=x+GetTextLen (pWindow,pMenu->pMessage);
			y2=y+(ys>>1);
		}
		y+=ys;
		pMenu=pMenu->pNextItem;
	}


	if (pChildMenu!=NULL) RenderMenu (pWindow,pChildMenu,x2,y2);
}


//************************************************************
//                                                           *
//   Name    : PrintMenu                                     *
//   Function: Prints the top most menu list. and sets off   *
//             the recursive menus down the way              *
//                                                           *
//   In   : pWindow = Window to process menus in             *
//   Out  : none                                             *
//                                                           *
//                                                           *
//************************************************************
void PrintMenu(tWindow *pWindow)
{
	int16		xs,ys,x,y,x2,y2,total;
	tMenu		*pChildMenu,*pMenu;


	pMenu=pWindow->pFirstMenu;
	if (pMenu==NULL) return;
	ys=pWindow->pFont->ysize;			// get font height

	PushClip(pWindow);
	pWindow->clipx1=0;					// clip window for printing frame
	pWindow->clipy1=0;
	pWindow->clipx2=pWindow->xsize;
	pWindow->clipy2=pWindow->ysize;
	x=6; y=3;								// base cords for menu


	pChildMenu=NULL;

	DrawButtonUp (pWindow, 0,0, pWindow->xsize-1,10);
	pMenu=pWindow->pFirstMenu;
	while (pMenu!=NULL){
		if (pSelected==pMenu) {
			xs=GetTextLen (pWindow,pMenu->pMessage);
			DrawButtonUp (pWindow, x-1,y-1, x+xs-1,y+ys-1);
		}

		SysPrint (pWindow,pWindow->pFont,x,y,pMenu->pMessage);
		if ((pMenu->flags&mSELECTED)!=0){
			pChildMenu=pMenu->pChildMenu;				// this child menu needs printing
			x2=x;
			y2=y+ys;
		}
		x+=GetTextLen (pWindow,pMenu->pMessage);
		pMenu=pMenu->pNextItem;
	}


	if (pChildMenu!=NULL){
		RenderMenu (pWindow,pChildMenu,x2,y2);
	}
	PopClip(pWindow);
}


//************************************************************
//                                                           *
//   Name    : RenderInterface                               *
//   Function: Print everything!                             *
//                                                           *
//************************************************************

void RenderWindow (tWindow *pWScreen, tWindow *pWindow )
{
	uint8		Pen;
	int32		offsetx,offsety,i;	
	tWindow	*pChildWindow;
	tGadget	*pGadget;

	if (pWindow==NULL) return;			// error checking;

	Pen=PenColour;
	while (pWindow!=NULL){
		offsetx=pWScreen->offsetx>>16;
		offsety=pWScreen->offsety>>16;

		PenColour=pWindow->PenColour;
		DrawCols[0]=pWindow->DrawCols[0];		// copy current colours
		DrawCols[1]=pWindow->DrawCols[1];					
		DrawCols[2]=pWindow->DrawCols[2];					
		DrawCols[3]=pWindow->DrawCols[3];					
		DrawCols[4]=pWindow->DrawCols[4];					

		if ((pWindow->Options&HIDE)==0) {		// Process this window??

			//
			// first order of business. print all gadgets! (if they've changed)
			//
			pGadget=pWindow->pFirstGadget;
			while (pGadget!=NULL){
				if ((pGadget->flags&gCOLOUR)!=0) {
					DrawCols[0]=pGadget->DrawCols[0];		// copy current colours
					DrawCols[1]=pGadget->DrawCols[1];					
					DrawCols[2]=pGadget->DrawCols[2];					
					DrawCols[3]=pGadget->DrawCols[3];					
					DrawCols[4]=pGadget->DrawCols[4];					
				}
				PrintGadget(pWindow,pGadget);
				if ((pGadget->flags&gCOLOUR)!=0) {
					DrawCols[0]=pWindow->DrawCols[0];		// copy current colours
					DrawCols[1]=pWindow->DrawCols[1];					
					DrawCols[2]=pWindow->DrawCols[2];					
					DrawCols[3]=pWindow->DrawCols[3];					
					DrawCols[4]=pWindow->DrawCols[4];					
				}
				pGadget=pGadget->pNextGadget;
			}


			// first render children into parent window
			pChildWindow=pWindow->pFirstChildWindow;
			if (pChildWindow!=NULL){
				RenderWindow (pWindow,  pChildWindow);
			}


			// Render Menus
			if ( (pWindow->pFirstMenu!=NULL) AND (mousebut==2) AND 
				  ((pWindow->flags&wACTIVE)!=0) ){
				PrintMenu(pWindow);									// print menus
			}



			// Print window to screen
			if ((pWindow->flags&wTRANSPARENT)==0){
				SysBlock (pWScreen, pWindow->BitMap,pWindow->x-offsetx,pWindow->y-offsety, 
								 		pWindow->xsize,pWindow->ysize, 
								 		pWindow->maxxsize);
			};
			if ((pWindow->Options&TRANSPARENT)!=0){
					pWindow->flags^=wTRANSPARENT;
			} else {
					pWindow->flags&=~wTRANSPARENT;
			}
		
		}
		pWindow->flags&=~(wREFRESH|wACTIVE);			// clear flags..	
		pWindow=pWindow->pNextWindow;
	}
	PenColour=Pen;
}


//************************************************************
//                                                           *
//   Name    : RenderInterface                               *
//   Function: Prints everything that needs printing.        *
//             Also prints gadgets when they are needing it. *
//                                                           *
//************************************************************
void RenderInterface ( void )
{
	RenderWindow (pDefaultWindow, pFirstWindow);
	if (EnableMouse==1) {
		if (pDefaultWindow==NULL) return;			// error checking;
		SysSprite ( pDefaultWindow, pMouse->pHand, pMouse->xoffset+xx>>1,pMouse->yoffset+yy, pMouse->xsize,pMouse->ysize, pMouse->xsize);
	}
}


/*************************************************************
/*                                                           *
/*   Name    : RefreshWindow                                 *
/*   Function: Refresh a window. This involves wiping it     *
/*             redrawing the borders and flaging refresh     *
/*                                                           *
/*************************************************************/
void RefreshWindow (tWindow *pWindow)
{
	if (pWindow!=NULL){
		pWindow->flags|=wREFRESH;			// refresh parent
		ClearWindow (pWindow);				// empty window ready for redrawing
		PrintWindowFrame (pWindow);		// redo window frame
	}
}


//************************************************************
//                                                           *
//   Name    : ClearLevel                                    *
//   Function: Clears slected flags in current level         *
//             also used to init child level                 *
//   In   : pMenu = current level to init                    *
//   Out  : none                                             *
//                                                           *
//                                                           *
//************************************************************
void ClearLevel (tMenu *pLevel)
{
	if (pLevel==NULL) return;

	while (pLevel!=NULL){
		pLevel->flags&=~mSELECTED;				// wipe flag
		pLevel=pLevel->pNextItem;
	}
}

//************************************************************
//                                                           *
//   Name    : CheckChild                                    *
//   Function: This is a recursive collision check for menus *
//                                                           *
//   In   :pWindow = current window being checked            *
//         pMenu   = Current menu level                      *
//         x,y     = top left corner of menu box             *
//   Out  : none                                             *
//                                                           *
//                                                           *
//************************************************************

void CheckChild (tWindow *pWindow,tMenu *pMenu, int16 x,int16 y)
{
	int16		xs,ys,x2,y2,mx,my,sx;
	tMenu		*pChildMenu,*pLevel;

	if (pMenu==NULL) return;   		// quit if no child
	ys=pWindow->pFont->ysize;			// get font height
	sx=pWindow->pFont->xsize;			// get font height
	mx=(mousex>>1)+pMouse->clickx;			// get click pixel!
	my=mousey+pMouse->clicky;

	
	pChildMenu=NULL;
	pLevel=pMenu;							// get current level of menu
	while (pMenu!=NULL){
		xs=GetTextLen(pWindow,pMenu->pMessage);
		pMenu->flags&=~mCHOICE;									// Wipe choice flag
		
		if ((mx>=x) AND (mx<x+xs+sx) AND (my>y) AND (my<=y+ys)){		// collision?
			if ((pMenu->flags&mSELECTED)==0){			// was this one seleted
				MenuRefresh=TRUE;								// last time? if not refresh
			}
			ClearLevel (pLevel);											// wipe current level
			ClearLevel (pMenu->pChildMenu);							// wipe child level
			pMenu->flags|=mSELECTED;										// flag as collision
			pSelected=pMenu;
		}

		if ((pMenu->flags&mSELECTED)!=0){
			pChildMenu=pMenu->pChildMenu;
			x2=x+GetTextLen (pWindow,pMenu->pMessage);
			y2=y+(ys>>1);
		}
	
		y+=ys;									// child goes DOWN the way
		pMenu=pMenu->pNextItem;
	}
	

	if (pChildMenu!=0) CheckChild (pWindow,pChildMenu,x2,y2);
	return;
}


//************************************************************
//                                                           *
//   Name    : CheckMenus                                    *
//   Function: Check the menus in a window                   *
//                                                           *
//   In   : pWindow = window to check!                       *
//   Out  : none                                             *
//                                                           *
//                                                           *
//************************************************************

void		CheckMenus(tWindow *pWindow)
{
	int16		xs,ys,x,y,x2,y2,mx,my;
	tMenu		*pChildMenu,*pMenu,*pLevel;


	pMenu=pWindow->pFirstMenu;			// get first menu in list to check!
	ys=pWindow->pFont->ysize;			// get font height
	mx=(mousex>>1)+pMouse->clickx;			// get click pixel!
	my=mousey+pMouse->clicky;

	
	MenuRefresh=0;
	pLastSelected=pSelected;
	pSelected=NULL;
	x=pWindow->x+6;						// get cord of FIRST menu
	y=pWindow->y+3;
	pChildMenu=NULL;
	pLevel=pMenu;							// get current level of menu
	while (pMenu!=NULL){
		xs=GetTextLen(pWindow,pMenu->pMessage);
		pMenu->flags&=~mCHOICE;									// Wipe choice flag

		if ((mx>=x) AND (mx<x+xs) AND (my>y) AND (my<=y+ys)){		// collision?
			if ((pMenu->flags&mSELECTED)==0){			// was this one seleted
				MenuRefresh=TRUE;								// last time? if not refresh
			}
			ClearLevel (pLevel);											// wipe current level
			ClearLevel (pMenu->pChildMenu);							// wipe child level
			pMenu->flags|=mSELECTED;									// flag as opened
			pSelected=pMenu;
		}

		if ((pMenu->flags&mSELECTED)!=0){
			pChildMenu=pMenu->pChildMenu;
			x2=x;
			y2=y+ys;
		}
		x+=GetTextLen (pWindow,pMenu->pMessage);
		pMenu=pMenu->pNextItem;
	}


	if (pChildMenu!=0) 				CheckChild (pWindow,pChildMenu,x2,y2);
	if (pSelected!=0)					pSelected->flags|=mCHOICE;
	if (pSelected!=pLastSelected) MenuRefresh=TRUE;
	if (MenuRefresh==TRUE) 			RefreshWindow (pWindow);
}


//************************************************************
//                                                           *
//   Name    : ProcessGadgets                                *
//   Function: Check mouse clicks to all windows gadgets     *
//                                                           *
//   In   : pWindow = windows gadgets to check               *
//          x,y     = offset from top of screen              *
//   Out  : int16   = click sucsessfull. No further action   *
//                                                           *
//************************************************************
int16	ProcessGadgets (tWindow *pWindow, int16 xoff, int16 yoff)
{
	int16		x1,y1,x2,y2,xs,ys;
	int16		mx,my;
	uint32	i;
	uint8		col;
	int32		gtype;
	tGadget	*pGadget;
	float		crap;



	pGadget=pWindow->pLastGadget;		// start at the back (coz of printing order)
	if (pGadget==NULL) return 0;
	if (pButGadget!=0) pGadget=pButGadget;				// set window lock
	

	mx=(mousex>>1)+pMouse->clickx;			// get click pixel!
	my=mousey+pMouse->clicky;


	while (pGadget!=NULL) {
		x1=pGadget->x+xoff-(pWindow->offsetx>>16);		// get cords needed for collision check
		y1=pGadget->y+yoff-(pWindow->offsety>>16);
		xs=pGadget->xsize;
		ys=pGadget->ysize;
		x2=x1+xs;
		y2=y1+ys;
		gtype=pGadget->type;


		//
		// first check collision with gadgets
		//
		if ( ((Lastmx>=x1) AND (Lastmx<=x2) AND (Lastmy>=y1) AND (Lastmy<=y2)) OR (pButGadget!=0)) {

			pButGadget=pGadget;						// Set gadget lock
			// mouse HAS clicked on gadget. so check the various states.
			if ( (gtype==BOOLEAN) OR (gtype==TICK) ){
				if (lbut==mousebut) return 0;			// mouse button was already clicked.
				pGadget->value^=-1;					// toggle status
				pGadget->flags|=gREFRESH;			// flag gadget for redrawing.
				if (gtype==TICK) RefreshWindow (pWindow);			// refresh this window
				return 1;
			}
		
			// check prop gadget Uses a "FLOAT" type
			if (gtype==VPROP) {
				i=Lastmy-y1;
				if (Lastmy>y2) i=ys;
				if (Lastmy<y1) i=0;
				crap=pGadget->maxysize-pGadget->minysize;	// get distance
				crap=crap/pGadget->ysize;		// get pixel step.
				crap=crap*i;
				i=crap;
				pGadget->value=i;
				pGadget->flags|=gREFRESH;			// flag gadget for redrawing.
				//RefreshWindow (pWindow);
				return 1;
			}


			// check prop gadget
			if (gtype==HPROP) {
				i=Lastmx-x1;
				if (Lastmx>x2) i=xs;
				if (Lastmx<x1) i=0;
				crap=pGadget->maxxsize-pGadget->minxsize;	// get distance
				crap=crap/pGadget->xsize;		// get pixel step.
				crap=crap*i;
				i=crap;
				pGadget->value=i+pGadget->minxsize;
				pGadget->flags|=gREFRESH;			// flag gadget for redrawing.
				//RefreshWindow (pWindow);
				return 1;
			}

			// check text box
			if ( (gtype==STRING) OR (gtype==INTEGER) ) {
				if (lbut==mousebut) return 0;			// mouse button was already clicked.
	 			EndEdit ();
				i=pGadget->misc[1];		// get current insert point;
				pGadget->pMessage[i]=CURSOR;
				pGadget->pMessage[i+1]=0x0;
				pGadget->flags|=gREFRESH;
				EditMode=1;
				Edindex=0;
				pEdGadget=pGadget;
			 	return 1;
			}
			if (gtype==TEXT) {
				if (lbut==mousebut) return 0;			// mouse button was already clicked.
				pGadget->flags|=gREFRESH;			// flag clicked
			 	return 1;
			}
			if (gtype==TEXTBUTTON) {
				if (lbut==mousebut) return 0;			// mouse button was already clicked.
				pGadget->value^=-1;					// toggle status
				pGadget->flags|=gREFRESH;			// flag gadget for redrawing.
				return 1;
			}

		}
		pGadget=pGadget->pLastGadget;	// move backwards!
	}
	return 0;
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//                                                           *
//************************************************************
void ClearMenu ( void )
{
	if (MenuLast==1) {								// menu WAS printed last frame
		RefreshWindow (pMenuWindow);				// refresh window to erase menu
		MenuLast=0;
		pMenuWindow=NULL;
	}
}


//************************************************************
//                                                           *
//   Name    : ProcessWindow                                 *
//   Function: Process all mouse clicks etc!                 *
//                                                           *
//   In   : pWindow   = window to process                    *
//          xoff,yoff = offset down the screen               *
//                      (usally for child windows)           *
//   Out  : 0=no click detected in this window (or childs)   *
//          1=click detected in this or in a child           *
//                                                           *
//************************************************************

int16 ProcessWindow ( tWindow *pWindow, int16 xoff,int16 yoff,uint8 flag )
{
	int16		x1,y1,x2,y2,xs,ys,tx,ty;
	int16		mx,my;
	uint32	i,scrollactual;
	uint8		col;
	int16		retval;

	if (pWindow==NULL) return 2;			// error checking;
	mx=(mousex>>1)+pMouse->clickx;				// get click pixel!
	my=mousey+pMouse->clicky;


	while ( (pWindow!=NULL) ) {
		x1=pWindow->x+xoff;
		y1=pWindow->y+yoff;
		xs=pWindow->xsize;
		ys=pWindow->ysize;
		x2=x1+xs;
		y2=y1+ys;

		if ((pWindow->Options&HIDE)==0) {		// Process this window??
			// inside this window??
			if ( (Lastmx>=x1) AND (Lastmx<=x2) AND (Lastmy>=y1) AND (Lastmy<=y2) ){


				pButWindow=pWindow;						// Set window lock
				BWxoff=xoff;
				BWyoff=yoff;
				

			   if (((pWindow->Options&BORDERS)!=0) AND (mousebut==1)){
					// first check CLOSE box
					if ( (Lastmx>=x1+3) AND (Lastmx<=x1+9) AND (Lastmy>=y1+3) AND 
						  (Lastmy<=y1+9) AND ((pWindow->Options&CLOSE)!=0)){
						if (lbut==mousebut) return 1;		// click is OVER close but not ON close			
						pWindow->flags|=wCLOSE|wACTIVE;
						return 1;
					}
				}


				if (flag==0){
					// if child windows, process them too!!
					if ((pWindow->pLastChildWindow!=0x0)){
						retval=ProcessWindow ( pWindow->pLastChildWindow,
											  	x1-(pWindow->offsetx>>16),
											  	y1-(pWindow->offsety>>16),0);
						if (retval==1){
							RefreshWindow (pWindow);				// refresh window
							return 2;
						};
						if (retval==2){
							return 2;
						}
					}
				}


			   if ((pWindow->Options&DRAGDROP)!=0){
				 // first check grab bar.
				 if ( ((Lastmx>=x1) AND (Lastmx<=x2) AND (Lastmy>=y1) AND (Lastmy<=y1+10) AND (mousebut==1)) OR (mousebut==3)){
						if ((lbut==mousebut) AND ((pWindow->flags&wMOVING)==0)) return 0;
						pWindow->flags|=wMOVING;		// set window is moving!
						x2=mx-Lastmx;					// Get distance moved!
						y2=my-Lastmy;
						
						if ((x2|y2)!=0) {
							if (y2!=0) {
								if ((pWindow->Options&VDRAGDROP)!=0){
									ty=pWindow->y+y2;
									if (ty<pWindow->miny) ty=pWindow->miny; 
									if (ty>pWindow->maxy) ty=pWindow->maxy; 
									pWindow->y=ty;
								}
							};
							if (x2!=0) {
								if ((pWindow->Options&HDRAGDROP)!=0){
									tx=pWindow->x+x2;
									if (tx<pWindow->minx) tx=pWindow->minx; 
									if (tx>pWindow->maxx) tx=pWindow->maxx; 
									pWindow->x=tx;
								}
							};
							RefreshWindow (pWindow->pParentWindow);		// refresh parent (if any)
							pWindow->flags|=wACTIVE;
							return 1;						// all done (flag for parent)!
						}
						return 2;	
				 }
				}



			  if (((pWindow->Options&BORDERS)!=0) AND (mousebut==1)){
				// Now check resize gadget
				if ((pWindow->Options&RESIZE)!=0){
					x2=x1+xs-8;												// get X and Y of resize gadget
					y2=y1+ys-8;
					if ( (Lastmx>=x2) AND (Lastmx<=x2+xs-1) AND (Lastmy>=y2) AND (Lastmy<=y2+ys-1) ){
						pWindow->flags|=wRESIZE|wREFRESH;		// set window is moving!
						x2=mx-Lastmx;									// Get distance moved!
						y2=my-Lastmy;
					
						if ((x2|y2)!=0) {
							pWindow->xsize+=x2;				// move window.
							pWindow->ysize+=y2;
							if (pWindow->xsize>pWindow->maxxsize)	pWindow->xsize=pWindow->maxxsize;
							if (pWindow->ysize>pWindow->maxysize)	pWindow->ysize=pWindow->maxysize;
							if (pWindow->xsize<12) pWindow->xsize=12;
							if (pWindow->ysize<18) pWindow->ysize=18;

							pWindow->clipx2=pWindow->xsize-8;			// alter clip window
							pWindow->clipy2=pWindow->ysize-8;
					
							// WIPE the windows bitmap

							RefreshWindow (pWindow);						// refresh window
							RefreshWindow(pWindow->pParentWindow);
							pWindow->flags|=wACTIVE;
							return 1;												// all done (flag for parent)!
						}
						return 2; 
					}
				}
			
				// Now check scroll down gadget
				x2=x1+xs-8;												// get X and Y of resize gadget
				y2=y1+ys-14;
				if ( ((Lastmx>=x2) AND (Lastmx<=x2+xs-1) AND (Lastmy>=y2) AND (Lastmy<=y2+ys-1)) AND (mousebut==1)){
						if (lbut==mousebut) return 2;	

						pWindow->offsety+=5<<16;					// scroll area up by 5
						if (pWindow->offsety>pWindow->vysize) {
								pWindow->offsety=pWindow->vysize;
						}
						RefreshWindow (pWindow);				// refresh window
						return 2;												// all done (flag for parent)!
				}
			

				// Now check scroll up gadget
				x2=x1+xs-8;												// get X and Y of resize gadget
				y2=y1+ys-21;
				if (((Lastmx>=x2) AND (Lastmx<=x2+xs-1) AND (Lastmy>=y2) AND (Lastmy<=y2+ys-1)) AND (mousebut==1)){
						if (lbut==mousebut) return 2;

						pWindow->offsety-=5<<16;					// scroll area up by 5
						if (pWindow->offsety<0) {
								pWindow->offsety=0;
						}

						RefreshWindow (pWindow);				// refresh window
						return 2;								// all done (flag for parent)!
				}


				// Now check scroll bar (up/down) gadget
				x2=x1+xs-8;												// get X and Y of resize gadget
				y2=y1+16;
				if ( ((Lastmx>=x2) AND (Lastmx<=x2+8) AND (Lastmy>=y2) AND (Lastmy<=y2+ys-46)) AND (mousebut==1)){

						y2=my-Lastmy;
						y2=Lastmy-y1-17;
						scrollactual=(ys-46);
						if (scrollactual<=0) return 2;
						scrollactual=pWindow->vysize/scrollactual;
						pWindow->offsety=(scrollactual*y2);					// scroll area up by 5

						if (pWindow->offsety<0) {
							pWindow->offsety=0;
						}
						if (pWindow->offsety>pWindow->vysize) {
							pWindow->offsety=pWindow->vysize;
						}
						
						RefreshWindow (pWindow);				// refresh window
						return 2;								// all done (flag for parent)!
				}


				// Now check scroll right gadget. (move left)
				x2=x1+xs-16;												// get X and Y of resize gadget
				y2=y1+ys-8;
				if ( ((Lastmx>=x2) AND (Lastmx<=x2+8) AND (Lastmy>=y2) AND (Lastmy<=y2+8)) AND (mousebut==1)){
						if (lbut==mousebut) return 2;	

						pWindow->offsetx+=5<<16;					// scroll area up by 5
						if (pWindow->offsetx>pWindow->vxsize) {
								pWindow->offsetx=pWindow->vxsize;
						}
						RefreshWindow (pWindow);				// refresh window
						return 2;												// all done (flag for parent)!
				}
			

				// Now check scroll left gadget (move right)
				x2=x1+xs-24;												// get X and Y of resize gadget
				y2=y1+ys-8;
				if ( ((Lastmx>=x2) AND (Lastmx<=x2+8) AND (Lastmy>=y2) AND (Lastmy<=y2+8)) AND (mousebut==1)){
						if (lbut==mousebut) return 2;

						pWindow->offsetx-=5<<16;				// scroll area up by 5
						if (pWindow->offsetx<0) {
								pWindow->offsetx=0;
						}
						RefreshWindow (pWindow);				// refresh window
						return 2;									// all done (flag for parent)!
				}



				// Now check scroll bar (left/right) gadget
				x2=x1+9;												// get X and Y of resize gadget
				y2=y1+ys-8;
				if ( ((Lastmx>=x2) AND (Lastmx<=x2+xs-43) AND (Lastmy>=y2) AND (Lastmy<=y2+8)) AND (mousebut==1)){
						FoundWindow=TRUE;

						x2=mx-Lastmx;
						x2=Lastmx-x1-9;
						scrollactual=(xs-43);
						if (scrollactual<=0) return 2;
						scrollactual=pWindow->vxsize/scrollactual;
						pWindow->offsetx=(scrollactual*x2);					// scroll area up by 5

						if (pWindow->offsetx<0) {
							pWindow->offsetx=0;
						}
						if (pWindow->offsetx>pWindow->vxsize) {
							pWindow->offsetx=pWindow->vxsize;
						}
						
						RefreshWindow (pWindow);				// refresh window
						return 2;								// all done (flag for parent)!
					}

				}
			

				//
				// Check Gadgets for THIS window
				//
				if (mousebut==1)	{
					if (ProcessGadgets (pWindow, x1,y1)==1){
						pWindow->flags|=wACTION|wACTIVE;
						return 0;
					}
				}

				if ((pWindow->pFirstMenu!=0) AND (mousebut==2)) {
					if (pMenuWindow!=pWindow) ClearMenu();
					if (MenuLast==0) ClearLevel (pWindow->pFirstMenu);
					pMenuWindow=pWindow;
					CheckMenus(pWindow);						// collision check to menus
					MenuLast=1;
					pWindow->flags|=wACTIVE;
					return 2;
				}

				pWindow->flags&=~(wACTION|wMOVING|wRESIZE|wREFRESH);			// Clear system flags!
				return 2;				// mouse is OVER this window, but did nothing.
			}


			//
			// if menu was in this window then process even if mouse is 
			// NOT in or over this window.
			//
			if ((pMenuWindow==pWindow) AND (mousebut==2)) {
				if (pMenuWindow!=pWindow) ClearMenu();
				if (MenuLast==0) ClearLevel (pWindow->pFirstMenu);
				pMenuWindow=pWindow;
				CheckMenus(pWindow);						// collision check to menus
				MenuLast=1;
				pWindow->flags|=wACTIVE;
				return 2;
			}
		}
		pWindow=pWindow->pLastWindow;
	}
	return 0;
}



//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void FreeMenu(tMenu *pMenu)
{
	tMenu	*pM;
	if (pMenu==NULL) return;

	while (pMenu!=NULL){
		pM=pMenu->pNextItem;						// get NEXT one in list
		FreeMenu(pMenu->pChildMenu);			// free the children
		MyFree(pMenu);								// free this one.
		pMenu=pM;									// and move on...
	}
}


//************************************************************
//                                                           *
//   Name    : CloseWindow                                   *
//   Function: Close window and free all memory including    *
//             and gadgets etc...                            *
//                                                           *
//   In   : pWindow = window to free                         *
//   Out  : none                                             *
//                                                           *
//************************************************************

void CloseWindow (tWindow *pWindow)
{
	tGadget	*pGadget;
	tGadget	*pNextGadget;
	tWindow	*pChildWindow;
	tWindow	*pNextChildWindow;
	tWindow	*pLWindow;
	tWindow	*pNWindow;

	if (pWindow==NULL) return;

	//
	// first free all gadgets this window uses.
	//

	pGadget=pWindow->pFirstGadget;
	while (pGadget!=NULL){
		pNextGadget=pGadget->pNextGadget;
		MyFree(pGadget);
		pGadget=pNextGadget;
	}

	//
	// Now free all MENUS
	//
	FreeMenu(pWindow->pFirstMenu);
	

	//
	// okay, now free all memory from CHILD windows!
	//
	pChildWindow=pWindow->pFirstChildWindow;
	while (pChildWindow!=NULL){
		pNextChildWindow=pChildWindow->pNextWindow;
		CloseWindow (pChildWindow);						// close this child window
		pChildWindow=pNextChildWindow;
	}

	// now get links
	pLWindow=pWindow->pLastWindow;	
	pNWindow=pWindow->pNextWindow;	

	// free windows memory
	MyFree(pWindow);


	//
	// remove all links to window
	//

	if (pLWindow==NULL)	{
		pFirstWindow=pNWindow;				// point to the NEXT one as the FIRST one
		if (pNWindow!=NULL){ 
			pNWindow->pLastWindow=NULL;	// wipe link
		} else {
			pLastWindow=pLWindow;
		}
	} else {
		pLWindow->pNextWindow=pNWindow;		// remove link. and link to next
		if (pNWindow!=NULL){ 
			pNWindow->pLastWindow=NULL;	// wipe link
		} else {
			pLastWindow=pLWindow;
		}
	}
}



//************************************************************
//                                                           *
//   Name    : AddGadget                                     *
//   Function: Add a gadget to the list of window gadgets    *
//                                                           *
//   In   : pWindow = window to add gadget to                *
//          pGadget = gadget to link in                      *
//   Out  : none                                             *
//                                                           *
//************************************************************

void Addgadget (tWindow *pWindow, tGadget *pGadget)
{
	if (pWindow->pLastGadget==NULL){		// first gadget in list?
 		pGadget->pLastGadget=NULL;
		pWindow->pFirstGadget=pGadget;
		pWindow->pLastGadget=pGadget;
	} else {
 		pGadget->pLastGadget=pWindow->pLastGadget;
 		pWindow->pLastGadget->pNextGadget=pGadget;
		pWindow->pLastGadget=pGadget;
	}
}
//************************************************************
//                                                           *
//   Name    : AddBooleanGadget                              *
//   Function: Create a new boolean gadget and attach        *
//             it into a window structure.                   *
//                                                           *
//   In   : pWindow = windows structure!                     *
//          x,y     = x and y cords inside window            *
//   Out  : Base address of gadget (or NULL)                 *
//                                                           *
//************************************************************/

tGadget *AddPropGadget (tWindow *pWindow, int16 x, int16 y,
														int32 dispxsize, int32 minx, int32 maxx,
														int32 dispysize, int32 miny, int32 maxy)
{
	uint8		*tmp;
	int32		gtype;
	tGadget	*pGadget;
	tGadget	*gadget;

	if (pWindow==NULL) return NULL;				// Window opened?
	tmp=(uint8 *) MyMalloc(sizeof(tGadget));		// first allocate memory
	if (tmp==NULL) return NULL;					// space for gadget?

	pGadget=(tGadget *) tmp;						// get base of new memory
	
	if (dispxsize==0) {
		gtype=VPROP;
		dispxsize=4;									// if no x size, then Y only
	} else {
		if (dispysize==0) {						// no y size, then X only
			gtype=HPROP;
			dispysize=4;									// if no x size, then Y only
		} else {
			gtype=HVPROP;								// or 2D prop.
		}
	}
	


	pGadget->PenColour=pWindow->PenColour;
	pGadget->x=x;
	pGadget->y=y;
	pGadget->xsize=dispxsize;						// set gadget size
	pGadget->ysize=dispysize;
	pGadget->maxxsize=maxx;
	pGadget->maxysize=maxy;
	pGadget->minxsize=minx;
	pGadget->minysize=miny;
	pGadget->type=gtype;
	pGadget->flags=gACTIVE|gDRAWN|gREFRESH;		// set gadget as active AND drawn!
	pGadget->value=0;										// by defualt its off!
 	pGadget->pNextGadget=NULL;
 	pGadget->pMessage=NULL;
	
	AddGadget(pWindow,pGadget);
	return pGadget;
}


//************************************************************
//                                                           *
//   Name    : AddBooleanGadget                              *
//   Function: Create a new boolean gadget and attach        *
//             it into a window structure.                   *
//                                                           *
//   In   : pWindow = windows structure!                     *
//          x,y     = x and y cords inside window            *
//   Out  : Base address of gadget (or NULL)                 *
//                                                           *
//************************************************************/

tGadget *AddBooleanGadget (tWindow *pWindow, int32 type, int16 x, int16 y)
{
	uint8		*tmp;
	tGadget	*pGadget;
	tGadget	*gadget;

	if (pWindow==NULL) return NULL;				// Window opened?
	tmp=(uint8 *) MyMalloc(sizeof(tGadget));		// first allocate memory
	if (tmp==NULL) return NULL;					// space for gadget?

	pGadget=(tGadget *) tmp;						// get base of new memory
	
	pGadget->PenColour=pWindow->PenColour;
	pGadget->x=x;
	pGadget->y=y;
	pGadget->xsize=8;									// set gadget size
	pGadget->ysize=8;
	pGadget->maxxsize=0;
	pGadget->maxysize=0;
	pGadget->type=type;
	pGadget->flags=gACTIVE|gDRAWN|gREFRESH;		// set gadget as active AND drawn!
	pGadget->value=0;										// by defualt its off!
 	pGadget->pNextGadget=NULL;
 	pGadget->pMessage=NULL;
	
	AddGadget(pWindow,pGadget);
	return pGadget;
}

//************************************************************
//                                                           *
//   Name    : AddBooleanGadget                              *
//   Function: Create a new boolean gadget and attach        *
//             it into a window structure.                   *
//                                                           *
//   In   : pWindow = windows structure!                     *
//          x,y     = x and y cords inside window            *
//   Out  : Base address of gadget (or NULL)                 *
//                                                           *
//************************************************************/

tGadget *AddStringGadget (tWindow *pWindow, int32 type, int16 x, int16 y, 
									int32	gxsize,int32 maxsize)
{
	uint8		*tmp;
	tGadget	*pGadget;
	tGadget	*gadget;
	int32		xs,ys;

	if (pWindow==NULL) return NULL;				// Window opened?
	tmp=(uint8 *) MyMalloc((sizeof(tGadget)+maxsize+2));		// first allocate memory+string space
	if (tmp==NULL) return NULL;					// space for gadget?

	pGadget=(tGadget *) tmp;						// get base of new memory
	
	ys=pWindow->pFont->ysize;

	pGadget->x=x;
	pGadget->y=y;
	pGadget->PenColour=pWindow->PenColour;
	pGadget->xsize=gxsize;
	pGadget->ysize=3+ys;									// font height+border space
	pGadget->maxxsize=maxsize;							// max size of string
	pGadget->maxysize=0;
	pGadget->type=type;
	pGadget->flags=gACTIVE|gDRAWN|gREFRESH;		// set gadget as active AND drawn!
	pGadget->value=0;										// by defualt its off!
 	pGadget->pNextGadget=NULL;
 	pGadget->pMessage=tmp+sizeof(tGadget);			// point to string
	pGadget->pMessage[0]=0x0;
	

	pGadget->misc[0]=0;									// char to start printing at
	pGadget->misc[1]=0;									// current insert point

	AddGadget(pWindow,pGadget);
	return pGadget;
}


//************************************************************
//                                                           *
//   Name    : AddText                                       *
//   Function: Add a TEXT string (a gadget type) into the    *
//             gadget window list.                           *
//                                                           *
//   In   : pWindow = windows structure!                     *
//          x,y     = x and y cords inside window            *
//          pMessage= default text string                    *
//   Out  : Base address of gadget (or NULL)                 *
//                                                           *
//************************************************************/

tGadget *AddText (tWindow *pWindow, int16 x, int16 y,char *pMessage)
{
	uint8		*tmp;
	tGadget	*pGadget;
	tGadget	*gadget;
	int32		xs,ys;

	if (pWindow==NULL) return NULL;				// Window opened?
	tmp=(uint8 *) MyMalloc(sizeof(tGadget)+WIN_Len(pMessage)+2);		// first allocate memory+string space
	if (tmp==NULL) return NULL;					// space for gadget?

	pGadget=(tGadget *) tmp;						// get base of new memory
	
	ys=pWindow->pFont->ysize;

	pGadget->PenColour=pWindow->PenColour;
	pGadget->x=x;
	pGadget->y=y;
	pGadget->xsize=GetTextLen(pWindow,pMessage);
	pGadget->ysize=ys;									// font height+border space
	pGadget->maxxsize=WIN_Len(pMessage);					// max size of string
	pGadget->maxysize=0;
	pGadget->type=TEXT;
	pGadget->flags=gACTIVE|gDRAWN|gREFRESH;		// set gadget as active AND drawn!
	pGadget->value=0;										// by defualt its off!
 	pGadget->pNextGadget=NULL;
 	pGadget->pMessage=tmp+sizeof(tGadget);			// point to string
	strcpy (pGadget->pMessage,pMessage);			// copy message
	

	pGadget->misc[0]=0;									// char to start printing at
	pGadget->misc[1]=0;									// current insert point

	AddGadget(pWindow,pGadget);
	return pGadget;
}

//************************************************************
//                                                           *
//   Name    : AddTextButton                                 *
//   Function: Add a TEXT button into the window gadget list *
//                                                           *
//   In   : pWindow = windows structure!                     *
//          x,y     = x and y cords inside window            *
//          xs,ys   = x and y sizes                          *
//          pMessage= default text string                    *
//   Out  : Base address of gadget (or NULL)                 *
//                                                           *
//************************************************************/

tGadget *AddTextButton (tWindow *pWindow, int16 x, int16 y,
								int16 xs,int16 ys,  char *pMessage)
{
	uint8		*tmp;
	tGadget	*pGadget;
	tGadget	*gadget;

	if (pWindow==NULL) return NULL;				// Window opened?
	tmp=(uint8 *) MyMalloc(sizeof(tGadget)+WIN_Len(pMessage)+2);		// first allocate memory+string space
	if (tmp==NULL) return NULL;					// space for gadget?

	pGadget=(tGadget *) tmp;						// get base of new memory
	
	pGadget->PenColour=pWindow->PenColour;
	pGadget->x=x;
	pGadget->y=y;
	pGadget->xsize=xs;
	pGadget->ysize=ys;									// font height+border space
	pGadget->maxxsize=WIN_Len(pMessage);					// max size of string
	pGadget->maxysize=0;
	pGadget->type=TEXTBUTTON;
	pGadget->flags=gACTIVE|gDRAWN|gREFRESH;		// set gadget as active AND drawn!
	pGadget->value=0;										// by defualt its UP!
 	pGadget->pNextGadget=NULL;
 	pGadget->pMessage=tmp+sizeof(tGadget);			// point to string
	strcpy (pGadget->pMessage,pMessage);			// copy message
	

	pGadget->misc[0]=0;									// char to start printing at
	pGadget->misc[1]=0;									// current insert point

	AddGadget(pWindow,pGadget);
	return pGadget;
}



//************************************************************
//                                                           *
//   Name    : EndEdit                                       *
//   Function: Stop editing                                  *
//                                                           *
//   In   : pGadget = gadget to edit                         *
//   Out  : none                                             *
//                                                           *
//************************************************************

void EndEdit ( void )
{
	int16	i;


	if (EditMode==0)  return;

	i=pEdGadget->misc[1];		// get current insert point;
	EditMode=0;							// end editing
	pEdGadget->pMessage[i]=0x0;		// wipe cursor
	pEdGadget->flags|=gREFRESH;		// flag gadget for refreshing
	pEdGadget=NULL;
}


//************************************************************
//                                                           *
//   Name    : ProcessEdit                                   *
//   Function: Edit a string contained in a gadget (pMessage)*
//                                                           *
//   In   : pGadget = gadget to edit                         *
//   Out  : none                                             *
//                                                           *
//                                                           *
//************************************************************

void ProcessEdit( void )
{
	int16	i,i2;
	tGadget	*pGadget;


	pGadget=pEdGadget;		// I just like using pGadget instead of pEdGadget! 
	if (pGadget==0x0) return;											// not in edit mode

	
	if ((pGadget->flags&gREFRESH)!=0) {			// if something ELSE has changed
		EndEdit();										// gadget then stop editing.
		return;
	}
			 
	if (EditMode==0)  return;
	if (key==0x0) 		return;												// nothing changed

	i=pGadget->misc[1];		// get current insert point;

	if (key==13) {
		EditMode=0;			// end editing
		pGadget->pMessage[i]=0x0;
		pGadget->flags|=gREFRESH;
		return;
	}

	// actual edit. Delete first
	if (key==0x8) {
		if (i==0) return;
		i--;
		pGadget->pMessage[i]=CURSOR;
		pGadget->pMessage[i+1]=0x0;
		pGadget->misc[1]=i;		// get current insert point;
		pGadget->flags|=gREFRESH;
	} else {

		if ((WIN_Len(pGadget->pMessage)-1)>=pGadget->maxxsize) return;	// cant insert any more
		if ( (key >=128) ) return;

		if (pGadget->type==INTEGER) 
				if ((key<'0') OR (key>'9'))
					return;

		pGadget->pMessage[i]=key;
		pGadget->pMessage[i+1]=CURSOR;
		pGadget->pMessage[i+2]=0x0;
		i++;
		pGadget->misc[1]=i;		// Set current insert point;
	
		pGadget->flags|=gREFRESH;
	}


}


//************************************************************
//                                                           *
//   Name    : ProcessInterface                              *
//   Function: Check all mouse clicks to all windows,        *
//             and gadgets inside windows                    *
//                                                           *
//************************************************************
void ProcessInterface ( char currentkey, int16 mx, int16 my, int16 mbut )
{
	int16	r;
	tWindow	*pWind;

	mousex=mx;
	mousey=my;
	mousebut=mbut;

	key=currentkey;
	ProcessEdit();								// if currently editing, carry on!
						
	if (EnableMouse==FALSE) return;		// no mouse, no point!


	if (but!=2){
		if (MenuLast==1) {						// menu WAS printed last frame
			if (pSelected!=NULL){
				pMenuWindow->flags|=wMENU;				// menu has been selected
				pMenuWindow->MenuID=pSelected->ID;	// copy Menu item ID
			}
			RefreshWindow (pMenuWindow);		// refresh window to erase menu
			MenuLast=0;
			pMenuWindow=NULL;
		}
	}

	if (mousebut==0) {
		Lastmx=mousex>>1;							// update mouse last x and y
		Lastmy=mousey;
		lbut=mousebut;
		pButWindow=NULL;						// remove window and gadget lock
		pButGadget=NULL;
		return;									// No click, no change!
	}


	if (pButWindow!=0) { 
		r=ProcessWindow (pButWindow,BWxoff,BWyoff,1);			// move backwards!
	} else {
		r=ProcessWindow (pLastWindow,0,0,0);			// move backwards!
	}

	Lastmx=mousex>>1;				// update mouse last x and y
	Lastmy=mousey;
	lbut=mousebut;
}

//************************************************************
//                                                           *
//   Name    : LinkMenu                                      *
//   Function: Link a menu structure into a window or        *
//             a master menu item                            *
//                                                           *
//   In   : pWindow = window to link into                    *
//          pMasterMenu = Master menu item (or NULL)         *
//          pMenu = menu to link in                          *
//   Out  : none                                             *
//                                                           *
//                                                           *
//************************************************************

void	LinkMenu (tWindow *pWindow,tMenu *pMasterMenu,tMenu *pMenu)
{
	tMenu	*pM;

	//
	// first try and link with a parent menu.
	//
	if (pMasterMenu!=0){
		pM=pMasterMenu->pChildMenu;
		if (pM==NULL){
			pMasterMenu->pChildMenu=pMenu;
			return;									// add menu then exit
		} else {
			while (pM!=NULL){
				if (pM->pNextItem==NULL){
					pM->pNextItem=pMenu;
					return;							// add menu then exit
				}
				pM=pM->pNextItem;
			}
		}
	}


	//
	// else link into windows master menu item
	//

	pM=pWindow->pFirstMenu;
	if (pM==NULL){
		pWindow->pFirstMenu=pMenu;			// first menu IN window!
		return;									// add menu then exit
	} else {
		while (pM!=NULL){
			if (pM->pNextItem==NULL){
				pM->pNextItem=pMenu;
				return;							// add menu then exit
			}
			pM=pM->pNextItem;
		}
	}
}

//************************************************************
//                                                           *
//   Name    : AddMenuItem                                   *
//   Function: Adds a menu item to a window                  *
//                                                           *
//   In   : pWindow = window to attach to                    *
//          pMasterMenu = if its a sub menu (else NULL)      *
//          pMessage= text menu should print                 *
//   Out  : tMenu * = pointer do new menu struct             *
//                                                           *
//                                                           *
//************************************************************

tMenu	*AddMenuItem (tWindow *pWindow ,tMenu *pMasterMenu, char *pMessage, uint32 ID)
{
	uint8		*tmp;
	tMenu		*pMenu;


	if (pWindow==NULL) return NULL;				// Window opened?
	tmp=(uint8 *) MyMalloc(sizeof(tMenu));
	if (tmp==NULL) return NULL;					// space for menu item?

	pMenu=(tMenu *) tmp;						// get base of new memory


	pMenu->Options=0;
	pMenu->flags=0;
 	pMenu->pMessage=pMessage;							// simply POINT to the string
 	pMenu->pChildMenu=NULL;
 	pMenu->ID=ID;
 	pMenu->pNextItem=NULL;


	LinkMenu (pWindow,pMasterMenu,pMenu);
	return pMenu;
}

//************************************************************
//                                                           *
//   Name    : LimitWindow                                   *
//   Function: Limits the max/min dragdrop of a window to    *
//             a certain area of the screen as defined by    *
//             another window OR the workbench screen.       *
//                                                           *
//   In   : pWB=Workbench screen (NULL=use WB screen)        *
//          pWindow = Window to limit                        *
//   Out  : none                                             *
//                                                           *
//************************************************************

void LimitWindow (tWindow *pWB, tWindow *pWindow)
{
	if (pWB==NULL) {
		pWB=pDefaultWindow;
	}
	pWindow->minx=0;
	pWindow->miny=0;
	pWindow->maxx=pWB->maxxsize-pWindow->xsize;
	pWindow->maxy=pWB->maxysize-pWindow->ysize;
}

void SetWindowLimits (tWindow *pWindow,int16 x,int16 y,int16 x2,int16 y2)
{
	if (pWindow==NULL) return;
	pWindow->minx=x;
	pWindow->miny=y;
	pWindow->maxx=x2;
	pWindow->maxy=y2;
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//                                                           *
//************************************************************

tWindow *MessageBox (tWindow *pWindow, int16 x,int16 y,char *pMessage)
{
	tWindow	*pWB;
	tWindow	*Wind;
 	int32		size;


	if (pWindow!=NULL) {
		pWB=pWindow;
	} else {
		pWB=pDefaultWindow;
	}

	size=GetTextLen(pWB,pMessage);
	Wind=OpenWindow (pWindow,x,y,size+10,pWB->pFont->ysize+BARYSIZE+10);
	if (Wind==NULL) return Wind;

	LimitWindow (pWB,Wind);
 
	Wind->WindowColour=Wind->DrawCols[MGRAY];
	Wind->Options&=~(BORDERS);
	Wind->clipx1=0;
	Wind->clipy1=BARYSIZE;
	Wind->clipx2=Wind->xsize;
	Wind->clipy2=Wind->ysize;
	RefreshWindow (Wind);						// window needs redrawn.
	
		DrawCols[0]=Wind->DrawCols[0];		// copy current colours
		DrawCols[1]=Wind->DrawCols[1];					
		DrawCols[2]=Wind->DrawCols[2];					
		DrawCols[3]=Wind->DrawCols[3];					
		DrawCols[4]=Wind->DrawCols[4];					
 
	DrawButtonUp (Wind,0,BARYSIZE-1,Wind->xsize-1,Wind->ysize-1);
	AddText (Wind,5,BARYSIZE+5,pMessage);
 	return (Wind);
}
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void ShutDownWindows( void )
{
	tWindow *pWindow,*pW;

	pWindow=pFirstWindow;
	while(pWindow!=NULL){
		pW=pWindow->pNextWindow;
		CloseWindow (pWindow);			// Close window and ALL gadgets!
		pWindow=pW;
	}
}
